"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _jquery = _interopRequireDefault(require("jquery"));

var _mustache = _interopRequireDefault(require("mustache"));

var _moment = _interopRequireDefault(require("moment"));

var _interfaces = _interopRequireDefault(require("./interfaces"));

var _machines = _interopRequireDefault(require("./machines"));

var credentials = _interopRequireWildcard(require("./credentials"));

var ipfuncs = _interopRequireWildcard(require("./iputils"));

var _jqmeter = _interopRequireDefault(require("./jqmeter"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//import cockpit from "cockpit";
function asserts_init() {
  console.log("asserts_init");
  /* Handles an href link to a server */

  (0, _jquery["default"])(document).on("click", "tr[class='unit-tr-row']", function (ev) {
    if (ev.target.localName === "button") {
      return;
    }

    cockpit.jump("/", (0, _jquery["default"])(this).attr("data-address"));
    ev.preventDefault();
    return false;
  });
  var units_template = (0, _jquery["default"])("#services-units-tmpl").html();

  _mustache["default"].parse(units_template);

  var groups_template = (0, _jquery["default"])("#groups-units-tmpl").html();

  _mustache["default"].parse(groups_template);

  var empty_template = (0, _jquery["default"])("#service-empty-tmpl").html();

  _mustache["default"].parse(empty_template);

  var setting_template = (0, _jquery["default"])("#setting-tmpl").html();

  _mustache["default"].parse(setting_template);

  var asserts_detail_template = (0, _jquery["default"])("#service-template-tmpl").html();

  _mustache["default"].parse(asserts_detail_template);

  var groups_detail_template = (0, _jquery["default"])("#group-template-tmpl").html();

  _mustache["default"].parse(groups_detail_template);

  var intv = 0;
  var g_asserts_bak = [];
  var g_groups_bak = [];

  var g_machines = _machines["default"].instance();

  var g_authkeys = credentials.keys_instance();
  (0, _jquery["default"])(g_authkeys).on("changed", update_available); // 自动发现资产的扫描计数

  var g_snip_finished = 0; // 自动发现资产时获取到的资产的信息

  var g_find_assert_info = {}; // 分页界面的相关变量放在这做成全局变量

  var g_vue_pagination;
  var g_cur_page_asserts = 1;
  var g_cur_page_groups = 1;
  var g_page_size = 20;

  function processPagination(units) {
    // 分页展示
    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-app-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);

            if (window.location.href.indexOf("#/groups") > 0) {
              // group page
              show_groups_page(g_groups_bak);
              registerGroupsEvent();
            } else {
              // rules page
              show_asserts_page(g_asserts_bak);
              registerAssertsEvent();
            }
          },
          handleCurrentChange: function handleCurrentChange(val) {
            if (window.location.href.indexOf("#/groups") > 0) {
              g_cur_page_groups = val;
              console.log("set g_cur_page_groups to:", val);
              show_groups_page(g_groups_bak);
              registerGroupsEvent();
            } else {
              g_cur_page_asserts = val;
              console.log("set g_cur_page_asserts to:", val);
              show_asserts_page(g_asserts_bak);
              registerAssertsEvent();
            }
          }
        },
        data: {
          current_page: g_cur_page_asserts,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      if (window.location.href.indexOf("#/groups") > 0) {
        g_vue_pagination.current_page = g_cur_page_groups;
      } else {
        g_vue_pagination.current_page = g_cur_page_asserts;
      }

      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    }

    if (window.location.href.indexOf("#/groups") > 0) {
      units = units.slice((g_cur_page_groups - 1) * g_page_size, g_cur_page_groups * g_page_size);
    } else {
      units = units.slice((g_cur_page_asserts - 1) * g_page_size, g_cur_page_asserts * g_page_size);
    }

    return units;
  }

  function getUnitById(assertid) {
    var unit = [];

    for (var i = 0; i < g_asserts_bak.length; i++) {
      if (g_asserts_bak[i].assertid == assertid) {
        unit = g_asserts_bak[i];
      }
    }

    if (!unit) {
      console.log("can not find unit,record id:", id);
    }

    return unit;
  }

  function updateAssertDesc(id, desc) {
    for (var i = 0; i < g_asserts_bak.length; i++) {
      if (g_asserts_bak[i].uuid == id) {
        g_asserts_bak[i].desc = desc;
      }
    }
  }

  function try_to_connect(address, options) {
    var dfd = _jquery["default"].Deferred();

    var conn_options = _jquery["default"].extend({
      "payload": "echo",
      "host": address
    }, options);

    var machine = g_machines.lookup(address);

    if (machine && machine.host_key && !machine.on_disk) {
      conn_options['temp-session'] = false;
      /* Compatiblity option */

      conn_options['session'] = 'shared';
      conn_options['host-key'] = machine.host_key;
    }

    var client = cockpit.channel(conn_options);
    client.send("x");
    (0, _jquery["default"])(client).on("message", function () {
      (0, _jquery["default"])(client).off();
      client.close();
      dfd.resolve();
    }).on("close", function (event, options) {
      dfd.reject(options);
    });
    return dfd.promise();
  }

  ;

  function doAddAssert() {
    var ip = (0, _jquery["default"])("#add-server-ip").val();
    var name = (0, _jquery["default"])("#add-server-name").val();
    var user = (0, _jquery["default"])("#add-server-user").val();
    var type = (0, _jquery["default"])("#add-server-type").children("option:selected").val();
    var options = {
      "user": user
    };
    var reg = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/;

    if (!reg.test(ip)) {
      return (0, _jquery["default"])("#add-server-msg").text(_("Please enter legitimate IP address. E.g.: 192.168.0.1"));
    }

    if (!name || name.length < 1 || name.length > 40) {
      return (0, _jquery["default"])("#add-server-msg").text(_("Please enter legitimate name, 1-40 characstics. English, Chinese, number or . - _ only."));
    }

    var rename = /[-\.\_a-zA-Z0-9\u4e00-\u9fa5]/;

    for (var i = 0; i < name.length; i++) {
      if (!rename.test(name[i])) {
        return (0, _jquery["default"])("#add-server-msg").text(_("Please enter legitimate name, 1-40 characstics. English, Chinese, number or . - _ only."));
      }
    }

    if (g_authkeys.items.length < 1) {
      return (0, _jquery["default"])("#add-server-msg").text(_("Management Server does not have credentials. Please generate credential first."));
    }

    var authkeydata = "";

    for (var id in g_authkeys.items) {
      var key = g_authkeys.items[id]; // 取第一个即可

      authkeydata = key.data;

      if (authkeydata.length > 0) {
        break;
      }
    }

    if (type === "0") {
      // 使用密码登录
      var password = (0, _jquery["default"])("#add-server-pass").val();
      options["password"] = password;
      options["session"] = 'shared'; //'private'

      options["temp-session"] = false;
    } else {
      // 使用证书登录
      var credit = (0, _jquery["default"])("#credit-identifier").children("option:selected").text();

      if (!credit) {
        return (0, _jquery["default"])("#add-server-msg").text(_("Please select a credential."));
      }
    }

    function realAddHost() {
      // 用户的主目录，需要执行命令去获取
      var home = "";

      function getAssertInfo() {
        // 还需要获取资产的标签和指纹信息
        var cmd = ["cat", "/etc/machine-id", "/etc/.kyinfo"];
        cockpit.spawn(cmd, {
          host: ip
        }).then(function (res) {
          console.log("exec cmd:", cmd, " res:", res);
          var arr = res.split("\n");

          if (arr.length < 2) {
            return (0, _jquery["default"])("#add-server-msg").text(_("Get assert's version and fingerprints failed."));
          }

          var finger = arr[0].trim();

          if (finger.length != 32) {
            return (0, _jquery["default"])("#add-server-msg").text(_("Get fingerprints failed."));
          }

          var tag = "";

          for (var _i = 1; _i < arr.length; _i++) {
            if (arr[_i].startsWith("milestone") && arr[_i].indexOf(" = 3.4-") > 0) {
              tag = "3.4";
            }

            if (arr[_i].startsWith("milestone") && arr[_i].indexOf(" = 3.3-") > 0) {
              tag = "3.3";
            }

            if (arr[_i].startsWith("milestone") && arr[_i].indexOf(" = 3.2-") > 0) {
              tag = "3.2";
            }
          }

          if (tag.length < 1) {
            return (0, _jquery["default"])("#add-server-msg").text(_("Get version tag information failed."));
          }

          var http = cockpit.http({
            "port": 9091
          });
          http.post("/addAssert", {
            "ip": ip,
            "name": name,
            "finger": finger,
            "tag": tag,
            "user": user
          }).done(function (res) {
            console.log("addAssert res:", res);

            var info = _jquery["default"].parseJSON(res);

            if (!info.succeed) {
              return (0, _jquery["default"])("#add-server-msg").text(_("Add assert failed: ") + info.error);
            }

            (0, _jquery["default"])("#add-server-msg").text(_("Add assert succeed!"));
            setTimeout(function (e) {
              (0, _jquery["default"])("#add-server-close").click();
              render_asserts_real();
            }, 1000);
          }).fail(function (err) {
            console.log(err);
            (0, _jquery["default"])("#add-server-msg").text(_("Add assert failed"));
          });
        })["catch"](function (err) {
          console.log(err);
          return (0, _jquery["default"])("#add-server-msg").text(_("Get assert's version and fingerprints failed."));
        });
      }

      function writeAuthToFile(rawcontent) {
        authkeydata = authkeydata.replace("\n", "").replace("\r", "");
        var towrite = "";

        if (!rawcontent || rawcontent.length < 1) {
          towrite = authkeydata;
        } else if (rawcontent.indexOf(authkeydata) >= 0) {
          towrite = rawcontent;
        } else {
          towrite = rawcontent + '\n' + authkeydata;
        }

        var authfile = home + "/.ssh/authorized_keys";
        var file = cockpit.file(authfile, {
          "host": ip
        });
        file.replace(towrite).then(function (tag) {
          console.log("上传证书到资产成功，tag:", tag);
          getAssertInfo();
        })["catch"](function (error) {
          return (0, _jquery["default"])("#add-server-msg").text(_("Upload credential failed."));
        });
      } // 到此已经添加到资产列表，还需要将管理服务器的证书上传到资产


      function uploadAuth() {
        var cmd = "mkdir -p $HOME/.ssh && echo $HOME";
        cockpit.script(cmd, {
          host: ip
        }).then(function (res) {
          home = res.replace("\n", "").replace("\r", "");
          var authfile = home + "/.ssh/authorized_keys";
          var file = cockpit.file(authfile, {
            "host": ip
          });
          file.read().then(function (content, tag) {
            console.log("assert authfile:", authfile, " rawcontent:", content, " tag:", tag);
            writeAuthToFile(content);
          })["catch"](function (err) {
            console.log("assert authfile donot exist:", authfile);
            writeAuthToFile("");
          });
        })["catch"](function (err) {
          console.log(err);
          return (0, _jquery["default"])("#add-server-msg").text(_("Create directory failed while uploading credential."));
        });
      }

      if (g_machines.lookup(ip)) {
        g_machines.change(ip, options);
      }

      g_machines.add(user + "@" + ip, options); // 调用add接口后需要再次运行 try_to_connect 才能真正生效

      try_to_connect(ip, options).fail(function (ex) {
        return (0, _jquery["default"])("#add-server-msg").text(_("Add assert to SCMMS failed."));
      }).done(function (res) {
        return uploadAuth();
      });
    } // 先尝试连接，看是否能够成功


    try_to_connect(ip, options).fail(function (ex) {
      console.log(ex);

      if (ex.problem == "unknown-host") {
        // 首次添加会出现这种情况，没有确认指纹，需要自动确认指纹
        // 需要用 private 选项会列出资产的指纹信息
        // options["session"] = 'private';
        try_to_connect(ip, {
          "session": "private"
        }).fail(function (ex) {
          if (ex.problem !== "unknown-hostkey") {
            // 使用 private 后报错类型是 unknown-hostkey
            console.log(ex);
            return (0, _jquery["default"])("#add-server-msg").text(_("Get fingerprints failed."));
          }

          var hostkey = ex["host-key"];
          var hostfp = ex["host-fingerprint"];
          console.log("auto add host footprint,fp:", hostfp, " key:", hostkey); // cockpit 会把证书加到 /etc/ssh/ssh_known_hosts，无效，需要加到 ~/.ssh/known_hosts

          /*g_machines.add_key(hostkey);
          g_machines.change(ip, {
              'host_key': hostkey
          });*/

          hostkey = hostkey.replace("\n", "").replace("\r", "");
          var addauthcmd = ["bash", "/usr/share/cockpit/manager.cmd/addHostKey.sh", user, hostkey];
          cockpit.spawn(addauthcmd).then(function (e) {
            // 尝试连接成功，添加资产到服务器列表
            realAddHost();
          }).fail(function (e) {
            console.log("exec cmd failed,cmd:", addauthcmd);
            return (0, _jquery["default"])("#add-server-msg").text(_("Connect to assert failed. Add assert to knwon_hosts failed."));
          });
        }).done(function (res) {// 异常情况，上次失败，这次不会成功
        });
        return;
      }

      if (ex.problem == "no-host") {
        return (0, _jquery["default"])("#add-server-msg").text(_("Connect to assert failed. Make sure ssh is opening."));
      }

      if (ex.problem == "access-denied" || ex.problem == "authentication-failed") {
        return (0, _jquery["default"])("#add-server-msg").text(_("Connection refuesd. Make sure authentication is valid."));
      }

      return (0, _jquery["default"])("#add-server-msg").text(_("Add assert failed. Unknown error."));
    }).done(function (e) {
      realAddHost();
    }).always(function (e) {});
  }

  function registerAssertsEvent() {
    (0, _jquery["default"])("#services-dropdown").change(function (e) {
      show_asserts_page(g_asserts_bak);
      registerAssertsEvent();
    });
    (0, _jquery["default"])("#services-text-filter").change(function (e) {
      show_asserts_page(g_asserts_bak);
      registerAssertsEvent();
    }); // 资产详情

    /*$("tr.unit-tr-row").unbind("click").click(function(e) {
        let id = $(this).data("goto-unit");
        // assert detail dialog
    });*/

    (0, _jquery["default"])("#clear-all-filters").unbind("click").click(function (e) {
      (0, _jquery["default"])("#services-text-filter").val("");
      show_asserts_page(g_asserts_bak);
      registerAssertsEvent();
    });
    (0, _jquery["default"])("#add-server").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add-server-ip").val("");
      (0, _jquery["default"])("#add-server-name").val("");
      (0, _jquery["default"])("#add-server-user").val("root"); // 目前绑定特权用户root, 不允许更改

      (0, _jquery["default"])("#add-server-user").attr("disabled", true);
      (0, _jquery["default"])("#add-server-pass").val("");
      (0, _jquery["default"])("#add-server-msg").text("");
    }); // add server dialog

    function onTypeChange() {
      var value = (0, _jquery["default"])("#add-server-type").children("option:selected").val();

      if (value == "0") {
        (0, _jquery["default"])("#pass-area").show();
        (0, _jquery["default"])("#credit-area").hide();
      } else {
        update_available();
        (0, _jquery["default"])("#pass-area").hide();
        (0, _jquery["default"])("#credit-area").show();
      }
    }

    (0, _jquery["default"])("#add-server-type").change(function (e) {
      onTypeChange();
    });
    onTypeChange();
    (0, _jquery["default"])("#add-server-confirm").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add-server-msg").text(_("Adding..."));
      doAddAssert();
    }); // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件

    (0, _jquery["default"])(".assert-opr-more").unbind("click").on("click", function (e) {
      var top = (0, _jquery["default"])(this).offset().top;
      var left = (0, _jquery["default"])(this).offset().left;
      var top1 = (0, _jquery["default"])("html").scrollTop();
      top = top - top1;
      var width = parseInt((0, _jquery["default"])(this).css("width").replace("px", ""));
      (0, _jquery["default"])(".assert-popup-menu").css("top", top); //let bodywidth = parseInt($("body#services-page").css("width").replace("px", ""));
      //let menuwidth = parseInt($(".assert-popup-menu").css("width").replace("px", ""));
      // 如果向右展示超出了窗口宽度，就向左展示
      //if (left + width + menuwidth <= bodywidth) {

      (0, _jquery["default"])(".assert-popup-menu").css("left", left + width); //} else {
      //    $(".assert-popup-menu").css("left", left - menuwidth);
      //}

      if ((0, _jquery["default"])(".assert-popup-menu").css("display") == "none") {
        (0, _jquery["default"])(".assert-popup-menu").css("display", "inline-grid");
      } else {
        (0, _jquery["default"])(".assert-popup-menu").css("display", "none");
      }

      var assertid = (0, _jquery["default"])(this).data("assert-id");
      (0, _jquery["default"])("#assert-popup-menu-private-data").data("private-data", assertid);
    });
    (0, _jquery["default"])(".assert-popup-btn").mouseover(function (e) {
      (0, _jquery["default"])(this).css("background-color", "#def3ff");
    }).mouseout(function (e) {
      (0, _jquery["default"])(this).css("background-color", "white");
    });
    (0, _jquery["default"])(window).unbind("click").on("click", function (e) {
      if (e.target.localName == "button" && (e.target.className.indexOf("assert-opr-more") >= 0 || e.target.className.indexOf("assert-delete") >= 0 || e.target.className.indexOf("assert-status") >= 0)) {
        return;
      }

      (0, _jquery["default"])(".assert-popup-menu").css("display", "none");
    });
    (0, _jquery["default"])("button.assert-status").unbind("click").click(function (e) {
      (0, _jquery["default"])("#assert-rules-msg").text("");
      (0, _jquery["default"])("#assert-rules-content").html(""); // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid

      var assertid = (0, _jquery["default"])("#assert-popup-menu-private-data").data("private-data");
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getAssertRules", {
        "id": assertid
      }).done(function (res) {
        console.log("getAssertRules res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#assert-rules-msg").text(_("Get rules info failed: ") + info.error);
        }

        info = info.data;

        if (info.length < 1) {
          (0, _jquery["default"])("#assert-rules-msg").text(_("No rules on this assert"));
          return;
        }

        for (var i = 0; i < info.length; i++) {
          var statustext = "";

          try {
            var applycount = _jquery["default"].parseJSON(info[i].applycount);

            if (!applycount[assertid]) {
              // 没有下发记录，不成功也不失败，下发中
              statustext = _("Downloading");
            } // 如果 applycount < editcount 则也是 尚未下发
            else if (applycount[assertid]["applycount"] >= info[i].editcount && applycount[assertid]["result"] == "succeed") {
                statustext = _("Succeed");
              } else if (applycount[assertid]["result"] == "succeed") {
                statustext = _("Waiting");
              } else {
                statustext = _("Failed ");
              }
          } catch (e) {
            // json 格式异常，没有下发结果，表示是初始状态，为 下发中
            statustext = _("Downloading");
            console.log(e);
          }

          var tr = "<tr><td class='text-align-left'>" + info[i].name + "</td><td>" + info[i].straname + "</td><td>" + info[i].strafrom + "</td><td><span class=''>" + statustext + "</span></td></tr>";
          (0, _jquery["default"])("#assert-rules-content").append((0, _jquery["default"])(tr));
        }
      }).fail(function (err) {
        console.log(err);
        (0, _jquery["default"])("#assert-rules-msg").text(_("Get rules info failed"));
      });
    }); // delete assert

    (0, _jquery["default"])("button.assert-delete.assert-popup-btn").unbind("click").click(function (e) {
      var id = (0, _jquery["default"])("#assert-popup-menu-private-data").data("private-data");
      console.log("delete-assert-btn clicked, recore id:" + id);
      var unit = getUnitById(id);
      (0, _jquery["default"])("#confirm-operate-msg").text(_("Are you sure delete assert ") + unit.assertname + "?");
      (0, _jquery["default"])("#confirm-operate-confirm").unbind("click").click(function (e) {
        if (unit.assertip == "localhost") {
          return (0, _jquery["default"])("#confirm-operate-msg").text(_("Localhost cannot delete"));
        } // 到此已经添加到资产列表，还需要添加到数据库


        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delAssert", {
          "id": id
        }).done(function (res) {
          console.log("delAssert res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            return (0, _jquery["default"])("#confirm-operate-msg").text("删除资产记录失败：" + info.error);
          }

          var machine = g_machines.lookup(unit.assertip);
          if (machine) g_machines.change(machine.key, {
            visible: false
          });
          (0, _jquery["default"])("#confirm-operate-msg").text("删除资产成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#confirm-operate-close").click();
            render_asserts_real();
          }, 1000);
        }).fail(function (err) {
          console.log(err);
          (0, _jquery["default"])("#confirm-operate-msg").text("删除资产记录失败");
        });
      });
    }); // 资产自动发现

    (0, _jquery["default"])("#find-server").unbind("click").click(function (e) {
      //let iplist = ipfuncs.default.listIPByRange("1.2.3.4", "1.2.3.99");
      //iplist = ipfuncs.default.listIPByNetwork("1.2.3.3", 31);
      (0, _jquery["default"])("#find-msg").text("");
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getFindConfig").done(function (res) {
        //console.log("getFindConfig res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          (0, _jquery["default"])("#find-msg").text("获取配置失败，请稍后重试");
          setTimeout(function (e) {
            (0, _jquery["default"])("#find-close").click();
          }, 2000);
        }

        if (info.data && info.data.enabled) {
          (0, _jquery["default"])("#setting-check-input").attr("checked", true);
        } else {
          (0, _jquery["default"])("#setting-check-input").attr("checked", false);
        }

        if (info.data && info.data.iprange) {
          (0, _jquery["default"])("#find-ip-range").val(info.data.iprange);
        }
      }).fail(function (err) {
        console.log(err);
        (0, _jquery["default"])("#find-msg").text("获取配置失败，请稍后重试");
        setTimeout(function (e) {
          (0, _jquery["default"])("#find-close").click();
        }, 2000);
      });
    });

    function updateProgress(raised, goal) {
      (0, _jquery["default"])("#jqmeter-container").html("");

      _jqmeter["default"].jQMeter_func('#jqmeter-container', {
        "goal": goal.toString(),
        "raised": raised.toString()
      });
    }

    function addScanResult(ip, state, allipcnt, hostdata) {
      //g_snip_finished = g_snip_finished + 1;
      if (state == "failed") {
        var tr = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class=''>扫描失败</td></tr>";
        (0, _jquery["default"])("#find-result-content").append(tr);
        g_snip_finished = g_snip_finished + 1;
        return updateProgress(g_snip_finished, allipcnt);
      }

      function succeedConnectOpr() {
        // 扫描成功后的操作
        // 获取资产的名称、版本、指纹信息
        if (!hostdata.machineid || hostdata.machineid.length < 1 || !hostdata.hostname || hostdata.hostname.length < 1 || !hostdata.kyinfo || hostdata.kyinfo.length < 1) {
          console.log("获取资产信息失败", hostdata);

          var _tr = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>处理资产信息失败</td></tr>";

          (0, _jquery["default"])("#find-result-content").append(_tr);
          g_snip_finished = g_snip_finished + 1;
          return updateProgress(g_snip_finished, allipcnt);
        }

        var finger = hostdata.machineid[0].replace("\n", "").replace("\r", "");
        var hostname = hostdata.hostname[0].replace("\n", "").replace("\r", "");
        var tag = "";
        var arr = hostdata.kyinfo;

        for (var i = 0; i < arr.length; i++) {
          if (arr[i].startsWith("milestone") && arr[i].indexOf(" = 3.4-") > 0) {
            tag = "3.4";
          }

          if (arr[i].startsWith("milestone") && arr[i].indexOf(" = 3.3-") > 0) {
            tag = "3.3";
          }

          if (arr[i].startsWith("milestone") && arr[i].indexOf(" = 3.2-") > 0) {
            tag = "3.2";
          }
        }

        if (tag.length < 1) {
          console.log(ip, "get assert version tag failed", err);

          var _tr2 = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>获取资产标签失败</td></tr>";

          (0, _jquery["default"])("#find-result-content").append(_tr2);
          g_snip_finished = g_snip_finished + 1;
          return updateProgress(g_snip_finished, allipcnt);
        }

        g_find_assert_info[ip] = {
          "finger": finger,
          "hostname": hostname,
          "tag": tag
        };
        var assertadded = false;

        for (var _i2 = 0; _i2 < g_asserts_bak.length; _i2++) {
          if (finger == g_asserts_bak[_i2].assertid) {
            assertadded = true;
            break;
          }
        }

        var tr = "<tr><td class='text-align-left'>" + ip + "</td><td>" + hostname + "</td><td><span class='add-find-assert fa fa-plus-square-o' data-assert-ip='" + ip + "'></span></td></tr>";

        if (assertadded) {
          tr = "<tr><td class='text-align-left'>" + ip + "</td><td>" + hostname + "</td><td><span class='added-find-assert' data-assert-ip='" + ip + "'>已添加</span></td></tr>";
        }

        (0, _jquery["default"])("#find-result-content").append(tr);
        g_snip_finished = g_snip_finished + 1;
        updateProgress(g_snip_finished, allipcnt);
        (0, _jquery["default"])("span.add-find-assert").unbind("click").click(function (e) {
          var spanele = (0, _jquery["default"])(this);
          var assert_ip = (0, _jquery["default"])(this).data("assert-ip");
          spanele.removeClass("fa");
          spanele.removeClass("fa-plus-square-o");
          spanele.removeClass("add-find-assert");
          spanele.text("添加中");

          if (g_machines.lookup(assert_ip)) {
            g_machines.change(assert_ip, {
              "user": "cockpit-client"
            });
          }

          g_machines.add("cockpit-client@" + assert_ip, {
            "user": "cockpit-client"
          }); // 调用add接口后需要再次运行 try_to_connect 才能真正生效

          try_to_connect(assert_ip, {
            "user": "cockpit-client"
          }).fail(function (ex) {
            console.log("add assert failed:", ex);
            var machine = g_machines.lookup(assert_ip);
            if (machine) g_machines.change(machine.key, {
              visible: false
            });
          }).done(function (res) {
            var http = cockpit.http({
              "port": 9091
            });
            http.post("/addAssert", {
              "ip": assert_ip,
              "name": g_find_assert_info[assert_ip]["hostname"],
              "finger": g_find_assert_info[assert_ip]["finger"],
              "tag": g_find_assert_info[assert_ip]["tag"],
              "user": "cockpit-client"
            }).done(function (res) {
              //console.log("addAssert res:", res);
              var info = _jquery["default"].parseJSON(res);

              if (!info.succeed) {
                return; //console.log("add assert failed, return:", res)
              }

              spanele.attr("class", "added-find-assert").text("已添加");
            }).fail(function (err) {
              console.log("add assert failed, err:", err);
              var machine = g_machines.lookup(assert_ip);
              if (machine) g_machines.change(machine.key, {
                visible: false
              });
            });
          });
        });
      } // succeed


      try_to_connect(ip, {
        "user": "cockpit-client" // 这时，证书已经上传，使用内置证书登录，不需要使用密码，option 不要提供任何参数

      }).fail(function (ex) {
        // unknown-host 表示没有添加指纹的情况
        if (ex.error != "unknown-host" && ex.error != "unknown-hostkey") {
          console.log(ip, "connect to assert failed, err:", ex);

          var _tr3 = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>连接失败</td></tr>";

          (0, _jquery["default"])("#find-result-content").append(_tr3);
          g_snip_finished = g_snip_finished + 1;
          updateProgress(g_snip_finished, allipcnt);
          return;
        } // 首次添加会出现这种情况，没有确认指纹，需要自动确认指纹
        // 需要用 private 选项会列出资产的指纹信息


        try_to_connect(ip, {
          "user": "cockpit-client",
          "session": "private"
        }).fail(function (ex) {
          if (ex.problem != "unknown-hostkey") {
            // 使用 private 后报错类型是 unknown-hostkey
            console.log(ip, "connect to assert failed, err:", ex);

            var _tr4 = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>添加指纹时连接失败</td></tr>";

            (0, _jquery["default"])("#find-result-content").append(_tr4);
            g_snip_finished = g_snip_finished + 1;
            updateProgress(g_snip_finished, allipcnt);
            return;
          }

          var hostkey = ex["host-key"];
          var hostfp = ex["host-fingerprint"];
          console.log("auto add host footprint when find,fp:", hostfp, " key:", hostkey);
          hostkey = hostkey.replace("\n", "").replace("\r", "");
          var addauthcmd = ["bash", "/usr/share/cockpit/manager.cmd/addHostKey.sh", "cockpit-client", hostkey];
          cockpit.spawn(addauthcmd).then(function (e) {
            succeedConnectOpr();
          }).fail(function (ex) {
            console.log(ip, "add host key failed, err:", ex);
            var tr = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>添加指纹失败</td></tr>";
            (0, _jquery["default"])("#find-result-content").append(tr);
            g_snip_finished = g_snip_finished + 1;
            updateProgress(g_snip_finished, allipcnt);
            return;
          });
        }).done(function (res) {
          // 异常情况，上次失败，这次不会成功
          console.log(ip, "connect to assert succeed with private option, unnormal !!!");
          var tr = "<tr><td class='text-align-left'>" + ip + "</td><td>----</td><td class='add-find-result-err'>添加指纹时连接失败</td></tr>";
          (0, _jquery["default"])("#find-result-content").append(tr);
          g_snip_finished = g_snip_finished + 1;
          updateProgress(g_snip_finished, allipcnt);
          return;
        });
      }).done(function (e) {
        succeedConnectOpr();
      });
    }

    function doFindWork(allips) {
      var goal = allips.length;
      var raised = 0;

      _jqmeter["default"].jQMeter_func('#jqmeter-container', {
        "goal": goal.toString(),
        "raised": raised.toString()
      });

      (0, _jquery["default"])("#show-find-result").click();
      setTimeout(function (e) {
        // 根据界面交互逻辑，扫描的逻辑做在前台，
        // 同时不影响前台响应，每100ms扫描一次
        if (g_authkeys.items.length < 1) {
          console.log("get auth key failed, stop scan");
          return;
        }

        var authkeydata = "";

        for (var id in g_authkeys.items) {
          var key = g_authkeys.items[id]; // 取第一个即可

          authkeydata = key.data;

          if (authkeydata.length > 0) {
            break;
          }
        }

        var _loop = function _loop(i) {
          //console.log("scan ip:", allips[i]);
          var http = cockpit.http({
            "address": allips[i],
            "port": 9092
          });
          http.post("/uploadCredit", {
            "key": "qazwsxedcrfv",
            "auth": authkeydata
          }).done(function (res) {
            var info = _jquery["default"].parseJSON(res);

            if (!info.succeed || !info.data) {
              //console.log(allips[i], "uploadCredit failed, ", res);
              return addScanResult(allips[i], "failed", allips.length, {});
            }

            console.log(allips[i], "uploadCredit succeed");
            addScanResult(allips[i], "succeed", allips.length, info.data);
          }).fail(function (err) {
            //console.log(allips[i], "scan ip failed, host may not exist", err);
            addScanResult(allips[i], "failed", allips.length, {});
          });
        };

        for (var i = 0; i < allips.length; i++) {
          _loop(i);
        }
      }, 100);
    } // 关闭发现窗口的时候，有可能已经加入了资产，刷新一下资产界面


    (0, _jquery["default"])("#find-close").unbind("click").click(function (e) {
      render_asserts_real();
    }); // 资产自动发现确认

    (0, _jquery["default"])("#find-confirm").unbind("click").click(function (e) {
      (0, _jquery["default"])("#find-msg").text("");
      var enabled = (0, _jquery["default"])("#setting-check-input").prop("checked");

      if (enabled) {
        enabled = 1;
      } else {
        enabled = 0;
      }

      var allips = [];
      var iprange = (0, _jquery["default"])("#find-ip-range").val();
      var iprangearr = iprange.split(";");

      for (var i = 0; i < iprangearr.length; i++) {
        var tmp = iprangearr[i];

        if (tmp.indexOf("-") > 0) {
          var tmparr = tmp.split("-");

          if (tmparr.length < 2) {
            return (0, _jquery["default"])("#find-msg").text("IP范围不合法：" + tmp);
          }

          var tmpiplist = ipfuncs["default"].listIPByRange(tmparr[0], tmparr[1]);

          if (tmpiplist.length < 1) {
            return (0, _jquery["default"])("#find-msg").text("IP范围不合法：" + tmp);
          }

          allips.push.apply(allips, tmpiplist);
        } else if (tmp.indexOf("/") > 0) {
          var _tmparr = tmp.split("/");

          if (_tmparr.length < 2) {
            return (0, _jquery["default"])("#find-msg").text("IP网段不合法：" + tmp);
          }

          var _tmpiplist = ipfuncs["default"].listIPByNetwork(_tmparr[0], parseInt(_tmparr[1]));

          if (_tmpiplist.length < 1) {
            return (0, _jquery["default"])("#find-msg").text("IP网段不合法：" + tmp);
          }

          allips.push.apply(allips, _tmpiplist);
        } else if (ipfuncs["default"].ip_valid(tmp)) {
          allips.push(tmp);
        } else {
          return (0, _jquery["default"])("#find-msg").text("IP不合法：" + tmp);
        }
      }

      allips = ipfuncs["default"].getUniqArr(allips);

      if (allips.length < 1) {
        return (0, _jquery["default"])("#find-msg").text("IP范围为空");
      }

      if (allips.length > 1000) {
        return (0, _jquery["default"])("#find-msg").text("IP范围最大1000个");
      }

      var http = cockpit.http({
        "port": 9091
      });
      http.post("/setFindConfig", {
        "enabled": enabled,
        "iprange": iprange
      }).done(function (res) {
        //console.log("setFindConfig res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#find-msg").text("提交配置失败");
        }

        (0, _jquery["default"])("#find-msg").text("提交配置成功");
        g_snip_finished = 0;
        (0, _jquery["default"])("#find-result-content").html("");
        doFindWork(allips);
      }).fail(function (err) {
        //console.log(err);
        return (0, _jquery["default"])("#find-msg").text("提交配置失败");
      });
    }); // edit assert

    (0, _jquery["default"])("button.edit-assert-btn").unbind("click").click(function (e) {
      (0, _jquery["default"])("#edit-assert-msg").text("");
      var id = (0, _jquery["default"])(this).data("assert-id");
      console.log("edit-assert-btn clicked, recore id:" + id);
      var unit = getUnitById(id);
      var oldip = unit.assertip;
      var oldiparr = oldip.split("/");
      var network = (0, _interfaces["default"])(oldiparr[0]);
      var oldipsuffix = "";

      if (oldiparr.length > 1) {
        oldipsuffix = oldiparr[1];
      }

      var oldtag = unit.asserttag;
      var showtag = oldtag;

      if (!showtag.endsWith(";")) {
        showtag = showtag + ";";
      }

      (0, _jquery["default"])("#edit-assert-ip").val(unit.assertip);
      (0, _jquery["default"])("#edit-assert-tag").val(showtag);
      (0, _jquery["default"])("#edit-assert-name").val(unit.assertname);
      (0, _jquery["default"])("#edit-assert-location").val(unit.assertlocation);
      (0, _jquery["default"])("#edit-assert-usage").val(unit.assertusage); // 处理资产所属的分组

      var assertGroupMap = {};

      for (var i = 0; i < g_groups_bak.length; i++) {
        var assertsarr = g_groups_bak[i].groupasserts.split(";");

        for (var j = 0; j < assertsarr.length; j++) {
          if (!assertsarr[j]) {
            continue;
          }

          assertGroupMap[assertsarr[j]] = g_groups_bak[i].groupid;
        }
      }

      (0, _jquery["default"])("#assert-group").html("");

      var select_text = _("Not selected");

      var html = '<option value="notselected">' + select_text + '</option>';
      (0, _jquery["default"])("#assert-group").append((0, _jquery["default"])(html));

      for (var _i3 = 0; _i3 < g_groups_bak.length; _i3++) {
        var _html = '<option value="' + g_groups_bak[_i3].groupid + '">' + g_groups_bak[_i3].groupname + '</option>';

        (0, _jquery["default"])("#assert-group").append((0, _jquery["default"])(_html));
      }

      (0, _jquery["default"])("#assert-group").val(assertGroupMap[id]);
      (0, _jquery["default"])("#edit-assert-confirm").unbind("click").click(function (e) {
        (0, _jquery["default"])("#edit-assert-msg").text("应用中，请等待..."); // 到此已经添加到资产列表，还需要添加到数据库

        var http = cockpit.http({
          "port": 9091
        });
        var ip = (0, _jquery["default"])("#edit-assert-ip").val();
        var tag = (0, _jquery["default"])("#edit-assert-tag").val();
        var name = (0, _jquery["default"])("#edit-assert-name").val();
        var loca = (0, _jquery["default"])("#edit-assert-location").val();
        var usage = (0, _jquery["default"])("#edit-assert-usage").val();
        var groupid = (0, _jquery["default"])("#assert-group option:selected").val();

        if (!name || name.length < 1 || name.length > 40) {
          return (0, _jquery["default"])("#edit-assert-msg").text("请输入合法名称，1-40字符, 仅支持英文 中文 数字 . - _ ");
        }

        var rename = /[-\.\_a-zA-Z0-9\u4e00-\u9fa5]/;

        for (var i = 0; i < name.length; i++) {
          if (!rename.test(name[i])) {
            return (0, _jquery["default"])("#edit-assert-msg").text("请输入合法名称，1-40字符, 仅支持英文 中文 数字 . - _ ");
          }
        }

        if (tag != unit.asserttag) {
          var tagarr = tag.split(";");
          var versiontagexist = false;

          for (var _i4 = 0; _i4 < tagarr.length; _i4++) {
            if (tagarr[_i4] == "3.3" || tagarr[_i4] == "3.4") {
              versiontagexist = true;
            }
          }

          if (!versiontagexist) {
            return (0, _jquery["default"])("#edit-assert-msg").text("版本标签不允许删除");
          }
        }

        if (loca.length > 40) {
          return (0, _jquery["default"])("#edit-assert-msg").text("资产位置描述过长，请输入小于40个字符");
        }

        if (usage.length > 40) {
          return (0, _jquery["default"])("#edit-assert-msg").text("资产用途描述过长，请输入小于40个字符");
        }
        /*if (ip != oldip) {
            // 修改IP
            if (unit.assertip == "localhost") {
                return $("#edit-assert-msg").text("管理服务器不允许修改IP");
            }
              return $("#edit-assert-msg").text("暂时不支持");
              let newiparr = ip.split("/");
            if (newiparr.length < 2) {
                return $("#edit-assert-msg").text("IP请输入192.168.120.2/24的格式");
            }
            let nicipchanged = false;
            let nics = network.list_interfaces()
              nics.forEach(function (iface) {
                if (!ipfuncs.default.isEmpty(iface.MainConnection)
                 && !ipfuncs.default.isEmpty(iface.MainConnection.Settings)
                 && !ipfuncs.default.isEmpty(iface.MainConnection.Settings.ipv4)
                 && !ipfuncs.default.isEmpty(iface.MainConnection.Settings.ipv4.addresses)) {
                    let addresses = iface.MainConnection.Settings.ipv4.addresses;
                    for(let i=0;i<addresses.length;i++) {
                          let nicip = iface.MainConnection.Settings.ipv4.addresses[i][0];
                        if( nicip == oldiparr[0]) {
                            console.log("find nic to change:", iface.Name, " change to:", ip);
                            nicipchanged = true;
                              let settings = iface.MainConnection.Settings;
                            settings.ipv4.addresses[i][0] = newiparr[0];
                            settings.ipv4.addresses[i][1] = newiparr[1];
                            iface.MainConnection.apply_settings(settings);
                              // 修改了网卡的IP配置后，还要重启网卡生效
                            // 重启网卡要先断开，会导致失联
                            /*iface.MainConnection.activate(iface.Device).fail(function(err){
                                console.log(err);
                            });
                            let cmd = "ifconfig " + iface.Name + " down;ifconfig " + iface.Name + " up &";
                            console.log("exec cmd to change nic ip:", cmd);
                            cockpit.spawn(cmd, {
                                host: oldiparr[0]
                            })
                            .catch(err=>{
                                console.log(err);
                                console.log("重启网卡失败")
                            })
                              // 修改机器列表信息
                            g_machines.add(newiparr[0], {"user": unit.assertuser}).fail(function(e){
                                console.log("修改IP时添加机器信息失败");
                            })
                            break;
                        }
                    }
                 }
            })
            if (! nicipchanged) {
                return $("#edit-assert-msg").text("修改网卡IP失败，没找到对应网卡");
            }
        }*/


        if (tag.endsWith(";")) {
          tag = tag.substr(0, tag.length - 1);
        }

        var postdata = {
          "id": id,
          "tag": tag,
          "name": name,
          "location": loca,
          "usage": usage,
          "ip": ip,
          "group": groupid,
          "oldgroup": assertGroupMap[id]
        };
        http.post("/setAssert", postdata).done(function (res) {
          console.log("setAssert res:", res, " postdata:", postdata);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            return (0, _jquery["default"])("#edit-assert-msg").text("编辑资产记录失败：" + info.error);
          }

          (0, _jquery["default"])("#edit-assert-msg").text("编辑资产成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#edit-assert-close").click();
            render_asserts_real();
          }, 1000);
        }).fail(function (err) {
          console.log(err);
          (0, _jquery["default"])("#edit-assert-msg").text("编辑资产记录失败");
        });
      });
    });
  }

  function get_assert_state(ip) {
    var index = 0;

    for (index = 0; index < g_machines.list.length; index++) {
      if (g_machines.list[index].address != ip) {
        continue;
      }

      if (g_machines.list[index].state == "connected") {
        return _("Online");
      }

      return _("Offline");
    }

    return "";
  }

  function show_asserts_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    var pattern = (0, _jquery["default"])('#services-filter li.active').attr('data-pattern');
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var current_type_filter = parseInt((0, _jquery["default"])('#services-dropdown').val());
    var units = [];
    var header = {
      Id: _("Assert ID"),
      Name: _("Assert Name"),
      Loca: _("Assert Location"),
      Usage: _("Assert Usage"),
      Ip: _("Assert IP"),
      Tag: _("Assert Tag"),
      State: _("Assert Status"),
      Group: _("Assert Group"),
      Operate: _("Operation")
    };
    var assertGroupMap = {}; // 处理资产所属的分组

    for (var i = 0; i < g_groups_bak.length; i++) {
      var assertsarr = g_groups_bak[i].groupasserts.split(";");

      for (var j = 0; j < assertsarr.length; j++) {
        if (!assertsarr[j]) {
          continue;
        }

        assertGroupMap[assertsarr[j]] = g_groups_bak[i].groupname;
      }
    }

    function cmp_assert(a, b) {
      return info[a].id > info[b].id;
    }

    var sorted_assert_keys = Object.keys(info).sort(cmp_assert);
    sorted_assert_keys.forEach(function (id) {
      var unit = info[id];

      if (!unit.assertlocation) {
        unit.assertlocation = "----";
      }

      if (!unit.assertusage) {
        unit.assertusage = "----";
      }

      var state = get_assert_state(unit.assertip);

      if (state === "") {// invalid assert
        // return 
      }

      unit.group = assertGroupMap[unit.assertid];
      unit.state = state;
      unit.edit_text = _("Edit");
      unit.more_text = _("More"); // 过滤掉状态类型

      var state_filter = {
        "0": "all",
        "1": _("Online"),
        "2": _("Offline")
      }[current_type_filter];

      if (current_type_filter != "0" && state_filter != unit.state) {
        return;
      } // 匹配搜索字符串


      if (!current_text_filter) {
        units.push(unit);
        return;
      }

      if (unit.assertname && unit.assertname.toLowerCase().indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }

      if (unit.assertlocation && unit.assertlocation.indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }

      if (unit.assertusage && unit.assertusage.indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }

      if (unit.assertip && unit.assertip.indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }
    });
    units = processPagination(units);
    var text = "";
    if (units.length > 0) text = _mustache["default"].render(units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template);
    (0, _jquery["default"])("#services-list").html(text);
    (0, _jquery["default"])("#service-detail-list").hide();
    (0, _jquery["default"])("#services").show();
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function render_asserts_real() {
    console.log("machines:", g_machines.list);
    (0, _jquery["default"])("#loading-fallback").show(); // 使用资产接口获取获取所有的资产信息

    clearInterval(intv);
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getAsserts").done(function (res) {
      //console.log("getAsserts res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getAsserts err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_asserts_bak = info; // 资产需要展示所属的分组信息

      http.get("/getGroups").fail(function (err) {
        //console.log("getGroups err:", err);
        (0, _jquery["default"])("#loading-fallback").hide();
      }).done(function (res) {
        //console.log("get groups res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#loading-fallback").hide();
        }

        g_groups_bak = info.data;
        show_asserts_page(g_asserts_bak);
        registerAssertsEvent();
        (0, _jquery["default"])("#loading-fallback").hide();
        intv = setInterval(function () {
          _jquery["default"].each(g_machines.list, function (i, v) {
            var status = v.state == "connected" ? _("Online") : _("Offline");
            (0, _jquery["default"])("div#services-list tbody tr[data-address='" + v.address + "']").find("#unit-status").text(status);
          });
        }, 2000);
      });
    }).fail(function (err) {
      //console.log("getAsserts err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  function update_available() {
    for (var id in g_authkeys.items) {
      var key = g_authkeys.items[id];
      (0, _jquery["default"])("#credit-identifier").html("");

      if (key.loaded) {
        (0, _jquery["default"])("#credit-identifier").append((0, _jquery["default"])("<option>").text(key.name));
      }
    }
  }

  function render_asserts() {
    console.log("render_asserts");
    (0, _jquery["default"])("#loading-fallback").show();
    (0, _jquery["default"])("#create-group").hide();
    (0, _jquery["default"])("#add-server").show();
    (0, _jquery["default"])("#find-server").show();
    (0, _jquery["default"])("#services-dropdown").show();
    (0, _jquery["default"])(g_machines).on("added.dashboard", function (e) {});
    (0, _jquery["default"])(g_machines).on("removed.dashboard", function (e) {});
    (0, _jquery["default"])(g_machines).on("updated.dashboard", function (e) {}); // 使用 dashboard 的接口获取到所有的机器信息，需要延时获取

    setTimeout(function () {
      render_asserts_real();
    }, 500);
  }

  function has_special_chars(str) {
    var arr = ["&", "\\", "/", "*", ">", "<", "@", "!"];

    for (var i = 0; i < arr.length; i++) {
      for (var j = 0; j < str.length; j++) {
        if (arr[i] == str.charAt(j)) {
          return true;
        }
      }
    }
  }

  function has_special_chars_name(str) {
    var rename = /[-\.\_a-zA-Z0-9\u4e00-\u9fa5]/;

    for (var i = 0; i < str.length; i++) {
      if (!rename.test(str[i])) {
        return true;
      }
    }

    return false;
  }

  function getGroupById(id) {
    var unit = [];

    for (var i = 0; i < g_groups_bak.length; i++) {
      if (g_groups_bak[i].groupid == id) {
        unit = g_groups_bak[i];
      }
    }

    if (!unit) {
      console.log("[g_groups_bak]can not find unit,uuid:", id);
    }

    return unit;
  }

  function registerEditGroupConfirmEvent() {
    (0, _jquery["default"])("#edit-group-confirm").unbind("click").click(function (e) {
      var uuid = (0, _jquery["default"])("#edit-group-id").val();
      var name = (0, _jquery["default"])("#edit-group-name").val();
      var desc = (0, _jquery["default"])("#edit-group-desc").val();

      if (!name || name.length < 1 || name.length > 40 || has_special_chars_name(name)) {
        (0, _jquery["default"])("#edit-group-msg").text("请输入合法名称，1-40字符, 仅支持英文 中文 数字 . - _ ");
        return;
      }

      if (!desc || desc.length < 1 || desc.length > 120) {
        (0, _jquery["default"])("#edit-group-msg").text("请输入合法描述，1-120字符，且不能有特殊字符");
        return;
      }

      var allasserts = "";
      (0, _jquery["default"])("#keepRenderingSort_to option").each(function (e) {
        var assertid = (0, _jquery["default"])(this).val();
        allasserts = allasserts + assertid + ";";
      });
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/editGroup", {
        "uuid": uuid,
        "name": name,
        "desc": desc,
        "asserts": allasserts
      }).done(function (res) {
        console.log("editGroup res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          (0, _jquery["default"])("#edit-group-msg").text("编辑分组失败，" + info.error);
          return;
        }

        (0, _jquery["default"])("#edit-group-msg").text("编辑分组成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#edit-group-close").click();
          render_groups();
        }, 1000);
      }).fail(function (err) {
        console.log("editGroup err:", err);
        (0, _jquery["default"])("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
      });
    });
  }

  function registerGroupsEvent() {
    function setSelectAssertUI(groupunit) {
      // 所有已分组的资产，元素是资产ID
      var allGroupAsserts = [];

      for (var i = 0; i < g_groups_bak.length; i++) {
        var _assertsarr = g_groups_bak[i].groupasserts.split(";");

        for (var j = 0; j < _assertsarr.length; j++) {
          if (allGroupAsserts.indexOf(_assertsarr[j]) < 0) {
            allGroupAsserts.push(_assertsarr[j]);
          }
        }
      }

      var keepRenderingSortHtml = "#keepRenderingSort";
      var keepRenderingSort_toHtml = "#keepRenderingSort_to";

      if (ipfuncs["default"].isEmpty(groupunit)) {
        keepRenderingSortHtml = "#add_keepRenderingSort";
        keepRenderingSort_toHtml = "#add_keepRenderingSort_to";
      }

      (0, _jquery["default"])(keepRenderingSortHtml).html(""); // 所有未分组的资产，元素是资产信息

      var noGroupAsserts = [];

      for (var _i5 = 0; _i5 < g_asserts_bak.length; _i5++) {
        if (allGroupAsserts.indexOf(g_asserts_bak[_i5].assertid) < 0) {
          noGroupAsserts.push(g_asserts_bak[_i5]);

          if (g_asserts_bak[_i5].assertip != "localhost") {
            var html = "<option value='" + g_asserts_bak[_i5].assertid + "'>" + g_asserts_bak[_i5].assertip + " " + g_asserts_bak[_i5].assertname + "</option>";
            (0, _jquery["default"])(keepRenderingSortHtml).append((0, _jquery["default"])(html));
          }
        }
      }

      (0, _jquery["default"])(keepRenderingSort_toHtml).html("");

      if (ipfuncs["default"].isEmpty(groupunit)) {
        // 新增分组的时候还没有选择资产
        return;
      } // 该分组所有已经选择的资产


      var assertsarr = groupunit.groupasserts.split(";");

      for (var _i6 = 0; _i6 < assertsarr.length; _i6++) {
        var assertunit = getUnitById(assertsarr[_i6]);

        if (ipfuncs["default"].isEmpty(assertunit)) {
          continue;
        }

        var _html2 = "<option value='" + assertsarr[_i6] + "'>" + assertunit.assertip + " " + assertunit.assertname + "</option>";

        (0, _jquery["default"])(keepRenderingSort_toHtml).append((0, _jquery["default"])(_html2));
      }
    }

    (0, _jquery["default"])("#create-group").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add-group-name").val("");
      (0, _jquery["default"])("#add-group-desc").val("");
      (0, _jquery["default"])("#add-group-msg").text("");
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getAsserts").done(function (res) {
        console.log("getAsserts res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          (0, _jquery["default"])("#add-group-msg").text("获取资产信息失败，请稍后重试");
          return setTimeout(function (e) {
            (0, _jquery["default"])("#add-group-close").click();
          }, 1500);
        }

        g_asserts_bak = info.data;
        setSelectAssertUI([]);
      }).fail(function (err) {
        console.log("getGroups err:", err);
        (0, _jquery["default"])("#add-group-msg").text("获取资产信息失败，请稍后重试");
        return setTimeout(function (e) {
          (0, _jquery["default"])("#add-group-close").click();
        }, 1500);
      });
    });
    (0, _jquery["default"])("#add_keepRenderingSort_rightAll").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add_keepRenderingSort option").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#add_keepRenderingSort_to").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#add_keepRenderingSort_leftAll").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add_keepRenderingSort_to option").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#add_keepRenderingSort").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#add_keepRenderingSort_rightSelected").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add_keepRenderingSort option:selected").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#add_keepRenderingSort_to").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#add_keepRenderingSort_leftSelected").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add_keepRenderingSort_to option:selected").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#add_keepRenderingSort").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#services-text-filter").change(function (e) {
      show_groups_page(g_groups_bak);
      registerGroupsEvent();
    });
    (0, _jquery["default"])("#clear-all-filters").unbind("click").click(function (e) {
      (0, _jquery["default"])("#services-text-filter").val("");
      show_groups_page(g_groups_bak);
      registerGroupsEvent();
    });
    (0, _jquery["default"])("#add-group-confirm").unbind("click").click(function (e) {
      var name = (0, _jquery["default"])("#add-group-name").val();
      var desc = (0, _jquery["default"])("#add-group-desc").val();

      if (!name || name.length < 1 || name.length > 40 || has_special_chars_name(name)) {
        (0, _jquery["default"])("#add-group-msg").text("请输入合法名称，1-40字符, 仅支持英文 中文 数字 . - _ ");
        return;
      }

      if (!desc || desc.length < 1 || desc.length > 120) {
        (0, _jquery["default"])("#add-group-msg").text("请输入合法描述，1-120字符，且不能有特殊字符");
        return;
      }

      var allasserts = "";
      (0, _jquery["default"])("#add_keepRenderingSort_to option").each(function (e) {
        var assertid = (0, _jquery["default"])(this).val();
        allasserts = allasserts + assertid + ";";
      });
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/addGroup", {
        "name": name,
        "desc": desc,
        "asserts": allasserts
      }).done(function (res) {
        console.log("addGroup res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("addGroup error, res:", res);
          (0, _jquery["default"])("#add-group-msg").text("添加分组失败，", res.error);
          return;
        }

        console.log("addGroup res:", res);
        (0, _jquery["default"])("#add-group-msg").text("添加分组成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#add-group-close").click();
          render_groups();
        }, 1000);
      }).fail(function (err) {
        console.log("addGroup err:", err);
        (0, _jquery["default"])("#add-group-msg").text("添加分组失败，请检查名称是否已经存在");
      });
    });
    (0, _jquery["default"])("button.edit-group-btn").unbind("click").click(function (e) {
      var uuid = (0, _jquery["default"])(this).data("group-id");
      console.log("edit-group-btn clicked, group id:" + uuid);
      var unit = getGroupById(uuid);
      (0, _jquery["default"])("#edit-group-id").val(unit.groupid);
      (0, _jquery["default"])("#edit-group-name").val(unit.groupname);
      (0, _jquery["default"])("#edit-group-desc").val(unit.groupdesc);
      (0, _jquery["default"])("#edit-group-msg").text("");
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getAsserts").done(function (res) {
        //console.log("getAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          (0, _jquery["default"])("#edit-group-msg").text("获取资产信息失败，请稍后重试");
          return setTimeout(function (e) {
            (0, _jquery["default"])("#edit-group-close").click();
          }, 1500);
        }

        g_asserts_bak = info.data;
        setSelectAssertUI(unit);
      }).fail(function (err) {
        console.log("getGroups err:", err);
        (0, _jquery["default"])("#edit-group-msg").text("获取资产信息失败，请稍后重试");
        return setTimeout(function (e) {
          (0, _jquery["default"])("#edit-group-close").click();
        }, 1500);
      });
    });
    (0, _jquery["default"])("#keepRenderingSort_rightAll").unbind("click").click(function (e) {
      (0, _jquery["default"])("#keepRenderingSort option").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#keepRenderingSort_to").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#keepRenderingSort_leftAll").unbind("click").click(function (e) {
      (0, _jquery["default"])("#keepRenderingSort_to option").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#keepRenderingSort").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#keepRenderingSort_rightSelected").unbind("click").click(function (e) {
      (0, _jquery["default"])("#keepRenderingSort option:selected").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#keepRenderingSort_to").append((0, _jquery["default"])(html));
      });
    });
    (0, _jquery["default"])("#keepRenderingSort_leftSelected").unbind("click").click(function (e) {
      (0, _jquery["default"])("#keepRenderingSort_to option:selected").each(function () {
        var html = '<option value="' + (0, _jquery["default"])(this).val() + '">' + (0, _jquery["default"])(this).text() + '</option>';
        (0, _jquery["default"])(this).remove();
        (0, _jquery["default"])("#keepRenderingSort").append((0, _jquery["default"])(html));
      });
    });
    registerEditGroupConfirmEvent();
    (0, _jquery["default"])("button.delete-group-btn").unbind("click").click(function (e) {
      var uuid = (0, _jquery["default"])(this).data("group-id");
      console.log("delete-group-btn clicked, group id:" + uuid);
      var unit = getGroupById(uuid);
      (0, _jquery["default"])("#confirm-operate-private-data").data("private-data", uuid);
      (0, _jquery["default"])("#confirm-operate-msg").text("确认要删除分组 " + unit.groupname + " 吗？"); // 阻止事件上传，不响应渲染分组详情的页面
      // e.stopPropagation();
    });
    (0, _jquery["default"])("#confirm-operate-confirm").unbind("click").click(function (e) {
      var uuid = (0, _jquery["default"])("#confirm-operate-private-data").data("private-data");
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/deleteGroup", {
        "uuid": uuid
      }).done(function (res) {
        console.log("deleteGroup res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("deleteGroup error, res:", res);
          (0, _jquery["default"])("#confirm-operate-msg").text("删除分组失败");
          return;
        }

        (0, _jquery["default"])("#confirm-operate-msg").text("删除分组成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#confirm-operate-close").click();
          render_groups();
        }, 1000);
      }).fail(function (err) {
        console.log("deleteGroup err:", err);
        (0, _jquery["default"])("#confirm-operate-msg").text("删除分组失败");
        return;
      });
    }); // 不做分组详情了

    /* $("tr.group-unit-tr-row").unbind("click").click(function(e){
        // 如果是点击的是 编辑 和 删除按钮，则不进行处理
        if (e.target.localName === "button") {
            return ;
        }
          let uuid = $(this).data("goto-unit");
        render_group_detail(uuid);
        cockpit.location.go(["groups-" + uuid]);
    }) */
  }

  function show_groups_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var units = [];
    var header = {
      Name: _("Group Name"),
      Description: _("Group Description"),
      Assertcnt: _("Assert Number"),
      Operate: _("Operation")
    };

    function cmp_group(a, b) {
      return info[a].id - info[b].id;
    }

    var sorted_group_keys = Object.keys(info).sort(cmp_group);
    sorted_group_keys.forEach(function (id) {
      var unit = info[id]; // 获取资产数目

      var assertcnt = 0;
      var assertsarr = unit.groupasserts.split(";");
      unit.edit_text = _("Edit");
      unit.del_text = _("Delete");

      for (var i = 0; i < assertsarr.length; i++) {
        if (assertsarr[i] && assertsarr[i].length > 0) {
          var asserttmp = getUnitById(assertsarr[i]);

          if (!asserttmp.hasOwnProperty("assertstate")) {
            continue;
          }

          if (asserttmp.assertstate == "deleted") {
            continue;
          }

          assertcnt = assertcnt + 1;
        }
      }

      unit.assertcnt = assertcnt; // 匹配搜索字符串

      if (!current_text_filter) {
        units.push(unit);
        return;
      }

      if (unit.groupdesc && unit.groupdesc.toLowerCase().indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }

      if (unit.groupname && unit.groupname.indexOf(current_text_filter) != -1) {
        units.push(unit);
        return;
      }
    }); // 分页展示

    units = processPagination(units);
    var text = "";
    if (units.length > 0) text = _mustache["default"].render(groups_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template);
    (0, _jquery["default"])("#services-list").html(text);
    (0, _jquery["default"])("#service-detail-list").hide();
    (0, _jquery["default"])("#services").show();
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function render_groups() {
    console.log("render_groups.");
    (0, _jquery["default"])("#loading-fallback").show();
    (0, _jquery["default"])("#create-group").show();
    (0, _jquery["default"])("#add-server").hide();
    (0, _jquery["default"])("#find-server").hide();
    (0, _jquery["default"])("#services-dropdown").hide();
    var http = cockpit.http({
      "port": 9091
    }); // 获取资产数需要资产信息，需要知道资产是否已经被删除

    http.get("/getAsserts").done(function (res) {
      //console.log("getAsserts res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getAsserts err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      g_asserts_bak = info.data;
      http.get("/getGroups").done(function (res) {
        //console.log("getGroups res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getGroups err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        info = info.data;
        g_groups_bak = info; // 如果是分组详情页面，在这里拦截，转到分组详情页面，需要到这里因为要获取数据

        if (window.location.href.indexOf("#/groups-") > 0) {
          var arr = window.location.href.split("#/groups-");
          var uuid = arr[arr.length - 1];
          render_group_detail(uuid);
          return;
        }

        show_groups_page(info);
        registerGroupsEvent();
        (0, _jquery["default"])("#loading-fallback").hide();
      }).fail(function (err) {
        console.log("getGroups err:", err);
        (0, _jquery["default"])("#loading-fallback").hide();
      });
    }).fail(function (err) {
      console.log("getAsserts err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  (0, _jquery["default"])('#services-filter li').on('click', function () {
    (0, _jquery["default"])('#services-filter li').removeClass('active').removeAttr('aria-current');
    (0, _jquery["default"])(this).addClass('active').attr('aria-current', true);
    var pattern = (0, _jquery["default"])(this).attr('data-pattern');

    if (pattern == "asserts") {
      cockpit.location.go(["asserts"]);
      render_asserts();
    } else if (pattern == "groups") {
      cockpit.location.go(["groups"]);
      render_groups();
    }
  }); // 根据 url 初始化渲染页面

  (0, _jquery["default"])("#services-filter li").removeClass('active').removeAttr('aria-current');

  if (window.location.href.indexOf("#/groups") > 0) {
    (0, _jquery["default"])("#groups-li").addClass('active').attr('aria-current', true);
    render_groups();
  } else {
    (0, _jquery["default"])("#asserts-li").addClass('active').attr('aria-current', true);
    render_asserts();
  }
}
/* These add themselves to jQuery so just including is enough */


cockpit.translate();
var _ = cockpit.gettext;

_moment["default"].locale(cockpit.language);

if (window.location.pathname.indexOf("manager/index.html") > 0) {
  asserts_init();
}