"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * 判断变量是否为空，
 * @param  {[type]}  param 变量
 * @return {Boolean}      为空返回true，否则返回false。
 */
function isEmpty(v) {
  switch (_typeof(v)) {
    case 'undefined':
      return true;

    case 'string':
      if (trim(v).length == 0) return true;
      break;

    case 'boolean':
      if (!v) return true;
      break;

    case 'number':
      if (0 === v) return true;
      break;

    case 'object':
      if (null === v) return true;
      if (undefined !== v.length && v.length == 0) return true;

      for (var k in v) {
        return false;
      }

      return true;
      break;
  }

  return false;
} // 验证IP的正则


var ip_reg = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/; // 验证子网掩码的正则

var mask_reg = /^(254|252|248|240|224|192|128|0)\.0\.0\.0|255\.(254|252|248|240|224|192|128|0)\.0\.0|255\.255\.(254|252|248|240|224|192|128|0)\.0|255\.255\.255\.(254|252|248|240|224|192|128|0)$/;

function ip_valid(ip) {
  if (ip_reg.test(ip)) {
    return true;
  }

  return false;
}

function mask_valid(mask) {
  if (mask_reg.test(mask)) {
    return true;
  }

  return false;
} //IP转数字


function ip2int(ip) {
  var num = 0;
  ip = ip.split(".");
  num = Number(ip[0]) * 256 * 256 * 256 + Number(ip[1]) * 256 * 256 + Number(ip[2]) * 256 + Number(ip[3]);
  num = num >>> 0;
  return num;
} //数字转IP


function int2iP(num) {
  var str;
  var tt = new Array();
  tt[0] = num >>> 24 >>> 0;
  tt[1] = num << 8 >>> 24 >>> 0;
  tt[2] = num << 16 >>> 24;
  tt[3] = num << 24 >>> 24;
  str = String(tt[0]) + "." + String(tt[1]) + "." + String(tt[2]) + "." + String(tt[3]);
  return str;
} //列出IP段内的IP


function listIPByRange(ip1, ip2) {
  var result = [];
  var ipInt1 = ip2int(ip1);
  var ipInt2 = ip2int(ip2);

  for (var i = ipInt1; i <= ipInt2; i++) {
    result.push(int2iP(i));
  }

  return result;
}

function listIPByNetwork(ipaddr, netmask) {
  var result = [];

  if (!ip_reg.test(ipaddr)) {
    return result;
  }

  if (netmask < 20 || netmask > 32) {
    return result;
  }

  var ipaddrint = ip2int(ipaddr);
  var ipaddrbegin = ipaddrint >> 32 - netmask << 32 - netmask;
  var ipaddrend = ipaddrbegin;

  if (netmask < 32) {
    var powy = Math.pow(2, 31 - netmask);
    ipaddrend = ipaddrbegin | powy;
  }

  ipaddrbegin = int2iP(ipaddrbegin);
  ipaddrend = int2iP(ipaddrend);
  return listIPByRange(ipaddrbegin, ipaddrend);
}

function getUniqArr(arr) {
  arr = arr.sort();
  console.log(arr);
  var arr1 = [arr[0]];

  for (var i = 1, len = arr.length; i < len; i++) {
    if (arr[i] !== arr[i - 1]) {
      arr1.push(arr[i]);
    }
  }

  return arr1;
}

var _default = {
  isEmpty: isEmpty,
  ip_valid: ip_valid,
  mask_valid: mask_valid,
  listIPByRange: listIPByRange,
  listIPByNetwork: listIPByNetwork,
  getUniqArr: getUniqArr
};
exports["default"] = _default;