"use strict";

var _jquery = _interopRequireDefault(require("jquery"));

var _mustache = _interopRequireDefault(require("mustache"));

var _moment = _interopRequireDefault(require("moment"));

require("patterns");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import journal from "journal";
// import JQMeter from "./jqmeter";
function notify_init() {
  console.log("notify_init...");
  (0, _jquery["default"])("#loading-fallback").show();
  var notify_units_template = (0, _jquery["default"])("#notify-units-tmpl").html();

  _mustache["default"].parse(notify_units_template);

  var empty_template = (0, _jquery["default"])("#notify-empty-tmpl").html();

  _mustache["default"].parse(empty_template);

  var g_vue_pagination;
  var g_cur_page = 1;
  var g_page_size = 20;
  var g_assertsp_bak = [];

  if (sessionStorage.getItem("assertp")) {
    g_assertsp_bak = _jquery["default"].parseJSON(sessionStorage.getItem("assertp"));
  }

  var units = [];

  for (var i = 0; i < g_assertsp_bak.length; i++) {
    units.push(g_assertsp_bak[i]);
  }

  var header = {
    Assert: "资产名称",
    IP: "资产IP",
    Opreation: "操作"
  };

  if (!g_vue_pagination) {
    g_vue_pagination = new Vue({
      template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
      el: "#vue-notify-div",
      methods: {
        handleSizeChange: function handleSizeChange(val) {
          g_page_size = val;
          console.log("set g_page_size to:", val);
          showpage(g_cur_page, val);
        },
        handleCurrentChange: function handleCurrentChange(val) {
          g_cur_page = val;
          console.log("set g_cur_page to:", val);
          showpage(val, g_page_size);
        }
      },
      data: {
        current_page: g_cur_page,
        page_size: g_page_size,
        total: units.length
      }
    });
  } else {
    g_vue_pagination.current_page = g_cur_page;
    g_vue_pagination.page_size = g_page_size;
    g_vue_pagination.total = units.length;
  } // 只展示这一页的数据


  function showpage(g_cur_page, g_page_size) {
    (0, _jquery["default"])("#notify-list").html();
    var cur_units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;

    if (cur_units.length > 0) {
      text = _mustache["default"].render(notify_units_template, {
        table_head: header,
        units: cur_units
      });
    } else {
      text = _mustache["default"].render(empty_template);
    }

    (0, _jquery["default"])("#notify-list").html(text);
  }

  showpage(g_cur_page, g_page_size);
  (0, _jquery["default"])("#loading-fallback").hide();
}

cockpit.translate();
var _ = cockpit.gettext;

_moment["default"].locale(cockpit.language);

if (window.location.pathname.indexOf("manager/notify") > 0) {
  (0, _jquery["default"])(notify_init);
}