"use strict";

var _jquery = _interopRequireDefault(require("jquery"));

var _mustache = _interopRequireDefault(require("mustache"));

var _moment = _interopRequireDefault(require("moment"));

var _journal = _interopRequireDefault(require("journal"));

require("patterns");

require("bootstrap-datepicker/dist/js/bootstrap-datepicker");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//import cockpit from "cockpit";
//import "bootstrap-datepicker/dist/locales/bootstrap-datepicker.zh-CN.min";
//import "bootstrap-datepicker/js/bootstrap-datepicker";
//import "bootstrap-datepicker/js/locales/bootstrap-datepicker.zh-CN";
_jquery["default"].fn.datepicker.dates['zh-CN'] = {
  days: ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"],
  daysShort: ["周日", "周一", "周二", "周三", "周四", "周五", "周六"],
  daysMin: ["日", "一", "二", "三", "四", "五", "六"],
  months: ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],
  monthsShort: ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
  today: "今天",
  monthsTitle: "选择月份",
  clear: "清除",
  format: "yyyy-mm-dd",
  titleFormat: "yyyy年mm月",
  weekStart: 1
};

function syslogs_init() {
  console.log("syslogs_init");
  var units_template = (0, _jquery["default"])("#services-units-tmpl").html();

  _mustache["default"].parse(units_template);

  var empty_template = (0, _jquery["default"])("#service-empty-tmpl").html();

  _mustache["default"].parse(empty_template);

  var syslogs_detail_template = (0, _jquery["default"])("#service-template-tmpl").html();

  _mustache["default"].parse(syslogs_detail_template);

  (0, _jquery["default"])("#datepicker1").datepicker({
    language: "zh-CN",
    //语言
    autoclose: true,
    //选择后自动关闭
    clearBtn: true,
    //清除按钮
    format: "yyyy-mm-dd",
    //日期格式
    startDate: "-90d",
    endDate: new Date()
  });
  (0, _jquery["default"])("#datepicker2").datepicker({
    language: 'zh-CN',
    //语言
    autoclose: true,
    //选择后自动关闭
    clearBtn: true,
    //清除按钮
    format: "yyyy-mm-dd",
    //日期格式
    startDate: "-90d",
    endDate: new Date()
  });
  var g_syslogs_bak = []; //分页界面的相关变量放在这做全局变量

  var g_vue_pagination;
  var g_cur_page = 1;
  var g_page_size = 20;
  var g_total_size = 0;

  function registerSyslogsEvent() {
    //registerJumpPageConfirmEvent();
    registerSearchButtonConfirmEvent(); //syslogMessageOperation();

    syslogServerConfig();
    (0, _jquery["default"])("#services-dropdown").change(function (e) {
      show_syslogs_page(g_syslogs_bak);
      registerSyslogsEvent();
    });
  }

  function getSyslogMessageById(syslogid) {
    console.log("getSyslogMessageById");
    console.log(syslogid);

    for (var i = 0; i < g_syslogs_bak.length; i++) {
      if (g_syslogs_bak[i][0] == syslogid) {
        console.log(g_syslogs_bak[i][7]);
        return g_syslogs_bak[i][7];
      }
    }

    return false;
  }

  function show_syslogs_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    var pattern = (0, _jquery["default"])('#services-filter li.active').attr('data-pattern');
    var severity = ["紧急", "警报", "关键", "错误", "警告", "通知", "信息", "调试"];
    var units = [];

    for (var i = 0; i < info.length; i++) {
      var j = info[i][5];
      var tmp = {
        "ID": info[i][0],
        "ReceivedAt": info[i][2],
        "FromHost": info[i][6],
        "Priority": severity[j],
        "Message": info[i][7]
      };
      units.push(tmp);
    }

    var header = {
      ID: "ID",
      ReceivedAt: "ReceivedAt",
      FromHost: "FromHost",
      NTSeverity: "NTSeverity",
      Message: "Message"
    };
    var text = "";
    if (units.length >= 0) text = _mustache["default"].render(units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template);
    (0, _jquery["default"])("#services-list").html(text);
    (0, _jquery["default"])("#service-detail-list").hide();
    (0, _jquery["default"])("#services").show();
    syslogMessageOperation();
    (0, _jquery["default"])("#services-dropdown").show();
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function syslogServerConfig() {
    (0, _jquery["default"])("#syslog-server").unbind("click").click(function (e) {
      (0, _jquery["default"])("#syslog-server-msg").text("");
      var content = {
        ip: "",
        port: "3306",
        database: "",
        user: "",
        password: "",
        keeptime: 3
      };
      JSON.stringify(content);
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getdbconfig", content).done(function (res) {
        var info = _jquery["default"].parseJSON(res); // console.log(info.content);


        (0, _jquery["default"])("#syslog-server-ip").val(info.content.ip);
        (0, _jquery["default"])("#syslog-server-port").val(info.content.port);
        (0, _jquery["default"])("#syslog-server-database").val(info.content.database);
        (0, _jquery["default"])("#syslog-server-user").val(info.content.user);
        (0, _jquery["default"])("#syslog-server-password").val(info.content.password);
        (0, _jquery["default"])("#syslog-keep-time").val(info.content.keeptime);
      })["catch"](function (e) {});
    });
    (0, _jquery["default"])("#syslog-server-confirm").unbind("click").click(function (e) {
      var ip = (0, _jquery["default"])("#syslog-server-ip").val();
      var port = (0, _jquery["default"])("#syslog-server-port").val();
      var database = (0, _jquery["default"])("#syslog-server-database").val();
      var user = (0, _jquery["default"])("#syslog-server-user").val();
      var password = (0, _jquery["default"])("#syslog-server-password").val();
      var keeptime = (0, _jquery["default"])("#syslog-keep-time").children("option:selected").val();
      (0, _jquery["default"])("#syslog-server-msg").text("配置中，请等待..."); //var result = "ip:" + ip + " " + "port:" + port + " " + "database:" + database + " " + "user:" + user + " " + "password:" + password + " " + "keeptime:" + keeptime;
      //alert(result);

      var http = cockpit.http({
        "port": 9091
      });
      http.post("/setSyslogConfig", {
        "ip": ip,
        "port": port,
        "database": database,
        "user": user,
        "password": password,
        "keeptime": keeptime
      }).done(function (res) {
        // console.log("setSyslogConfig res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#syslog-server-msg").text("日志服务器配置失败：" + info.error);
        }

        (0, _jquery["default"])("#syslog-server-msg").text("日志服务器配置成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#syslog-server-close").click();
        }, 1000);
      }).fail(function (exception, err) {
        console.log(err);
        (0, _jquery["default"])("#syslog-server-msg").text("日志服务器配置失败");
      });
    });
  }

  function syslogMessageOperation() {
    (0, _jquery["default"])("button.syslog-message").unbind("click").click(function (e) {
      var syslogid = (0, _jquery["default"])(this).data("syslog-id");
      var syslogmessage = getSyslogMessageById(syslogid); //alert(syslogid);

      (0, _jquery["default"])("#syslog-message-msg").val(syslogmessage);
      console.log(syslogid);
      console.log(syslogmessage);
    });
  }

  function registerSearchButtonConfirmEvent() {
    (0, _jquery["default"])("#search-confirm").unbind("click").click(function (e) {
      g_cur_page = 1;
      var jumppage = String(g_cur_page);
      var pagesize = String(g_page_size);
      var begintime = (0, _jquery["default"])("#datepicker1").val();
      var endtime = (0, _jquery["default"])("#datepicker2").val(); //alert(begintime + endtime);

      var domain = (0, _jquery["default"])("#services-domain").children("option:selected").val();
      var priority = (0, _jquery["default"])("#services-priority").children("option:selected").val();
      var search = (0, _jquery["default"])("#services-search").val();
      (0, _jquery["default"])("#loading-fallback").show(); //alert(priority);

      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getRsyslogsByFilter", {
        "jumppage": jumppage,
        "pagesize": pagesize,
        "begintime": begintime,
        "endtime": endtime,
        "domain": domain,
        "priority": priority,
        "search": search
      }).done(function (res) {
        // console.log("getRsyslogsByFilter res:", domain);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getRsyslogsByFilter err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        var data = info.data.log;
        g_total_size = info.data.totalrecords;
        g_syslogs_bak = data;
        show_syslogs_page(data);
        (0, _jquery["default"])("#loading-fallback").hide(); //点击搜索按钮后，更改分页相关变量

        g_vue_pagination.current_page = g_cur_page;
        g_vue_pagination.page_size = g_page_size;
        g_vue_pagination.total = g_total_size;
      })["catch"](function (err) {
        console.log("getClientInfo err:", err);
        (0, _jquery["default"])("#loading-fallback").hide();
      });
    });
  }

  function render_syslogs() {
    console.log("render_syslogs");
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    var pagesize = String(g_page_size);
    var jumppage = String(g_cur_page);
    http.get("/getRsyslogs", {
      "jumppage": jumppage,
      "pagesize": pagesize
    }).done(function (res) {
      // console.log("getRsyslogs res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRsyslogs err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      var data = info.data.log;
      var domain = info.data.domain;
      g_total_size = parseInt(info.data.totalrecords); // console.log("the total size is")
      // console.log(info);

      if (!g_vue_pagination) {
        g_vue_pagination = new Vue({
          template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80,100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
          el: "#vue-syslog-div",
          methods: {
            handleSizeChange: function handleSizeChange(val) {
              //发请求，传递当前页和每页数据大小，得到当前页数据
              g_page_size = val;
              g_cur_page = 1;
              console.log("set g_page_size to:", val);
              var http = cockpit.http({
                "port": 9091
              });
              var jumppage = String(g_cur_page);
              var pagesize = String(g_page_size);
              var begintime = (0, _jquery["default"])("#datepicker1").val();
              var endtime = (0, _jquery["default"])("#datepicker2").val();
              var domain = (0, _jquery["default"])("#services-domain").children("option:selected").val();
              var priority = (0, _jquery["default"])("#services-priority").children("option:selected").val();
              var search = (0, _jquery["default"])("#services-search").val();
              (0, _jquery["default"])("#loading-fallback").show();
              http.get("/getRsyslogsByPage", {
                "jumppage": jumppage,
                "pagesize": pagesize,
                "begintime": begintime,
                "endtime": endtime,
                "domain": domain,
                "priority": priority,
                "search": search
              }).done(function (res) {
                // console.log("getRsyslogsByPage res:", domain);
                var info = _jquery["default"].parseJSON(res);

                if (!info.succeed) {
                  console.log("getRsyslogsByPage err:", res);
                  (0, _jquery["default"])("#loading-fallback").hide();
                  return;
                }

                var data = info.data.log;
                g_syslogs_bak = data;
                show_syslogs_page(data);
                (0, _jquery["default"])("#loading-fallback").hide();
              }).fail(function (exception, err) {
                console.log("getRsyslogsByPage err:", err); //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
              });
            },
            handleCurrentChange: function handleCurrentChange(val) {
              //发请求，传递当前页和每页数据大小，得到当前页数据
              g_cur_page = val;
              console.log("set g_cur_page to:", val);
              var http = cockpit.http({
                "port": 9091
              });
              var jumppage = String(g_cur_page);
              var pagesize = String(g_page_size);
              var begintime = (0, _jquery["default"])("#datepicker1").val();
              var endtime = (0, _jquery["default"])("#datepicker2").val();
              var domain = (0, _jquery["default"])("#services-domain").children("option:selected").val();
              var priority = (0, _jquery["default"])("#services-priority").children("option:selected").val();
              var search = (0, _jquery["default"])("#services-search").val();
              (0, _jquery["default"])("#loading-fallback").show();
              http.get("/getRsyslogsByPage", {
                "jumppage": jumppage,
                "pagesize": pagesize,
                "begintime": begintime,
                "endtime": endtime,
                "domain": domain,
                "priority": priority,
                "search": search
              }).done(function (res) {
                // console.log("getRsyslogsByPage res:", domain);
                var info = _jquery["default"].parseJSON(res);

                if (!info.succeed) {
                  console.log("getRsyslogsByPage err:", res);
                  (0, _jquery["default"])("#loading-fallback").hide();
                  return;
                }

                var data = info.data.log;
                g_syslogs_bak = data;
                show_syslogs_page(data);
                (0, _jquery["default"])("#loading-fallback").hide();
              }).fail(function (exception, err) {
                console.log("getRsyslogsByPage err:", err); //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
              });
            }
          },
          data: {
            current_page: g_cur_page,
            page_size: g_page_size,
            total: g_total_size
          }
        });
      } else {
        g_vue_pagination.current_page = g_cur_page;
        g_vue_pagination.page_size = g_page_size;
        g_vue_pagination.total = g_total_size;
      }

      for (var id in domain) {
        (0, _jquery["default"])("#services-domain").append((0, _jquery["default"])("<option>").text(domain[id]));
      }

      g_syslogs_bak = data;
      show_syslogs_page(data);
      (0, _jquery["default"])("#loading-fallback").hide();
    })["catch"](function (err) {
      console.log("getClientInfo err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    }); // fix -> fun() 

    syslogMessageOperation();
    registerSyslogsEvent();
  }

  function has_special_chars(str) {
    var arr = ["&", "\\", "/", "*", ">", "<", "@", "!"];

    for (var i = 0; i < arr.length; i++) {
      for (var j = 0; j < str.length; j++) {
        if (arr[i] == str.charAt(j)) {
          return true;
        }
      }
    }

    return false;
  }

  (0, _jquery["default"])('#services-filter li').on('click', function () {
    (0, _jquery["default"])('#services-filter li').removeClass('active').removeAttr('aria-current');
    (0, _jquery["default"])(this).addClass('active').attr('aria-current', true);
    var pattern = (0, _jquery["default"])(this).attr('data-pattern');

    if (pattern == "syslogs") {
      cockpit.location.go(["syslogs"]);
      render_syslogs();
    }
  }); // 根据 url 初始化渲染页面

  (0, _jquery["default"])("#services-filter li").removeClass('active').removeAttr('aria-current');
  render_syslogs();
}
/* These add themselves to jQuery so just including is enough */


cockpit.translate();
var _ = cockpit.gettext;

_moment["default"].locale(cockpit.language);

if (window.location.pathname.indexOf("manager/logs.html") > 0) {
  syslogs_init();
}