"use strict";

var _jquery = _interopRequireDefault(require("jquery"));

var _mustache = _interopRequireDefault(require("mustache"));

var _moment = _interopRequireDefault(require("moment"));

var _journal = _interopRequireDefault(require("journal"));

require("patterns");

var _jqmeter = _interopRequireDefault(require("./jqmeter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//import cockpit from "cockpit";
//import "bootstrap-datepicker/dist/js/bootstrap-datepicker";
//import "bootstrap-datepicker/dist/locales/bootstrap-datepicker.zh-CN.min";
//import "bootstrap-datepicker/js/bootstrap-datepicker";
//import "bootstrap-datepicker/js/locales/bootstrap-datepicker.zh-CN";
function show_error_dialog(title, message) {
  if (message) {
    (0, _jquery["default"])("#error-popup-title").text(title);
    (0, _jquery["default"])("#error-popup-message").text(message);
  } else {
    (0, _jquery["default"])("#error-popup-title").text(_("Error"));
    (0, _jquery["default"])("#error-popup-message").text(title);
  }

  (0, _jquery["default"])("#show-error-dialog").click();
}

function randomString(e) {
  e = e || 32;
  var t = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678",
      a = t.length,
      n = "";

  for (var i = 0; i < e; i++) {
    n += t.charAt(Math.floor(Math.random() * a));
  }

  return n;
}

function update_init() {
  console.log("update_init");
  var softrepo_units_template = (0, _jquery["default"])("#softrepo-units-tmpl").html();

  _mustache["default"].parse(softrepo_units_template);

  var reporule_units_template = (0, _jquery["default"])("#reporule-units-tmpl").html();

  _mustache["default"].parse(reporule_units_template);

  var empty_template = (0, _jquery["default"])("#softrepo-empty-tmpl").html();

  _mustache["default"].parse(empty_template);

  var repostrategy_units_template = (0, _jquery["default"])("#repostrategy-units-tmpl").html();

  _mustache["default"].parse(repostrategy_units_template);

  var updatestrategy_units_template = (0, _jquery["default"])("#updatestrategy-units-tmpl").html();

  _mustache["default"].parse(updatestrategy_units_template);

  var updaterule_units_template = (0, _jquery["default"])("#updaterule-units-tmpl").html();

  _mustache["default"].parse(updaterule_units_template);

  var g_softrepos_bak = [];
  var g_repostrategies_bak = [];
  var g_updatestrategies_bak = [];
  var g_reporules_bak = [];
  var g_updaterules_bak = [];
  var g_asserts_bak = [];
  var intv = 0; // 分页界面的相关变量放在这做成全局变量

  var g_vue_pagination;
  var g_cur_page = 1;
  var g_page_size = 20;
  var vue_choose_softrepos;
  var vue_choose_softrepospkgs;
  var vue_choose_asserts;
  var vue_choose_repo_asserts;
  var vuedata;

  function getAssertById(assertid) {
    for (var i = 0; i < g_asserts_bak.length; i++) {
      if (g_asserts_bak[i].assertid == assertid) {
        return g_asserts_bak[i];
      }
    }

    return false;
  }

  function getRepoRuleById(id) {
    for (var i = 0; i < g_reporules_bak.length; i++) {
      if (g_reporules_bak[i].id == id) {
        return g_reporules_bak[i];
      }
    }

    return false;
  }

  function getUpdateRuleById(id) {
    for (var i = 0; i < g_updaterules_bak.length; i++) {
      if (g_updaterules_bak[i].id == id) {
        return g_updaterules_bak[i];
      }
    }

    return false;
  }

  function getRepoStrategyById(id) {
    for (var i = 0; i < g_repostrategies_bak.length; i++) {
      if (g_repostrategies_bak[i].id == id) {
        return g_repostrategies_bak[i];
      }
    }

    return false;
  }

  function getUpdateStrategyById(id) {
    for (var i = 0; i < g_updatestrategies_bak.length; i++) {
      if (g_updatestrategies_bak[i].id == id) {
        return g_updatestrategies_bak[i];
      }
    }

    return false;
  }

  function getSoftRepoById(id) {
    for (var i = 0; i < g_softrepos_bak.length; i++) {
      if (g_softrepos_bak[i].id == id) {
        return g_softrepos_bak[i];
      }
    }

    return false;
  }

  function show_reporules_page() {
    // 未使用
    console.log("show_reporules_page");
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var header = {
      Name: "名称",
      Straname: "",
      Applyto: "应用到",
      Status: "规则状态",
      Operate: "操作"
    }; //debugger

    var units = [];

    for (var i = 0; i < g_reporules_bak.length; i++) {
      var unit = g_reporules_bak[i];
      var applytotext = "";
      var assertsarr = unit.applyto.split(";");

      for (var _i = 0; _i < assertsarr.length; _i++) {
        if (!assertsarr[_i] || assertsarr[_i].length < 1) {
          continue;
        }

        var asserttmp = getAssertById(assertsarr[_i]);
        applytotext = applytotext + "资产：" + asserttmp.assertip + "-" + asserttmp.assertname + ";";
      }

      unit.applytotext = applytotext;

      try {
        unit.straname = unit.stracontent;
      } catch (e) {
        console.log(e);
      }

      if (unit.applycount.length < 1) {
        unit.status = "下发中";
      } else {
        try {
          var applyjson = _jquery["default"].parseJSON(unit.applycount);

          var keys = Object.keys(applyjson);

          for (var _i2 = 0; _i2 < keys.length; _i2++) {
            if (applyjson[keys[_i2]]["applycount"] < unit.editcount) {
              // 说明还是上次的下发结果
              unit.status = "尚未下发";
              break;
            }

            if (applyjson[keys[_i2]]["result"] != "succeed") {
              // 只要有一个下发失败，就认为下发失败
              unit.status = "下发失败";
              break;
            }
          } // 如果全部都成功，才认为下发成功


          if (!unit.status || unit.status.length < 1) {
            unit.status = "下发成功";
          }
        } catch (e) {
          console.log(e);
        }
      } // 匹配搜索字符串


      if (!current_text_filter || unit.name.indexOf(current_text_filter) != -1) {
        units.push(unit);
      }
    } // 分页展示


    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-update-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);
            show_reporules_page(g_reporules_bak); //registerAssertsEvent();

            ruleDownloadOperation();
            repoRuleMoreOperation();
          },
          handleCurrentChange: function handleCurrentChange(val) {
            g_cur_page = val;
            console.log("set g_cur_page to:", val);
            show_reporules_page(g_reporules_bak); //registerAssertsEvent();

            ruleDownloadOperation();
            repoRuleMoreOperation();
          }
        },
        data: {
          current_page: g_cur_page,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      g_vue_pagination.current_page = g_cur_page;
      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    } // 只展示这一页的数据


    units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;
    if (units.length > 0) text = _mustache["default"].render(reporule_units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template);
    (0, _jquery["default"])("#reporule-list").html(text);
    (0, _jquery["default"])("#software-list").html("");
    (0, _jquery["default"])("#repostrategy-list").html("");
    (0, _jquery["default"])("#updatestrategy-list").html("");
    (0, _jquery["default"])("#updaterule-list").html("");
  }

  function show_updaterules_page() {
    console.log("show_updaterules_page");
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var header = {
      Name: "名称",
      // Straname: "策略名称",
      Reponame: "软件源",
      Pkgname: "软件包",
      Applyto: "应用到",
      Status: "规则状态",
      Operate: "操作"
    }; //debugger

    var units = [];

    var _loop = function _loop(i) {
      var unit = g_updaterules_bak[i];
      var applytotext = "";
      var assertsarr = unit.applyto.split(";");

      var applycount = _jquery["default"].parseJSON(unit.applycount);

      var stracontent = _jquery["default"].parseJSON(unit.stracontent);

      var deleted = [];

      for (var _i3 = 0; _i3 < assertsarr.length; _i3++) {
        if (!assertsarr[_i3] || assertsarr[_i3].length < 1) {
          continue;
        }

        var asserttmp = getAssertById(assertsarr[_i3]);

        if (!asserttmp.assertip) {
          // 过滤已删除的 添加到已删除列表
          deleted.push(assertsarr[_i3]);
          continue;
        }

        applytotext = applytotext + "资产：" + asserttmp.assertip + "-" + asserttmp.assertname + ";";
      }

      unit.applytotext = applytotext; // try {
      //     unit.straname = unit.stracontent;
      // } catch(e) {
      //     console.log(e)
      // }

      unit.reponame = [];
      unit.pkgname = [];

      _jquery["default"].each(stracontent, function (key, v) {
        unit.reponame.push(key);
        unit.pkgname.push(v);
      });

      unit.reponamep = unit.reponame.toString().replace(/\,/g, "\n");
      unit.pkgnamep = unit.pkgname.toString().replace(/\,/g, "\n");
      unit.applytop = unit.applytotext.replace(/\;/g, "\n"); // 如果是失败状态要判断是不是所有失败的都在已删除列表里
      // 如果有一项失败的不在删除列表里则返回失败，全在则返回成功

      statusmap = {
        donwlaod: "下发中",
        redownload: "下发中",
        processing: "下发中",
        succeed: "下发成功",
        failed: function failed() {
          var flag = true;

          _jquery["default"].each(applycount, function (i, v) {
            if (v.result != "succeed") {
              if (_jquery["default"].inArray(i, deleted) == -1) {
                // 存在返回0,不存在返回-1
                flag = false;
                return false;
              }
            }
          });

          return !flag ? "下发失败" : "下发成功";
        }
      };
      var jsstatus = unit.status;

      _jquery["default"].each(statusmap, function (i, v) {
        if (i == jsstatus) {
          unit.status = v;
        }
      });

      unit.ruleid = g_updaterules_bak[i].id; // if (unit.status != "donwload" && unit.status != "redownload") {
      //     unit.status = "下发中";
      // } else if (unit.status == "succeed"){
      //     unit.status = "下发成功";
      // } else if (unit.status == "failed"){
      //     unit.status = "下发失败";
      // }else {
      //     unit.status = "错误";
      // }
      // try {
      //     let applyjson = $.parseJSON(unit.applycount);
      //     let keys = Object.keys(applyjson);
      //     for (let i=0;i<keys.length;i++) {
      //         if (applyjson[keys[i]]["applycount"] < unit.editcount) {
      //             // 说明还是上次的下发结果
      //             if(applyjson[keys[i]]["result"] == "processing"){
      //                 unit.status = "下发中";
      //             }else{
      //                 unit.status = "尚未下发";
      //             }
      //         }
      //         if (applyjson[keys[i]]["result"] == "failed") {
      //             // 只要有一个下发失败，就认为下发失败
      //             unit.status = "下发失败";
      //         }
      //     }
      //     // 如果全部都成功，才认为下发成功
      //     for (let i=0;i<keys.length;i++) {
      //         unit.status = "下发成功";
      //     }
      // } catch(e) {
      //     console.log(e)
      // }
      // console.log(unit);
      //units.push(unit);
      // 匹配搜索字符串

      if (!current_text_filter || unit.name.indexOf(current_text_filter) != -1) {
        units.push(unit);
      }
    };

    for (var i = 0; i < g_updaterules_bak.length; i++) {
      var statusmap;

      _loop(i);
    } // 分页展示


    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-update-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);
            show_updaterules_page(g_updaterules_bak); //registerAssertsEvent();

            ruleDownloadOperation();
            updateRuleMoreOperation();
          },
          handleCurrentChange: function handleCurrentChange(val) {
            g_cur_page = val;
            console.log("set g_cur_page to:", val);
            show_updaterules_page(g_updaterules_bak); //registerAssertsEvent();

            ruleDownloadOperation();
            updateRuleMoreOperation();
          }
        },
        data: {
          current_page: g_cur_page,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      g_vue_pagination.current_page = g_cur_page;
      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    } // 只展示这一页的数据


    units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;
    if (units.length > 0) text = _mustache["default"].render(updaterule_units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template); //debugger

    (0, _jquery["default"])("#reporule-list").html("");
    (0, _jquery["default"])("#software-list").html("");
    (0, _jquery["default"])("#repostrategy-list").html("");
    (0, _jquery["default"])("#updatestrategy-list").html("");
    (0, _jquery["default"])("#updaterule-list").html(text);
  }

  function getVuedataByAssertsAndGroups(info) {
    vuedata = [];
    var allGroupAsserts = [];
    var allasserts = info["allasserts"];

    function getAssertsById(id) {
      for (var i = 0; i < allasserts.length; i++) {
        if (allasserts[i].assertid == id) {
          return allasserts[i];
        }
      }

      return {};
    }

    for (var i = 0; i < info["allgroups"].length; i++) {
      var grouptmp = info["allgroups"][i];
      var unit = {
        id: grouptmp.groupid,
        label: "分组：" + grouptmp.groupname,
        children: []
      };
      var tmparr = grouptmp.groupasserts.split(";");

      for (var k = 0; k < tmparr.length; k++) {
        if (!tmparr[k] || tmparr[k].length < 1) {
          continue;
        }

        var asserttmp = getAssertsById(tmparr[k]);

        if (asserttmp.assertip == "localhost") {
          continue;
        }

        if (!asserttmp.assertip) {
          // 过滤掉已经删除的
          continue;
        }

        unit.children.push({
          id: tmparr[k],
          label: "资产：" + asserttmp.assertip + "-" + asserttmp.assertname
        });

        if (allGroupAsserts.indexOf(tmparr[k]) < 0) {
          allGroupAsserts.push(tmparr[k]);
        }
      }

      if (unit.children.length == 0) {
        continue;
      }

      vuedata.push(unit);
    }

    for (var _i4 = 0; _i4 < info["allasserts"].length; _i4++) {
      var _asserttmp = info["allasserts"][_i4];

      if (allGroupAsserts.indexOf(_asserttmp.assertid) >= 0) {
        continue;
      }

      if (_asserttmp.assertip == "localhost") {
        continue;
      }

      var _unit = {
        id: _asserttmp.assertid,
        label: "资产：" + _asserttmp.assertip + "-" + _asserttmp.assertname
      };
      vuedata.push(_unit);
    }

    return vuedata;
  }

  function getVuedataBySoftRepos(info) {
    vuedata = []; //let allrepostrategies = info;

    for (var i = 0; i < info.length; i++) {
      var softrepo = info[i];
      var unit = {
        id: softrepo.id,
        label: "软件源:" + softrepo.name
      };
      vuedata.push(unit);
    } //debugger


    return vuedata;
  }

  function getVuedataBySoftRepo(info) {
    // 获取软件源和包含的包名
    vuedata = [];

    for (var i = 0; i < info.length; i++) {
      var repotmp = info[i];
      var unit = {
        id: repotmp.id,
        label: "软件源: " + repotmp.name,
        children: []
      };
      var tmparr = repotmp.pkglist.split("\n");

      for (var j = 0; j < tmparr.length; j++) {
        if (tmparr[j].length == 0) {
          continue;
        }

        unit.children.push({
          id: repotmp.name + ":" + tmparr[j],
          label: "软件包: " + tmparr[j]
        });
      }

      vuedata.push(unit);
    }

    return vuedata;
  }

  function render_reporules() {
    console.log("render_reporules");
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getRules", {
      "type": "repo"
    }).fail(function (err) {
      console.log("getRules err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    }).done(function (res) {
      // console.log("getRules res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRules err:", res);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }

      info = info.data;
      g_reporules_bak = info; // 规则里面还要展示应用到的资产，需要获取资产详细信息

      http.get("/getAsserts").fail(function (err) {
        console.log("getAsserts err:", err);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }).done(function (res) {
        // console.log("getAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getAsserts err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        info = info.data;
        g_asserts_bak = info;
        show_reporules_page();
        ruleDownloadOperation();
        repoRuleMoreOperation();
        (0, _jquery["default"])("#loading-fallback").hide();
      });
    });
  }

  function render_updaterules() {
    console.log("render_updaterules");
    clearInterval(intv);
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getRules", {
      "type": "update"
    }).fail(function (err) {
      console.log("getRules err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    }).done(function (res) {
      // console.log("getRules res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRules err:", res);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }

      info = info.data; // console.log(info);

      g_updaterules_bak = info; // 规则里面还要展示应用到的资产，需要获取资产详细信息

      http.get("/getAsserts").fail(function (err) {
        console.log("getAsserts err:", err);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }).done(function (res) {
        // console.log("getAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getAsserts err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        info = info.data;
        g_asserts_bak = info;
        show_updaterules_page();
        ruleDownloadOperation();
        updateRuleMoreOperation();

        _jquery["default"].each(g_updaterules_bak, function (i, v) {
          if (!v.isdelete == 0 || v.deletecount) {
            (0, _jquery["default"])("#data-rule-" + v.id).attr("disabled", true);
            (0, _jquery["default"])("#update-rule-" + v.id).text("正在删除");
          }
        });

        (0, _jquery["default"])("#loading-fallback").hide(); // 定时器获取规则状态

        var dlsucceed = /\u4e0b\u53d1\u4e2d/;
        intv = setInterval(function () {
          var isdone = true;

          for (var i = 0; i < g_updaterules_bak.length; i++) {
            if (!g_updaterules_bak[i].isdelete == 0 || g_updaterules_bak[i].deletecount) {
              continue;
            }

            if (dlsucceed.test(g_updaterules_bak[i].status)) {
              isdone = false;
              http.get("/getRuleState", {
                "type": "update"
              }).fail(function (err) {
                console.log("getRules of update err:", err);
              }).done(function (res) {
                var info = _jquery["default"].parseJSON(res);

                if (!info.succeed) {
                  console.log("getRules of update err:", res);
                }

                info = info.data;
                g_updaterules_bak = info ? info : g_updaterules_bak;
              });
            } else {
              for (var k in g_updaterules_bak) {
                var arule = g_updaterules_bak[k];
                var rstatus = "下发中";

                if (arule["status"] == "succeed" || arule["status"] == "下发成功") {
                  rstatus = "下发成功";
                } else if (arule["status"] == "下发中" || arule["status"] == "redownload" || arule["status"] == "processing") {
                  isdone = false;
                  g_updaterules_bak[k]["status"] = "下发中";
                } else if (arule["isdelete"]) {
                  rstatus = "正在删除";
                } else {
                  rstatus = "下发失败";
                }

                (0, _jquery["default"])("#update-rule-" + arule["id"]).text(rstatus);
              }
            }
          }

          if (isdone) {
            clearInterval(intv);
          }
        }, 5000);
      });
    });
  }

  function show_softrepos_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    //let pattern = $('#services-filter li.active').attr('data-pattern');
    console.log("show_softrepos_page");
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var units = [];

    for (var i = 0; i < info.length; i++) {
      var repo = info[i];
      var newinfo = repo["repoinfo"].replace(/\;/g, "\n");
      var tmp = {
        "ID": repo["id"],
        "Name": repo["name"],
        "Tag": repo["tag"],
        "BuildTime": repo["buildtime"],
        "PkgList": repo["pkglist"],
        "RepoFile": repo["repofile"],
        "RepoInfo": repo["repoinfo"],
        "Tinfo": newinfo,
        "IP": repo["ip"],
        "CVE": repo["iscve"],
        "CveInfo": repo["cveinfo"],
        "Status": repo["iseffective"]
      }; //units.push(tmp);

      if (repo["iscve"]) {
        tmp["CVE"] = "是";
      } else {
        tmp["CVE"] = "否";
      }

      if (!current_text_filter || repo["name"].indexOf(current_text_filter) != -1) {
        units.push(tmp);
      }
    }

    var header = {
      ID: "ID",
      Name: "Name",
      Tag: "Tag",
      BuildTime: "BuildTime",
      PkgList: "PkgList",
      RepoFile: "RepoFile",
      RepoInfo: "RepoInfo",
      IP: "IP",
      CVE: "CVE",
      CveInfo: "CveInfo",
      Status: "Status",
      Tinfo: "Tinfo"
    }; // 分页展示

    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-update-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);
            show_softrepos_page(g_softrepos_bak); //registerAssertsEvent();

            softrepoAddOperation();
            softrepoDeleteOperation();
            softrepoPkglistOperation();
          },
          handleCurrentChange: function handleCurrentChange(val) {
            g_cur_page = val;
            console.log("set g_cur_page to:", val);
            show_softrepos_page(g_softrepos_bak); //registerAssertsEvent();

            softrepoAddOperation();
            softrepoDeleteOperation();
            softrepoPkglistOperation();
          }
        },
        data: {
          current_page: g_cur_page,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      g_vue_pagination.current_page = g_cur_page;
      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    } // 只展示这一页的数据


    units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;
    if (units.length > 0) text = _mustache["default"].render(softrepo_units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template);
    (0, _jquery["default"])("#software-list").html(text);
    (0, _jquery["default"])("#repostrategy-list").html("");
    (0, _jquery["default"])("#updatestrategy-list").html("");
    (0, _jquery["default"])("#reporule-list").html("");
    (0, _jquery["default"])("#updaterule-list").html("");
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function show_repostrategies_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    //let pattern = $('#services-filter li.active').attr('data-pattern');
    console.log("show_repostrategies_page");
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var units = [];

    for (var i = 0; i < info.length; i++) {
      var strategy = info[i];
      var tmp = {
        "ID": strategy["id"],
        "Name": strategy["name"],
        "RepoList": strategy["reponamelist"]
      }; //units.push(tmp);

      if (!current_text_filter || strategy["name"].indexOf(current_text_filter) != -1) {
        units.push(tmp);
      }
    }

    var header = {
      ID: "ID",
      Name: "Name",
      RepoList: "RepoList"
    }; // 分页展示

    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-update-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);
            show_repostrategies_page(g_repostrategies_bak); //registerAssertsEvent();

            repoStrategyDeleteOperatin();
          },
          handleCurrentChange: function handleCurrentChange(val) {
            g_cur_page = val;
            console.log("set g_cur_page to:", val);
            show_repostrategies_page(g_repostrategies_bak); //registerAssertsEvent();

            repoStrategyDeleteOperatin();
          }
        },
        data: {
          current_page: g_cur_page,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      g_vue_pagination.current_page = g_cur_page;
      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    } // 只展示这一页的数据


    units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;
    if (units.length > 0) text = _mustache["default"].render(repostrategy_units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template); //console.log(text)
    //debugger

    (0, _jquery["default"])("#software-list").html("");
    (0, _jquery["default"])("#repostrategy-list").html(text);
    (0, _jquery["default"])("#updatestrategy-list").html("");
    (0, _jquery["default"])("#reporule-list").html("");
    (0, _jquery["default"])("#updaterule-list").html("");
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function show_updatestrategies_page(info) {
    // 这个函数不申请数据，只是重新做下匹配
    //let pattern = $('#services-filter li.active').attr('data-pattern');
    console.log("show_updatestrategies_page");
    var current_text_filter = (0, _jquery["default"])('#services-text-filter').val().toLowerCase();
    var units = [];

    for (var i = 0; i < info.length; i++) {
      var strategy = info[i];
      var tmp = {
        "ID": strategy["id"],
        "Name": strategy["name"],
        "PkgList": strategy["pkglist"]
      }; //units.push(tmp);

      if (!current_text_filter || strategy["name"].indexOf(current_text_filter) != -1) {
        units.push(tmp);
      }
    }

    var header = {
      ID: "ID",
      Name: "Name",
      PkgList: "PkgList"
    }; // 分页展示

    if (!g_vue_pagination) {
      g_vue_pagination = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#vue-update-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size = val;
            console.log("set g_page_size to:", val);
            show_updatestrategies_page(g_updatestrategies_bak); //registerAssertsEvent();

            updateStrategyDeleteOperatin();
          },
          handleCurrentChange: function handleCurrentChange(val) {
            g_cur_page = val;
            console.log("set g_cur_page to:", val);
            show_updatestrategies_page(g_updatestrategies_bak); //registerAssertsEvent();

            updateStrategyDeleteOperatin();
          }
        },
        data: {
          current_page: g_cur_page,
          page_size: g_page_size,
          total: units.length
        }
      });
    } else {
      g_vue_pagination.current_page = g_cur_page;
      g_vue_pagination.page_size = g_page_size;
      g_vue_pagination.total = units.length;
    } // 只展示这一页的数据


    units = units.slice((g_cur_page - 1) * g_page_size, g_cur_page * g_page_size);
    var text;
    if (units.length > 0) text = _mustache["default"].render(updatestrategy_units_template, {
      table_head: header,
      units: units
    });else text = _mustache["default"].render(empty_template); //console.log(text)
    //debugger

    (0, _jquery["default"])("#software-list").html("");
    (0, _jquery["default"])("#repostrategy-list").html("");
    (0, _jquery["default"])("#reporule-list").html("");
    (0, _jquery["default"])("#updaterule-list").html("");
    (0, _jquery["default"])("#updatestrategy-list").html(text);
    (0, _jquery["default"])("#loading-fallback").hide();
  }

  function render_softrepos() {
    console.log("render_softrepos");
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getSoftRepos").done(function (res) {
      // console.log("getSoftRepos res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getSoftRepos err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_softrepos_bak = info;
      show_softrepos_page(info);
      softrepoAddOperation();
      softrepoDeleteOperation();
      softrepoPkglistOperation();
      (0, _jquery["default"])("#loading-fallback").hide();
    })["catch"](function (err) {
      console.log("getClientInfo err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  function render_repostrategies() {
    console.log("render_repostrategies");
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getRepoStrategies").done(function (res) {
      console.log("getRepoStrategies res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRepoStrategies err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_repostrategies_bak = info;
      show_repostrategies_page(info); //repostrategyAddOperation();

      repoStrategyDeleteOperatin();
      (0, _jquery["default"])("#loading-fallback").hide();
    })["catch"](function (err) {
      console.log("getRepoStrategies err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  function render_updatestrategies() {
    console.log("render_updatestrategies");
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getUpdateStrategies").done(function (res) {
      // console.log("getUpdateStrategies res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getUpdateStrategies err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_updatestrategies_bak = info;
      show_updatestrategies_page(info); //repostrategyAddOperation();

      updateStrategyDeleteOperatin();
      (0, _jquery["default"])("#loading-fallback").hide();
    })["catch"](function (err) {
      console.log("getUpdateStrategies err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  (0, _jquery["default"])('#services-text-filter').change(function (e) {
    //let filter-text = $("#services-text-filter").val();
    //alert($("#services-text-filter").val());
    if (window.location.href.indexOf("#/repostrategy") > 0) {
      render_repostrategies();
    } else if (window.location.href.indexOf("#/reporule") > 0) {
      render_reporules();
    } else if (window.location.href.indexOf("#/updatestrategy") > 0) {
      render_updatestrategies();
    } else if (window.location.href.indexOf("#/updaterule") > 0) {
      render_updaterules();
    } else {
      render_softrepos();
    }
  });

  function softrepoAddOperation() {
    //alert("nihao")
    (0, _jquery["default"])("#softrepo-add").unbind("click").click(function (e) {
      (0, _jquery["default"])("#softrepo-add-msg").text("");
      (0, _jquery["default"])("#jsonfile").val("");
      (0, _jquery["default"])("#rpmfile").val("");
      (0, _jquery["default"])("#jqmeter-container-upload").html("");
    });
    (0, _jquery["default"])("#softrepo-add-confirm").unbind("click").click(function (e) {
      if ((0, _jquery["default"])("#jsonfile").val() == "" || (0, _jquery["default"])("#rpmfile").val() == "") {
        (0, _jquery["default"])("#softrepo-add-msg").text("上传文件不能为空");
        setTimeout(function (e) {
          (0, _jquery["default"])("#softrepo-add-close").click();
        }, 1500);
        return;
      }

      var jsonfile = (0, _jquery["default"])("#jsonfile").prop("files");
      var rpmfile = (0, _jquery["default"])("#rpmfile").prop("files"); // console.log("jsonfile:", jsonfile);
      // console.log("rpmfile", rpmfile);

      var jsonfilename = jsonfile[0].name;
      var jsonfilenamesave = "/tmp/" + jsonfile[0].name + "." + randomString(6);
      ;
      var jsonreader = new FileReader();
      jsonreader.readAsBinaryString(jsonfile[0]);
      var rpmname = "rpmfile." + randomString(6);
      var rpmfilename = (0, _jquery["default"])('#rpmfile')[0].files[0].name; // 保存在服务器上的文件路径，cockpit 的上传接口会保存在固定的位置

      var rpmfilenamesave = "/tmp/cockpit-upload-" + rpmname + "-" + rpmfilename;
      var checkProgressFlag = 1;

      function doAddRepo() {
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/addSoftRepo", {
          "jsonfile": jsonfilenamesave,
          "rpmfile": rpmfilenamesave
        }).done(function (res) {
          console.log("addSoftRepo res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            return (0, _jquery["default"])("#softrepo-add-msg").text("软件源添加失败：" + info.error);
          }

          (0, _jquery["default"])("#softrepo-add-msg").text("软件源添加成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#softrepo-add-msg").text("");
            (0, _jquery["default"])("#softrepo-add-close").click();
            render_softrepos();
          }, 1000);
        }).fail(function (err) {
          console.log(err);
          return (0, _jquery["default"])("#softrepo-add-msg").text("软件源添加失败");
        });
      }

      function checkProgress() {
        if (!checkProgressFlag) {
          return;
        }

        var http = cockpit.http({
          "port": 9091
        });
        http.get("/getUploadProgress", {
          "filepath": rpmfilenamesave
        }).done(function (res) {
          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("checkProgress failed ", res);
            return setTimeout(checkProgress, 2000);
          } //console.log("get upload progress:", info.data)


          var progress = parseInt(info.data);
          (0, _jquery["default"])("#jqmeter-container-upload").html("");

          _jqmeter["default"].jQMeter_func('#jqmeter-container-upload', {
            "goal": "100",
            "raised": progress.toString()
          });

          if (progress >= 100) {
            (0, _jquery["default"])("#softrepo-add-msg").text("正在生成软件源，请耐心等待");
            checkProgressFlag = 0;
          }

          setTimeout(checkProgress, 2000);
        }).fail(function (e) {
          console.log("checkProgress failed,", e);
          return setTimeout(checkProgress, 2000);
        });
      }

      function uploadRpmfile() {
        (0, _jquery["default"])("#softrepo-add-msg").text("文件正在上传，请耐心等待"); // 大文件采用 cockpit 的文件上传接口来上传

        var formdata = new FormData();
        formdata.append(rpmname, (0, _jquery["default"])('#rpmfile')[0].files[0]);

        _jquery["default"].ajax({
          url: "/cockpit/upload",
          dataType: 'json',
          type: 'POST',
          timeout: 3600000,
          //async: false,
          //cache : false,
          data: formdata,
          processData: false,
          contentType: false,
          success: function success(result) {
            console.log("upload rpm file succeed:", rpmfilenamesave); // disable checkprocess timer

            checkProgressFlag = 0;
            (0, _jquery["default"])("#jqmeter-container-upload").html("");

            _jqmeter["default"].jQMeter_func('#jqmeter-container-upload', {
              "goal": "100",
              "raised": "100"
            });

            (0, _jquery["default"])("#softrepo-add-msg").text("正在生成软件源，请耐心等待");
            doAddRepo();
          },
          error: function error(err) {
            console.log(err);
            checkProgressFlag = 0;
            (0, _jquery["default"])("#softrepo-add-msg").text("上传软件包失败");
          }
        });

        setTimeout(checkProgress, 1000);
      } // 上传 json 文件


      jsonreader.onload = function () {
        console.log("文件读取完毕 " + jsonfile[0].name);
        var baseString = jsonreader.result;

        try {
          _jquery["default"].parseJSON(baseString);
        } catch (err) {
          return (0, _jquery["default"])("#softrepo-add-msg").text("Json文件格式错误，请检查");
        }

        var jsonobj = _jquery["default"].parseJSON(baseString); // 上传前判断是否存在数据库中


        var http = cockpit.http({
          "port": 9091
        });
        http.post("/checkSoftRepo", {
          "reponame": jsonobj.name
        }).done(function (res) {
          console.log("checkSoftRepo res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            return (0, _jquery["default"])("#softrepo-add-msg").text("软件源查询失败" + info.error);
          }

          var jsonwriter = cockpit.file(jsonfilenamesave, {
            binary: true
          });
          jsonwriter.replace(baseString).done(function (tag) {
            console.log("upload json file succeed:", jsonfilenamesave, tag);
            uploadRpmfile();
            jsonwriter.close();
          }).fail(function (error) {
            console.log("upload json file failed:", jsonfilenamesave, error);
            jsonwriter.close();
          });
        }).fail(function (err) {
          console.log(err);
          return (0, _jquery["default"])("#softrepo-add-msg").text("软件源添加失败");
        });
      };
    });
  }

  function softrepoPkglistOperation() {
    (0, _jquery["default"])("button.softrepo-pkglist").unbind("click").click(function (e) {
      var softrepoid = (0, _jquery["default"])(this).data("softrepo-id");
      var softrepounit = getSoftRepoById(softrepoid); //alert(softrepoid);

      (0, _jquery["default"])("#softrepo-pkglist-msg").text(softrepounit.pkglist);
    });
  }

  function softrepoDeleteOperation() {
    (0, _jquery["default"])("button.softrepo-del").unbind("click").click(function (e) {
      var softrepoid = (0, _jquery["default"])(this).data("softrepo-id");
      var softrepounit = getSoftRepoById(softrepoid); //alert(strategyid);

      (0, _jquery["default"])("#softrepo-del-msg").text("确认要删除软件源 " + softrepounit.name + " 吗？");
      console.log(softrepoid);
      (0, _jquery["default"])("#softrepo-del-confirm").unbind("click").click(function (e) {
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delSoftRepo", {
          id: softrepoid
        }).fail(function (err) {
          console.log("delSoftRepo err:", err);
          (0, _jquery["default"])("#softrepo-del-msg").text("删除软件源失败");
        }).done(function (res) {
          console.log("delSoftRepo res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("delSoftRepo err:", res);
            (0, _jquery["default"])("#softrepo-del-msg").text("删除软件源失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#softrepo-del-msg").text("删除软件源成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#softrepo-del-close").click();
            render_softrepos();
          }, 1500);
        });
      });
    });
  }

  function ruleDownloadOperation() {
    //点击下发按钮触发后台下发
    (0, _jquery["default"])("button.download-rule-btn").unbind("click").click(function (e) {
      console.log("downloadRule");
      var ruleid = (0, _jquery["default"])(this).data("rule-id");
      var ruletype = "";
      var runit = "";

      if (window.location.href.indexOf("#/reporule") > 0) {
        ruletype = "repo";
      } else {
        ruletype = "update";
      }

      if (ruletype == "repo") {
        runit = getRepoRuleById(ruleid);
      } else if (ruletype == "update") {
        runit = getUpdateRuleById(ruleid);
      }

      (0, _jquery["default"])("#download-rule-btn-msg").text("确认要重新下发规则 " + runit.name + " 吗？");
      (0, _jquery["default"])("#download-rule-btn-confirm").unbind("click").click(function (e) {
        console.log(ruletype);
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/downloadRule", {
          id: ruleid,
          type: ruletype
        }).fail(function (err) {
          console.log("downloadRule err:", err);
          (0, _jquery["default"])("#download-rule-btn-msg").text("通知后台下发失败");
        }).done(function (res) {
          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("downloadRule err:", res);
            (0, _jquery["default"])("#download-rule-btn-msg").text("通知后台下发失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#download-rule-btn-msg").text("已通知后台下发");

          if (ruletype == "repo") {
            setTimeout(function (e) {
              (0, _jquery["default"])("#download-rule-btn-close").click();
              render_reporules();
            }, 1500);
          } else {
            setTimeout(function (e) {
              (0, _jquery["default"])("#download-rule-btn-close").click();
              render_updaterules();
            }, 1500);
          }
        });
      });
    });
  }

  function repoRuleMoreOperation() {
    // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件
    (0, _jquery["default"])(".repo-rule-opr-more").unbind("click").on("click", function (e) {
      var top = (0, _jquery["default"])(this).offset().top;
      var left = (0, _jquery["default"])(this).offset().left;
      var top1 = (0, _jquery["default"])("html").scrollTop();
      top = top - top1;
      var width = parseInt((0, _jquery["default"])(this).css("width").replace("px", "")); //对于软件源规则和软件升级规则，暂时不提供编辑功能

      (0, _jquery["default"])("button.repo-rule-edit").hide();
      (0, _jquery["default"])(".repo-rule-popup-menu").css("top", top);
      (0, _jquery["default"])(".repo-rule-popup-menu").css("left", left + width);

      if ((0, _jquery["default"])(".repo-rule-popup-menu").css("display") == "none") {
        (0, _jquery["default"])(".repo-rule-popup-menu").css("display", "inline-grid");
      } else {
        (0, _jquery["default"])(".repo-rule-popup-menu").css("display", "none");
      }

      var ruleid = (0, _jquery["default"])(this).data("rule-id");
      (0, _jquery["default"])("#repo-rule-popup-menu-private-data").data("private-data", ruleid);
    });
    (0, _jquery["default"])(".repo-rule-popup-btn").mouseover(function (e) {
      (0, _jquery["default"])(this).css("background-color", "#def3ff");
    }).mouseout(function (e) {
      (0, _jquery["default"])(this).css("background-color", "white");
    });
    (0, _jquery["default"])(window).unbind("click").on("click", function (e) {
      if (e.target.localName == "button" && (e.target.className.indexOf("repo-rule-opr-more") >= 0 || e.target.className.indexOf("repo-rule-del") >= 0 || e.target.className.indexOf("repo-rule-status") >= 0 || e.target.className.indexOf("repo-rule-edit") >= 0)) {
        return;
      }

      (0, _jquery["default"])(".repo-rule-popup-menu").css("display", "none");
    });
    (0, _jquery["default"])("button.repo-rule-status").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#repo-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getRepoRuleById(ruleid);

      try {
        (0, _jquery["default"])("#repo-rule-status-content").html("");

        var applycount = _jquery["default"].parseJSON(ruleunit.applycount);

        Object.keys(applycount).forEach(function (key) {
          // 渲染规则页面的时候已经获取过资产信息，这里直接用，不重新请求了
          var asserttmp = getAssertById(key);

          if (!asserttmp) {
            console.log("[repo-rule-status]get assert failed,assertid:", applycount[key]);
            return;
          }

          var statustext = "";

          if (applycount[key]["applycount"] < ruleunit.editcount) {
            statustext = "尚未下发";
          } else {
            if (applycount[key]["result"] == "succeed") {
              statustext = "下发成功";
            } else {
              statustext = "下发失败";
            }
          }

          var tr = "<tr><td class='text-align-left'>" + asserttmp.assertip + "</td><td>" + asserttmp.assertname + "</td><td><span class=''>" + statustext + "</span></td></tr>";
          (0, _jquery["default"])("#repo-rule-status-content").append((0, _jquery["default"])(tr));
        });
      } catch (e) {
        console.log(e);
      }
    });
    (0, _jquery["default"])("button.repo-rule-del").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#repo-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getRepoRuleById(ruleid);
      (0, _jquery["default"])("#repo-rule-del-msg").text("确认要删除规则 " + ruleunit.name + " 吗？");
      (0, _jquery["default"])("#repo-rule-del-confirm").unbind("click").click(function (e) {
        (0, _jquery["default"])("#repo-rule-del-msg").text("规则正在删除，请耐心等待");
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delRule", {
          type: "repo",
          id: ruleid
        }).fail(function (err) {
          console.log("delRule err:", err);
          (0, _jquery["default"])("#repo-rule-del-msg").text("删除规则失败");
        }).done(function (res) {
          console.log("delRule res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("delRule err:", res);
            (0, _jquery["default"])("#repo-rule-del-msg").text("删除规则失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#repo-rule-del-msg").text("删除规则成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#repo-rule-del-close").click();
            render_reporules();
          }, 1500);
        });
      });
    });
  }

  function updateRuleMoreOperation() {
    // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件
    (0, _jquery["default"])(".update-rule-opr-more").unbind("click").on("click", function (e) {
      var top = (0, _jquery["default"])(this).offset().top;
      var left = (0, _jquery["default"])(this).offset().left;
      var top1 = (0, _jquery["default"])("html").scrollTop();
      top = top - top1;
      var width = parseInt((0, _jquery["default"])(this).css("width").replace("px", "")); //对于软件源规则和软件升级规则，暂时不提供编辑功能

      (0, _jquery["default"])("button.update-rule-edit").hide();
      (0, _jquery["default"])(".update-rule-popup-menu").css("top", top);
      (0, _jquery["default"])(".update-rule-popup-menu").css("left", left + width);

      if ((0, _jquery["default"])(".update-rule-popup-menu").css("display") == "none") {
        (0, _jquery["default"])(".update-rule-popup-menu").css("display", "inline-grid");
      } else {
        (0, _jquery["default"])(".update-rule-popup-menu").css("display", "none");
      }

      var ruleid = (0, _jquery["default"])(this).data("rule-id");
      (0, _jquery["default"])("#update-rule-popup-menu-private-data").data("private-data", ruleid);
    });
    (0, _jquery["default"])(".update-rule-popup-btn").mouseover(function (e) {
      (0, _jquery["default"])(this).css("background-color", "#def3ff");
    }).mouseout(function (e) {
      (0, _jquery["default"])(this).css("background-color", "white");
    });
    (0, _jquery["default"])(window).unbind("click").on("click", function (e) {
      if (e.target.localName == "button" && (e.target.className.indexOf("update-rule-opr-more") >= 0 || e.target.className.indexOf("update-rule-del") >= 0 || e.target.className.indexOf("update-rule-status") >= 0 || e.target.className.indexOf("update-rule-edit") >= 0)) {
        return;
      }

      (0, _jquery["default"])(".update-rule-popup-menu").css("display", "none");
    });
    (0, _jquery["default"])("button.update-rule-status").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#update-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getUpdateRuleById(ruleid);

      try {
        (0, _jquery["default"])("#update-rule-status-content").html("");

        var applycount = _jquery["default"].parseJSON(ruleunit.applycount);

        Object.keys(applycount).forEach(function (key) {
          // 渲染规则页面的时候已经获取过资产信息，这里直接用，不重新请求了
          var asserttmp = getAssertById(key);
          var statustext = "";

          if (!asserttmp) {
            console.log("[update-rule-status]get assert failed,assertid:", key);
            return;
          }

          if (applycount[key]["applycount"] < ruleunit.editcount) {
            if (applycount[key]["result"] == "processing") {
              statustext = "下发中";
            } else {
              statustext = "尚未下发";
            }
          } else {
            if (applycount[key]["result"] == "succeed") {
              statustext = "下发成功";
            } else {
              statustext = "下发失败";
            }
          }

          var tr = "<tr><td class='text-align-left'>" + asserttmp.assertip + "</td><td>" + asserttmp.assertname + "</td><td><span class=''>" + statustext + "</span>" + "</td><td><buttom data-toggle='modal' class='btn btn-default assert-status'" + " data-target='#updaterule-status-dialog' arule-assert-id='" + key + "'>查看详情</buttom>" + "</td></tr>";
          (0, _jquery["default"])("#update-rule-status-content").append((0, _jquery["default"])(tr));
        });
        (0, _jquery["default"])("buttom.assert-status").unbind("click").click(function (e) {
          var buttomid = (0, _jquery["default"])(this).attr("arule-assert-id");
          (0, _jquery["default"])("#assert-status-msg").text(applycount[buttomid]["result"]);
        });
      } catch (e) {
        console.log(e);
      }
    });
    (0, _jquery["default"])("button.update-rule-del").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#update-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getUpdateRuleById(ruleid);
      (0, _jquery["default"])("#update-rule-del-msg").text("确认要删除规则 " + ruleunit.name + " 吗？");
      (0, _jquery["default"])("#update-rule-del-confirm").unbind("click").click(function (e) {
        (0, _jquery["default"])("#update-rule-del-msg").text("规则正在删除，请耐心等待");
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delRule", {
          type: "update",
          id: ruleid
        }).fail(function (err) {
          console.log("delRule err:", err);
          (0, _jquery["default"])("#update-rule-del-msg").text("删除规则失败");
        }).done(function (res) {
          console.log("delRule res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("delRule err:", res);
            (0, _jquery["default"])("#update-rule-del-msg").text("通知后台删除规则失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#update-rule-del-msg").text("成功通知后台删除规则");
          (0, _jquery["default"])("#data-rule-" + ruleid).attr("disabled", true);
          setTimeout(function (e) {
            (0, _jquery["default"])("#update-rule-del-close").click();
            render_updaterules();
          }, 1500);
        });
      });
    });
  }

  function updateStrategyDeleteOperatin() {
    (0, _jquery["default"])("button.update-strategy-del").unbind("click").click(function (e) {
      var strategyid = (0, _jquery["default"])(this).data("strategy-id");
      var strategyunit = getUpdateStrategyById(strategyid); //alert(strategyid);

      (0, _jquery["default"])("#update-strategy-del-msg").text("确认要删除策略 " + strategyunit.name + " 吗？");
      console.log(strategyid);
      (0, _jquery["default"])("#update-strategy-del-confirm").unbind("click").click(function (e) {
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delUpdateStrategy", {
          id: strategyid
        }).fail(function (err) {
          console.log("delUpdateStrategy err:", err);
          (0, _jquery["default"])("#update-strategy-del-msg").text("删除策略失败");
        }).done(function (res) {
          console.log("delUpdateStrategy res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("delUpdateStrategy err:", res);
            (0, _jquery["default"])("#update-strategy-del-msg").text("删除策略失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#update-strategy-del-msg").text("删除策略成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#update-strategy-del-close").click();
            render_updatestrategies();
          }, 1500);
        });
      });
    });
  }

  function repoStrategyDeleteOperatin() {
    (0, _jquery["default"])("button.repo-strategy-del").unbind("click").click(function (e) {
      var strategyid = (0, _jquery["default"])(this).data("strategy-id");
      var strategyunit = getRepoStrategyById(strategyid);
      (0, _jquery["default"])("#repo-strategy-del-msg").text("确认要删除策略 " + strategyunit.name + " 吗？");
      console.log(strategyid);
      (0, _jquery["default"])("#repo-strategy-del-confirm").unbind("click").click(function (e) {
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delRepoStrategy", {
          id: strategyid
        }).fail(function (err) {
          console.log("delRepoStrategy err:", err);
          (0, _jquery["default"])("#repo-strategy-del-msg").text("删除策略失败");
        }).done(function (res) {
          console.log("delRepoStrategy res:", res);

          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("delRepoStrategy err:", res);
            (0, _jquery["default"])("#repo-strategy-del-msg").text("删除策略失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#repo-strategy-del-msg").text("删除策略成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#repo-strategy-del-close").click();
            render_repostrategies();
          }, 1500);
        });
      });
    });
  }

  (0, _jquery["default"])("#repostrategy-add").unbind("click").click(function (e) {
    //info = g_softrepos_bak;
    (0, _jquery["default"])("#repostrategy-add-msg").text("");
    (0, _jquery["default"])("#repostrategy-add-name").val(""); //vue_choose_softrepos = "";
    //vue_choose_softrepos.data = [];

    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getSoftRepos").done(function (res) {
      // console.log("getSoftRepos res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getSoftRepos err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_softrepos_bak = info;
      vuedata = getVuedataBySoftRepos(g_softrepos_bak); //debugger

      if (!vue_choose_softrepos) {
        vue_choose_softrepos = new Vue({
          template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
          el: "#vue-repostrtegy-div",
          methods: {
            getCheckedNodes: function getCheckedNodes() {
              return this.$refs.tree.getCheckedNodes();
            },
            setCheckedKeys: function setCheckedKeys(data) {
              this.$refs.tree.setCheckedKeys(data);
            }
          },
          data: {
            data: vuedata,
            defaultProps: {
              children: 'children',
              label: 'label'
            }
          },
          watch: {
            data: function data(newdata, olddata) {}
          }
        });
      }

      vue_choose_softrepos.data = vuedata; //vue_choose_softrepos.setCheckedKeys([]);

      (0, _jquery["default"])("#loading-fallback").hide();
    })["catch"](function (err) {
      console.log("getClientInfo err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  });
  (0, _jquery["default"])("#reporule-add").unbind("click").click(function (e) {
    (0, _jquery["default"])("#reporule-add-straname").html("");
    (0, _jquery["default"])("#reporule-add-name").val("");
    (0, _jquery["default"])("#reporule-add-msg").text("");
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getRepoStrategies").fail(function (err) {
      console.log("getRepoStrategies err:", err);
      (0, _jquery["default"])("#reporule-add-msg").text("获取软件源策略失败");
    }).done(function (res) {
      console.log("getRepoStrategies res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRepoStrategies err:", res);
        return (0, _jquery["default"])("#reporule-add-msg").text("获取软件源策略失败：" + info.error);
      }

      info = info.data;
      g_repostrategies_bak = info;
      (0, _jquery["default"])("#reporule-add-straname").html("");

      for (var i = 0; i < g_repostrategies_bak.length; i++) {
        var html = '<option value="' + g_repostrategies_bak[i].id + '">' + g_repostrategies_bak[i].name + '</option>';
        (0, _jquery["default"])("#reporule-add-straname").append((0, _jquery["default"])(html));
      } // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
      // 先获取资产和分组信息


      http.get("/getGroupsAndAsserts").fail(function (err) {
        console.log("getGroupsAndAsserts err:", err);
        (0, _jquery["default"])("#reporule-add-msg").text("获取资产和分组失败");
      }).done(function (res) {
        // console.log("getGroupsAndAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getGroupsAndAsserts err:", res);
          return (0, _jquery["default"])("#reporule-add-msg").text("获取资产和分组失败：" + info.error);
        }

        info = info.data;
        vuedata = getVuedataByAssertsAndGroups(info);

        if (!vue_choose_repo_asserts) {
          vue_choose_repo_asserts = new Vue({
            template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
            el: "#vue-reporule-div",
            methods: {
              getCheckedNodes: function getCheckedNodes() {
                return this.$refs.tree.getCheckedNodes();
              },
              setCheckedKeys: function setCheckedKeys(data) {
                this.$refs.tree.setCheckedKeys(data);
              }
            },
            data: {
              data: vuedata,
              defaultProps: {
                children: 'children',
                label: 'label'
              }
            },
            watch: {
              data: function data(newdata, olddata) {//
              }
            }
          });
        }

        vue_choose_repo_asserts.data = vuedata;
      });
    });
  });
  (0, _jquery["default"])("#updaterule-add").unbind("click").click(function (e) {
    // $("#updaterule-add-straname").html("");
    (0, _jquery["default"])("#updaterule-add-name").val("");
    (0, _jquery["default"])("#updaterule-add-msg").text("");
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getUpdateStrategies").fail(function (err) {
      console.log("getUpdateStrategies err:", err);
      (0, _jquery["default"])("#updaterule-add-msg").text("获取软件升级策略失败");
    }).done(function (res) {
      // console.log("getUpdateStrategies res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getUpdateStrategies err:", res);
        return (0, _jquery["default"])("#updaterule-add-msg").text("获取软件升级策略失败：" + info.error);
      }

      info = info.data;
      g_updatestrategies_bak = info; // $("#updaterule-add-straname").html("");
      // for (let i=0;i<g_updatestrategies_bak.length;i++) {
      //     let html = '<option value="' + g_updatestrategies_bak[i].id + '">' + g_updatestrategies_bak[i].name + '</option>';
      //     $("#updaterule-add-straname").append($(html))
      // }

      http.get("/getSoftRepos").fail(function (err) {
        console.log("getSoftRepos err:", err);
        (0, _jquery["default"])("#updaterule-add-msg").text("获取软件源失败");
      }).done(function (res) {
        // console.log("getSoftRepos res",res);
        var reposinfo = _jquery["default"].parseJSON(res);

        if (!reposinfo.succeed) {
          console.log("getSoftRepos err", res);
          return (0, _jquery["default"])("#updaterule-add-msg").text("获取软件源失败：" + info.error);
        }

        reposinfo = reposinfo.data;
        var vuedata1 = getVuedataBySoftRepo(reposinfo); //debugger

        if (!vue_choose_softrepospkgs) {
          vue_choose_softrepospkgs = new Vue({
            template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
            el: "#vue-updaterule-repos",
            methods: {
              getCheckedNodes: function getCheckedNodes() {
                return this.$refs.tree.getCheckedNodes();
              },
              setCheckedKeys: function setCheckedKeys(data) {
                this.$refs.tree.setCheckedKeys(data);
              }
            },
            data: {
              data: vuedata1,
              defaultProps: {
                children: 'children',
                label: 'label'
              }
            },
            watch: {
              data: function data(newdata, olddata) {}
            }
          });
        }

        vue_choose_softrepospkgs.data = vuedata1;
      }); // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
      // 先获取资产和分组信息

      http.get("/getGroupsAndAsserts").fail(function (err) {
        console.log("getGroupsAndAsserts err:", err);
        (0, _jquery["default"])("#updaterule-add-msg").text("获取资产和分组失败");
      }).done(function (res) {
        // console.log("getGroupsAndAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getGroupsAndAsserts err:", res);
          return (0, _jquery["default"])("#updaterule-add-msg").text("获取资产和分组失败：" + info.error);
        }

        info = info.data;
        vuedata = getVuedataByAssertsAndGroups(info);

        if (!vue_choose_asserts) {
          vue_choose_asserts = new Vue({
            template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
            el: "#vue-updaterule-div",
            methods: {
              getCheckedNodes: function getCheckedNodes() {
                return this.$refs.tree.getCheckedNodes();
              },
              setCheckedKeys: function setCheckedKeys(data) {
                this.$refs.tree.setCheckedKeys(data);
              }
            },
            data: {
              data: vuedata,
              defaultProps: {
                children: 'children',
                label: 'label'
              }
            },
            watch: {
              data: function data(newdata, olddata) {//
              }
            }
          });
        }

        vue_choose_asserts.data = vuedata;
      });
    });
  }); // 确认添加规则时的操作
  // $("#reporule-add-confirm").unbind("click").click(function(e){
  //     // 暂时弃用
  //     console.log("reporule-add-confirm")
  //     let choosedAssertsAndGroups = vue_choose_repo_asserts.getCheckedNodes();
  //     let choosedAsserts = [];
  //     for (let i=0;i<choosedAssertsAndGroups.length;i++) {
  //         if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
  //             choosedAsserts.push(choosedAssertsAndGroups[i].id)
  //         }
  //     }
  //     let choosedGroups = [];
  //     // 检查是否某个分组的所有资产都选择上了，如果都选择上了，则认为应用到分组内的所有资产，包括以后添加的?
  //     // 确定是否选择了分组不太确定，如果第一次建立规则时没选全分组内的资产，后来删除了分组内没选的资产，
  //     // 下次编辑的时候就会变成选择了分组内的全部资产了，还是只按照资产下发，如果改变了分组状态，
  //     // 需要重新编辑规则，并且下发
  //     for (let i=0;i<choosedAssertsAndGroups.length;i++) {
  //         if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
  //             continue
  //         }
  //     }
  //     if (choosedAsserts.length < 1) {
  //         return $("#reporule-add-msg").text("请至少选择一个资产");
  //     }
  //     let assertsstr = choosedAsserts.join(";");
  //     let name = $("#reporule-add-name").val();
  //     if (!name || name.length < 1 || name.length > 32) {
  //         return $("#reporule-add-msg").text("请输入合法的名称，最大32字符");
  //     }
  //     let straid = $("#reporule-add-straname option:selected").val();
  //     if (!straid || straid.length < 1) {
  //         return $("#reporule-add-msg").text("请选择合法的策略");
  //     }
  //     $("#reporule-add-msg").text("规则正在添加，请耐心等待");
  //     let http = cockpit.http({
  //         "port": 9091
  //     });
  //     http.post("/addRule", {
  //         type: "repo",
  //         name: name,
  //         straid: straid,
  //         asserts: assertsstr
  //     })
  //     .fail(function(err){
  //         console.log("addRule err:", err);
  //         $("#reporule-add-msg").text("添加规则失败")
  //     })
  //     .done(function(res) {
  //         console.log("addRule res:", res);
  //         let info = $.parseJSON( res );
  //         if (! info.succeed) {
  //             console.log("addRule err:", res);
  //             return $("#reporule-add-msg").text("添加规则失败：" + info.error)
  //         }
  //         $("#reporule-add-msg").text("添加规则成功");
  //         setTimeout(function(e){
  //             $("#reporule-add-close").click();
  //             render_reporules();
  //         }, 1500)
  //     })
  // })
  // 确认添加规则时的操作

  (0, _jquery["default"])("#updaterule-add-confirm").unbind("click").click(function (e) {
    // 根据评审 更改为可选安装包应用到不同资产或者分组去
    console.log("updaterule-add-confirm");
    var choosedAssertsAndGroups = vue_choose_asserts.getCheckedNodes();
    var choosedAsserts = [];
    var choosedRepospkgs = vue_choose_softrepospkgs.getCheckedNodes();
    var choosedpkgs = [];

    for (var x = 0; x < choosedRepospkgs.length; x++) {
      if (!choosedRepospkgs[x].children) {
        choosedpkgs.push(choosedRepospkgs[x].id); // console.log(choosedRepospkgs[x].id);
      }
    }

    for (var i = 0; i < choosedAssertsAndGroups.length; i++) {
      if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
        choosedAsserts.push(choosedAssertsAndGroups[i].id);
      }
    }

    var choosedGroups = []; // 检查是否某个分组的所有资产都选择上了，如果都选择上了，则认为应用到分组内的所有资产，包括以后添加的?
    // 确定是否选择了分组不太确定，如果第一次建立规则时没选全分组内的资产，后来删除了分组内没选的资产，
    // 下次编辑的时候就会变成选择了分组内的全部资产了，还是只按照资产下发，如果改变了分组状态，
    // 需要重新编辑规则，并且下发

    for (var _i5 = 0; _i5 < choosedAssertsAndGroups.length; _i5++) {
      if (choosedAssertsAndGroups[_i5].label.indexOf("资产") == 0) {
        continue;
      }
    }

    if (choosedRepospkgs.length < 1) {
      return (0, _jquery["default"])("#updaterule-add-msg").text("请至少选择一个软件包");
    }

    if (choosedAsserts.length < 1) {
      return (0, _jquery["default"])("#updaterule-add-msg").text("请至少选择一个资产");
    }

    var assertsstr = choosedAsserts.join(";");
    var name = (0, _jquery["default"])("#updaterule-add-name").val();

    if (!name || name.length < 1 || name.length > 32) {
      return (0, _jquery["default"])("#updaterule-add-msg").text("请输入合法的名称，最大32字符");
    } // let straid = $("#updaterule-add-straname option:selected").val();
    // if (!straid || straid.length < 1) {
    //     return $("#updaterule-add-msg").text("请选择合法的策略");
    // }


    (0, _jquery["default"])("#updaterule-add-msg").text("规则正在添加，请耐心等待");
    var http = cockpit.http({
      "port": 9091
    });
    http.post("/addRule", {
      type: "update",
      name: name,
      stracontent: choosedpkgs,
      straid: 0,
      asserts: assertsstr
    }).fail(function (err) {
      console.log("addRule err:", err);
      (0, _jquery["default"])("#updaterule-add-msg").text("添加规则失败");
    }).done(function (res) {
      // console.log("addRule res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("addRule err:", res);
        return (0, _jquery["default"])("#updaterule-add-msg").text("添加规则失败：" + info.error);
      }

      (0, _jquery["default"])("#updaterule-add-msg").text("添加规则成功");
      setTimeout(function (e) {
        (0, _jquery["default"])("#updaterule-add-close").click();
        render_updaterules();
      }, 1500);
    });
  });
  (0, _jquery["default"])("#repostrategy-add-confirm").unbind("click").click(function (e) {
    console.log("repostrategy-add-confirm");
    var choosedNodes = vue_choose_softrepos.getCheckedNodes();
    var choosedSoftRepos = [];
    var choosedNames = [];

    if (choosedNodes.length < 1) {
      return (0, _jquery["default"])("#repostrategy-add-msg").text("请至少选择一个软件源");
    }

    for (var i = 0; i < choosedNodes.length; i++) {
      choosedSoftRepos.push(choosedNodes[i].id);
      var softreponame = choosedNodes[i].label.split(':')[1];
      choosedNames.push(softreponame);
    }

    var softrepostr = choosedSoftRepos.join(";");
    var softreponamestr = choosedNames.join(";");
    console.log(softrepostr);
    console.log(softreponamestr);
    var name = (0, _jquery["default"])("#repostrategy-add-name").val();
    console.log(name);
    var http = cockpit.http({
      "port": 9091
    });
    http.post("/addRepoStrategies", {
      "name": name,
      "softrepostr": softrepostr,
      "softreponamestr": softreponamestr
    }).done(function (res) {
      console.log("addRepoStrategies res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        return (0, _jquery["default"])("#repostrategy-add-msg").text("软件源策略添加失败：" + info.error);
      }

      (0, _jquery["default"])("#repostrategy-add-msg").text("软件源策略添加成功");
      setTimeout(function (e) {
        (0, _jquery["default"])("#repostrategy-add-close").click(); //vue_choose_softrepos.data = [];

        render_repostrategies();
      }, 1000);
    }).fail(function (exception, err) {
      console.log(err);
      (0, _jquery["default"])("#repostrategy-add-msg").text("软件源策略添加失败");
    });
  });
  (0, _jquery["default"])("#updatestrategy-add-confirm").unbind("click").click(function (e) {
    console.log("updatestrategy-add-confirm");
    var name = (0, _jquery["default"])("#updatestrategy-add-name").val();
    var pkglist = (0, _jquery["default"])("#updatestrategy-add-pkglist").val();
    console.log(name);
    console.log(pkglist);
    var http = cockpit.http({
      "port": 9091
    });
    http.post("/addUpdateStrategies", {
      "name": name,
      "pkglist": pkglist
    }).done(function (res) {
      console.log("addUpdateStrategies res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        return (0, _jquery["default"])("#updatestrategy-add-msg").text("软件升级策略添加失败：" + info.error);
      }

      (0, _jquery["default"])("#updatestrategy-add-msg").text("软件升级策略添加成功");
      setTimeout(function (e) {
        (0, _jquery["default"])("#updatestrategy-add-close").click();
        render_updatestrategies();
      }, 1000);
    }).fail(function (exception, err) {
      console.log(err);
      (0, _jquery["default"])("#updatestrategy-add-msg").text("软件升级策略添加失败");
    });
  });
  (0, _jquery["default"])('#update-filter li').on('click', function () {
    (0, _jquery["default"])('#update-filter li').removeClass('active').removeAttr('aria-current');
    (0, _jquery["default"])(this).addClass('active').attr('aria-current', true);
    var pattern = (0, _jquery["default"])(this).attr('data-pattern');

    if (pattern == "repostrategy") {
      cockpit.location.go(["repostrategy"]); //$("#softrepo-add").hide();
      //$("#repostrategy-add").show();
      //render_rules();
    } else if (pattern == "softrepo") {
      cockpit.location.go([""]); //$("#softrepo-add").show();
      //$("#repostrategy-add").hide();
      //render_users()
    } else if (pattern == "reporule") {
      cockpit.location.go(["reporule"]); //$("#softrepo-add").hide();
      //$("#repostrategy-add").hide();
      //render_users()
    } else if (pattern == "updatestrategy") {
      cockpit.location.go(["updatestrategy"]); //$("#softrepo-add").hide();
      //$("#repostrategy-add").hide();
      //render_users()
    } else if (pattern == "updaterule") {
      cockpit.location.go(["updaterule"]); //$("#softrepo-add").hide();
      //$("#repostrategy-add").hide();
      //render_users()
    }
  }); // 根据 url 初始化渲染页面

  (0, _jquery["default"])("#update-filter li").removeClass('active').removeAttr('aria-current');

  function navigate() {
    if (window.location.href.indexOf("#/repostrategy") > 0) {
      (0, _jquery["default"])("#repostrategy-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#repostrategy-add").show();
      (0, _jquery["default"])("#softrepo-add").hide();
      (0, _jquery["default"])("#reporule-add").hide();
      (0, _jquery["default"])("#updatestrategy-add").hide();
      (0, _jquery["default"])("#updaterule-add").hide();
      render_repostrategies();
    } else if (window.location.href.indexOf("#/reporule") > 0) {
      (0, _jquery["default"])("#reporule-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#reporule-add").show();
      (0, _jquery["default"])("#softrepo-add").hide();
      (0, _jquery["default"])("#repostrategy-add").hide();
      (0, _jquery["default"])("#updatestrategy-add").hide();
      (0, _jquery["default"])("#updaterule-add").hide();
      render_reporules();
    } else if (window.location.href.indexOf("#/updatestrategy") > 0) {
      (0, _jquery["default"])("#updatestrategy-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#reporule-add").hide();
      (0, _jquery["default"])("#softrepo-add").hide();
      (0, _jquery["default"])("#repostrategy-add").hide();
      (0, _jquery["default"])("#updatestrategy-add").show();
      (0, _jquery["default"])("#updaterule-add").hide();
      render_updatestrategies();
    } else if (window.location.href.indexOf("#/updaterule") > 0) {
      (0, _jquery["default"])("#updaterule-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#reporule-add").hide();
      (0, _jquery["default"])("#softrepo-add").hide();
      (0, _jquery["default"])("#repostrategy-add").hide();
      (0, _jquery["default"])("#updatestrategy-add").hide();
      (0, _jquery["default"])("#updaterule-add").show();
      render_updaterules();
    } else {
      (0, _jquery["default"])("#softrepo-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#softrepo-add").show();
      (0, _jquery["default"])("#repostrategy-add").hide();
      (0, _jquery["default"])("#reporule-add").hide();
      (0, _jquery["default"])("#updatestrategy-add").hide();
      (0, _jquery["default"])("#updaterule-add").hide();
      render_softrepos();
    }
  }

  (0, _jquery["default"])(cockpit).on("locationchanged", navigate);
  navigate();
}
/* These add themselves to jQuery so just including is enough */


cockpit.translate();
var _ = cockpit.gettext;

_moment["default"].locale(cockpit.language);

if (window.location.pathname.indexOf("manager/update.html") > 0) {
  (0, _jquery["default"])(update_init);
}