"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _jquery = _interopRequireDefault(require("jquery"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _mustache = _interopRequireDefault(require("mustache"));

var authorized_keys = _interopRequireWildcard(require("./authorized-keys.js"));

require("patterns");

require("bootstrap-datepicker/dist/js/bootstrap-datepicker");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * This file is part of Cockpit.
 *
 * Copyright (C) 2013 Red Hat, Inc.
 *
 * Cockpit is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * Cockpit is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Cockpit; If not, see <http://www.gnu.org/licenses/>.
 */
//import cockpit from 'cockpit';
//import ElementUI from 'element-ui' //新添加
//import Vue from 'vue'
//Vue.use(ElementUI)
var _ = cockpit.gettext;
var C_ = cockpit.gettext;
var g_asserts_bak = [];
var g_users_bak = [];
var g_rules_bak = [];
var intv = 0;

function password_quality(password) {
  var dfd = cockpit.defer();
  cockpit.spawn('/usr/bin/pwscore', {
    "err": "message"
  }).input(password).done(function (content) {
    var quality = parseInt(content, 10);

    if (quality === 0) {
      dfd.reject(new Error(_("Password is too weak")));
    } else if (quality <= 33) {
      dfd.resolve("weak");
    } else if (quality <= 66) {
      dfd.resolve("okay");
    } else if (quality <= 99) {
      dfd.resolve("good");
    } else {
      dfd.resolve("excellent");
    }
  }).fail(function (ex) {
    dfd.reject(new Error(ex.message || _("Password is not acceptable")));
  });
  return dfd.promise();
}

function is_valid_char_username(c) {
  return c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c >= '0' && c <= '9' || c == '.' || c == '_' || c == '-';
}

function check_username() {
  var dfd = cockpit.defer();
  var username = (0, _jquery["default"])('#accounts-create-user-name').val();

  for (var i = 0; i < username.length; i++) {
    if (!is_valid_char_username(username[i])) {
      dfd.reject(new Error(_("The user name can only consist of letters from a-z, digits, dots, dashes and underscores.")));
      return dfd.promise();
    }
  }

  dfd.resolve();
  return dfd.promise();
}

PageAccounts.prototype = {
  _init: function _init() {
    this.id = "accounts";
    this.user_list_tmpl = (0, _jquery["default"])("#users-list-tmpl").html();

    _mustache["default"].parse(this.user_list_tmpl);
  },
  show: function show() {
    var self = this; // 从 g_users_bak 获取用户数据

    self.hide();
    var header = {
      Name: "账户名",
      Fullname: "账户全名",
      Ifdelete: "策略类型",
      Operate: "操作"
    };
    var units = [];

    for (var i = 0; i < g_users_bak.length; i++) {
      var unit = g_users_bak[i];

      if (unit.deleteuser) {
        unit["deleteusertext"] = "删除账户";
      } else {
        unit["deleteusertext"] = "创建账户";
      }

      units.push(unit);
    } // 分页展示


    units = g_processPagination(units);

    var text = _mustache["default"].render(self.user_list_tmpl, {
      table_head: header,
      units: units
    });

    (0, _jquery["default"])("#accounts-list").html(text);
  },
  hide: function hide() {
    (0, _jquery["default"])("#accounts-list").html("");
  }
};

function PageAccounts() {
  this._init();
}

PageAccountsCreate.prototype = {
  _init: function _init() {
    var self = this;
  },
  getRandomPass: function getRandomPass(length, hasNum, hasChar, hasSymbol, caseSense, lowerCase) {
    var m = "";
    if (hasNum == "0" && hasChar == "0" && hasSymbol == "0") return m;
    var achar = false;
    var asymbol = false;

    for (var i = length; i >= 0; i--) {
      var num = Math.floor(Math.random() * 89 + 33); // 33 - 122

      if (hasNum == "0" && num >= 48 && num <= 57 || hasChar == "0" && (num >= 65 && num <= 90 || num >= 97 && num <= 122) || hasSymbol == "0" && (num >= 33 && num <= 47 // ! " #  $ % & ' ( ) * + , - . /
      || num >= 58 && num <= 64 // : ; < = > ?
      || num >= 91 && num <= 96 // [ \ ] ^ _
      ) //  || (
      //     (num >= 123) && (num <= 127) // { | } ~ del
      // ))
      || num == 34 || num == 36 || num == 39 || num == 92 // " $ ' \
      ) {
          i++;
          continue;
        }

      if (num >= 65 && num <= 90 || num >= 97 && num <= 122) {
        achar = true;
      }

      if (num >= 33 && num <= 47 || num >= 58 && num <= 64 || num >= 91 && num <= 96) {
        asymbol = true;
      }

      m += String.fromCharCode(num);
    }

    if (caseSense == "0") {
      m = lowerCase == "0" ? m.toUpperCase() : m.toLowerCase();
    } // 检测如果不含符号或者不含英文字母，需要修改为至少含有一个字母或者符号的密码


    if (!achar) {
      m.replace(m[m.length - 1], "a");
    }

    if (!asymbol) {
      m.replace(m[m.length - 2], "!");
    }

    return m;
  },
  setRandomPass: function setRandomPass() {
    var self = this;
    var randomPass = self.getRandomPass(16, 1, 1, 1, 1, 0);
    (0, _jquery["default"])("#accounts-create-pw1").val(randomPass);
    (0, _jquery["default"])("#accounts-create-pw2").val(randomPass);
    self.validate();
  },
  setup: function setup(render_users) {
    var self = this;
    self.render_users = render_users;
    (0, _jquery["default"])('#accounts-create-dialog .check-passwords').on('keydown change', _jquery["default"].proxy(this, "validate"));
    (0, _jquery["default"])('#accounts-create-create').unbind("click").on('click', _jquery["default"].proxy(this, "create"));
    (0, _jquery["default"])('#add-user-password-button').unbind("click").on('click', _jquery["default"].proxy(this, "setRandomPass"));
    (0, _jquery["default"])('#check-user-password-button').unbind("click").on('click', function (e) {
      (0, _jquery["default"])("#password-text").text((0, _jquery["default"])("#accounts-create-pw1").val());
    });
  },
  validate: function validate() {
    var self = this;
    var ex;
    var fails = [];
    var pw = (0, _jquery["default"])('#accounts-create-pw1').val();

    if ((0, _jquery["default"])('#accounts-create-pw2').val() != pw) {
      ex = new Error(_("The passwords do not match"));
      ex.target = "#accounts-create-pw2";
      fails.push(ex);
    }

    if (!(0, _jquery["default"])('#accounts-create-user-name').val()) {
      ex = new Error(_("No user name specified"));
      ex.target = '#accounts-create-user-name';
      fails.push(ex);
    }

    if (!(0, _jquery["default"])('#accounts-create-full-name').val()) {
      ex = new Error(_("No full name specified"));
      ex.target = '#accounts-create-full-name';
      fails.push(ex);
    }
    /* The first check is immediately complete */


    var dfd = cockpit.defer();
    if (fails.length) dfd.reject(fails);else dfd.resolve();
    var promise_password = password_quality(pw).fail(function (ex) {
      ex.target = "#accounts-create-pw2";
    }).always(function (arg) {
      var strength = this.state() == "resolved" ? arg : "weak";
      var meter = (0, _jquery["default"])("#accounts-create-password-meter").removeClass("weak okay good excellent");
      if (pw) meter.addClass(strength);
      var message = (0, _jquery["default"])("#accounts-create-password-meter-message");

      if (strength == "excellent") {
        message.text(_("Excellent password"));
      } else {
        message.text("");
      }
    });
    var promise_username = check_username().fail(function (ex) {
      ex.target = "#accounts-create-user-name";
    }); // Can't use Promise.all() here, because this promise is passed to
    // dialog(), which expects a promise with a progress() method (see
    // pkg/lib/patterns.js)
    // eslint-disable-next-line cockpit/no-cockpit-all

    return cockpit.all(dfd.promise(), promise_password, promise_username);
  },
  create: function create() {
    var self = this;
    var name = (0, _jquery["default"])('#accounts-create-user-name').val();
    var fullname = (0, _jquery["default"])('#accounts-create-full-name').val();
    var pw1 = (0, _jquery["default"])("#accounts-create-pw1").val();
    var pw2 = (0, _jquery["default"])("#accounts-create-pw2").val();

    if (pw1 !== pw2) {
      return (0, _jquery["default"])("#accounts-create-password-meter-message").text("密码不一致");
    }

    var passCheckTip = (0, _jquery["default"])("#accounts-create-password-meter");

    if (passCheckTip[0].className.indexOf("weak") >= 0) {
      return (0, _jquery["default"])("#accounts-create-password-meter-message").text("密码强度太低");
    }

    var lockuser = (0, _jquery["default"])('#accounts-create-locked').prop('checked');
    lockuser = lockuser ? 1 : 0;
    var isadmin = (0, _jquery["default"])('#accounts-create-isadmin').prop('checked');
    isadmin = isadmin ? 1 : 0;
    var deleteuser = (0, _jquery["default"])('#accounts-create-delete').prop('checked');
    deleteuser = deleteuser ? 1 : 0;

    if (!name || name.length < 1 || name.length > 32) {
      return (0, _jquery["default"])("#create-user-msg").text("用户名不能为空且最大32字符");
    }

    var allnum = true;

    for (var i = 0; i < name.length; i++) {
      if (!/[0-9]/.test(name[i])) {
        allnum = false;
      }

      if (!is_valid_char_username(name[i])) {
        return (0, _jquery["default"])("#create-user-msg").text("用户名含有非法字符");
      }
    }

    if (allnum) {
      return (0, _jquery["default"])("#create-user-msg").text("用户名不能为全数字");
    }

    if (!fullname || fullname.length < 1 || fullname.length > 32) {
      return (0, _jquery["default"])("#create-user-msg").text("用户全名不能为空且最大32字符");
    }

    for (var i = 0; i < fullname.length; i++) {
      if (!is_valid_char_username(fullname[i])) {
        return (0, _jquery["default"])("#create-user-msg").text("用户全名含有非法字符");
      }
    }

    var http = cockpit.http({
      "port": 9091
    });
    http.post("/addUser", {
      "name": name,
      "fullname": fullname,
      "pwd": pw1,
      "lockuser": lockuser,
      "isadmin": isadmin,
      "deleteuser": deleteuser
    }).fail(function (err) {
      console.log("adduser err:", err);
      (0, _jquery["default"])("#create-user-msg").text("添加账户失败");
    }).done(function (res) {
      console.log("addUser res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        return (0, _jquery["default"])("#create-user-msg").text("添加账户失败：" + info.error);
      }

      (0, _jquery["default"])("#create-user-msg").text("添加账户成功");
      setTimeout(function (e) {
        (0, _jquery["default"])("#accounts-create-close").click();
        self.render_users();
      }, 1500);
    });
  }
};

function PageAccountsCreate() {
  this._init();
}

PageAccount.prototype = {
  _init: function _init(user) {
    this.id = "account-page";
    this.keys_template = (0, _jquery["default"])("#authorized-keys-tmpl").html();

    _mustache["default"].parse(this.keys_template);

    this.user = user;
  },
  setusername: function setusername(user) {
    this.user = user;
  },
  getUserInfo: function getUserInfo(user) {
    for (var i = 0; i < g_users_bak.length; i++) {
      if (g_users_bak[i].name == user) {
        return g_users_bak[i];
      }
    }

    return false;
  },
  show: function show() {
    var self = this;
    var exist = false;

    for (var i = 0; i < g_users_bak.length; i++) {
      if (g_users_bak[i].name == self.user) {
        exist = true;
      }
    }

    if (!exist) {
      (0, _jquery["default"])("#account").hide();
      (0, _jquery["default"])("#account-failure").show();
    } else {
      (0, _jquery["default"])("#account").show();
      (0, _jquery["default"])("#account-failure").hide();
    }
  },
  hide: function hide() {
    (0, _jquery["default"])("#account").hide();
    (0, _jquery["default"])("#account-failure").hide();
  },
  validate: function validate() {
    var ex;
    var pw = (0, _jquery["default"])('#account-set-password-pw1').val();

    if ((0, _jquery["default"])('#account-set-password-pw2').val() != pw) {
      ex = new Error(_("The passwords do not match"));
      ex.target = "#account-set-password-pw2";
    }

    var dfd = cockpit.defer();
    if (ex) dfd.reject(ex);else dfd.resolve();
    var promise = password_quality(pw).fail(function (ex) {
      ex.target = "#account-set-password-pw2";
    }).always(function (arg) {
      var strength = this.state() == "resolved" ? arg : "weak";
      var meter = (0, _jquery["default"])("#account-set-password-meter").removeClass("weak okay good excellent");
      if (pw) meter.addClass(strength);
      var message = (0, _jquery["default"])("#account-set-password-meter-message");

      if (strength == "excellent") {
        message.text(_("Excellent password"));
      } else {
        message.text("");
      }
    }); // Can't use Promise.all() here, because this promise is passed to
    // dialog(), which expects a promise with a progress() method (see
    // pkg/lib/patterns.js)
    // eslint-disable-next-line cockpit/no-cockpit-all

    return cockpit.all(dfd.promise(), promise);
  },
  // 编辑成功后刷新数据
  refreshUserInfo: function refreshUserInfo(callback, callback_err) {
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getUsers").fail(function (err) {
      console.log("getUsers err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
      callback_err();
    }).done(function (res) {
      // console.log("getUsers res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getUsers err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        callback_err();
        return;
      }

      info = info.data;
      g_users_bak = info;
      (0, _jquery["default"])("#loading-fallback").hide();
      callback();
    });
  },
  setup: function setup() {
    var self = this;
    var userinfo = self.getUserInfo(self.user);

    if (!userinfo) {
      return;
    }

    (0, _jquery["default"])("ol.breadcrumb li.active").text(userinfo.fullname);
    (0, _jquery["default"])("span#account-title").text(userinfo.fullname);
    (0, _jquery["default"])("#account-full-name").val(userinfo.fullname);
    (0, _jquery["default"])("#account-user-name").val(userinfo.name);
    (0, _jquery["default"])("#account-role-checkbox-10").prop("checked", userinfo.isadmin);
    (0, _jquery["default"])("#account-locked").prop("checked", userinfo.lockuser);
    (0, _jquery["default"])("#account-ifdelete").prop("checked", userinfo.deleteuser);
    (0, _jquery["default"])('#account .breadcrumb a').on("click", function () {
      cockpit.location.go('/');
    });
    (0, _jquery["default"])('#account-full-name').on('change', _jquery["default"].proxy(this, "edit_user"));
    (0, _jquery["default"])("#account-role-checkbox-10").on('change', _jquery["default"].proxy(this, "edit_user"));
    (0, _jquery["default"])("#account-locked").on('change', _jquery["default"].proxy(this, "edit_user"));
    (0, _jquery["default"])("#account-ifdelete").on('change', _jquery["default"].proxy(this, "edit_user")); // 证书界面

    var keystrarr = userinfo.authkey.split(";");
    var keys = [];

    for (var i = 0; i < keystrarr.length; i++) {
      var keyarr = keystrarr[i].split(" ");

      if (keyarr.length < 3) {
        continue;
      }

      var type = keyarr[0];
      var content = keyarr[1];
      var comment = keyarr[2];
      var unit = {
        "valid": true,
        "fp": type + ":" + comment,
        "comment": comment,
        "raw": keystrarr[i],
        "allkeycontent": keystrarr[i]
      };
      keys.push(unit);
    }

    var keys_html = "";

    if (keys.length < 1) {
      keys_html = _mustache["default"].render(this.keys_template, {
        "empty": true
      });
    } else {
      keys_html = _mustache["default"].render(this.keys_template, {
        "keys": keys
      });
    }

    (0, _jquery["default"])('#account-authorized-keys-list').html(keys_html); // 设置密码

    (0, _jquery["default"])('#account-set-password-dialog .check-passwords').on('keydown change', _jquery["default"].proxy(this, "validate"));
    (0, _jquery["default"])("#account-set-password-apply").unbind("click").click(function (e) {
      var pwcheck = (0, _jquery["default"])("#account-set-password-meter")[0];

      if (pwcheck.className.indexOf("weak") >= 0) {
        return (0, _jquery["default"])("#account-set-password-meter-message").text("密码太弱，请重新设置");
      }

      var pw1 = (0, _jquery["default"])("#account-set-password-pw1").val();
      var pw2 = (0, _jquery["default"])("#account-set-password-pw2").val();

      if (pw1 != pw2) {
        return (0, _jquery["default"])("#account-set-password-meter-message").text("密码不一致，请重新设置");
      }

      var http = cockpit.http({
        "port": 9091
      });
      http.post("/editUserPassword", {
        "name": self.user,
        "pwd": pw1
      }).fail(function (err) {
        console.log("editUserPassword err:", err);
        (0, _jquery["default"])("#account-set-password-meter-message").text("设置账户密码失败");
      }).done(function (res) {
        console.log("editUserPassword res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#account-set-password-meter-message").text("设置账户密码失败：" + info.error);
        }

        self.refreshUserInfo(function () {
          (0, _jquery["default"])("#account-set-password-meter-message").text("设置账户密码成功");
          setTimeout(function () {
            (0, _jquery["default"])("#account-set-password-close").click();
          }, 1500);
        }, function (e) {
          (0, _jquery["default"])("#account-set-password-meter-message").text("刷新数据失败");
        });
      });
    }); // 查看密码

    (0, _jquery["default"])("#password-show-button").unbind("click").click(function (e) {
      var userinfotmp = self.getUserInfo(self.user);
      (0, _jquery["default"])("#password-text").text(userinfotmp.password);
    }); // 点击添加按钮的时候，要把文本框内的内容情况，可能上次添加会有残留

    (0, _jquery["default"])("#authorized-key-add").unbind("click").click(function (e) {
      (0, _jquery["default"])("#authorized-keys-text").val("");
    }); // 管理公钥

    (0, _jquery["default"])("#add-authorized-key").unbind("click").click(function (e) {
      (0, _jquery["default"])("#add-authorized-key-message").text("");
      var authkey = (0, _jquery["default"])("#authorized-keys-text").val();

      if (!authkey || authkey.length < 1) {
        return (0, _jquery["default"])("#add-authorized-key-message").text("请输入公钥内容");
      }

      var authkeyarr = authkey.split(" ");

      if (authkeyarr.length < 3) {
        return (0, _jquery["default"])("#add-authorized-key-message").text("请输入合法的公钥内容");
      }

      var http = cockpit.http({
        "port": 9091
      });
      http.post("/addUserKey", {
        "name": self.user,
        "authkey": authkey
      }).fail(function (err) {
        console.log("addUserKey err:", err);
        (0, _jquery["default"])("#add-authorized-key-message").text("添加公钥失败");
      }).done(function (res) {
        console.log("addUserKey res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#add-authorized-key-message").text("添加公钥失败：" + info.error);
        }

        self.refreshUserInfo(function () {
          (0, _jquery["default"])("#add-authorized-key-message").text("添加公钥成功");
          self.setup();
          setTimeout(function (e) {
            (0, _jquery["default"])("#cancel-authorized-key").click();
          }, 1500);
        }, function (e) {
          (0, _jquery["default"])("#add-authorized-key-message").text("刷新数据失败");
        });
      });
    });
    (0, _jquery["default"])("button.account-remove-key").unbind("click").click(function (e) {
      var raw = (0, _jquery["default"])(this).data("raw");
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/delUserKey", {
        "name": self.user,
        "authkey": raw
      }).fail(function (err) {
        console.log("delUserKey err:", err);
        show_error_dialog("错误", "删除公钥失败");
      }).done(function (res) {
        console.log("delUserKey res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return show_error_dialog("错误", "删除公钥失败：" + info.error);
        }

        self.refreshUserInfo(function () {
          self.setup();
        }, function (e) {
          show_error_dialog("错误", "刷新数据失败");
        });
      });
    });
  },
  edit_user: function edit_user(e) {
    var self = this;

    function disable_edit() {
      (0, _jquery["default"])('#account-locked').prop("disabled", true);
      (0, _jquery["default"])('#account-role-checkbox-10').prop("disabled", true);
      (0, _jquery["default"])('#account-ifdelete').prop("disabled", true);
    }

    function enable_edit() {
      (0, _jquery["default"])('#account-locked').prop("disabled", false);
      (0, _jquery["default"])('#account-role-checkbox-10').prop("disabled", false);
      (0, _jquery["default"])('#account-ifdelete').prop("disabled", false);
    } // 改变 checkbox 的 disabled 属性时也会触发 change 事件，调用 setup 的时候也会，这里过滤掉


    if ((0, _jquery["default"])('#account-locked').prop("disabled") || (0, _jquery["default"])('#account-role-checkbox-10').prop("disabled") || (0, _jquery["default"])('#account-ifdelete').prop("disabled")) {
      return;
    }

    disable_edit();
    var user = (0, _jquery["default"])("#account-user-name").text();
    var newfullname = (0, _jquery["default"])("#account-full-name").val();

    if (!newfullname || newfullname.length < 1 || newfullname.length > 32) {
      return enable_edit();
    }

    var lockuser = (0, _jquery["default"])('#account-locked').prop('checked');
    lockuser = lockuser ? 1 : 0;
    var isadmin = (0, _jquery["default"])('#account-role-checkbox-10').prop('checked');
    isadmin = isadmin ? 1 : 0;
    var deleteuser = (0, _jquery["default"])('#account-ifdelete').prop('checked');
    deleteuser = deleteuser ? 1 : 0;
    var http = cockpit.http({
      "port": 9091
    });
    http.post("/editUserNormal", {
      "name": self.user,
      "fullname": newfullname,
      "lockuser": lockuser,
      "isadmin": isadmin,
      "deleteuser": deleteuser
    }).fail(function (err) {
      console.log("editUserNormal err:", err);
      enable_edit();
      return show_error_dialog("错误", "设置账户策略失败");
    }).done(function (res) {
      console.log("editUserPassword res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        enable_edit();
        return show_error_dialog("错误", "设置账户策略失败：" + info.error);
      }

      self.refreshUserInfo(function () {
        self.setup();
        enable_edit();
      }, function (e) {
        show_error_dialog("错误", "刷新数据失败");
      });
    });
  } // 

};

function PageAccount(user) {
  this._init(user);
}

function AccountExpiration() {
  (0, _jquery["default"])("#account-expiration").on("show.bs.modal", function (ev) {
    var account_id = (0, _jquery["default"])(ev.relatedTarget).data("account-id");
    (0, _jquery["default"])("#account-expiration").data("account-id", account_id);
    /* Fill in initial dialog values */

    var expire_date = (0, _jquery["default"])(ev.relatedTarget).data("expire-date");
    (0, _jquery["default"])(expire_date ? '#account-expiration-expires' : "#account-expiration-never").prop('checked', true);
    (0, _jquery["default"])('#account-expiration-input').val(expire_date ? expire_date.toISOString().substr(0, 10) : "");
    (0, _jquery["default"])('#account-expiration-input').prop('disabled', !expire_date);
    /* TRANSLATORS: This is split up and therefore cannot use ngettext plurals */

    var parts = _("Lock account on $0").split("$0");

    (0, _jquery["default"])("#account-expiration-before").text(parts[0]);
    (0, _jquery["default"])("#account-expiration-after").text(parts[1]);
  });
  (0, _jquery["default"])('#account-expiration .btn-primary').on('click', function () {
    var date, value;
    var ex;
    var promise = null;
    /* Parse the dialog data and validate */

    if ((0, _jquery["default"])('#account-expiration-expires').prop('checked')) {
      value = (0, _jquery["default"])('#account-expiration-input').val();

      if (!value) {
        ex = new Error(_("Please specify an expiration date"));
        ex.target = "#account-expiration-input";
      } else {
        date = new Date(value + "T12:00:00Z");

        if (isNaN(date.getTime()) || date.getTime() < 0) {
          ex = new Error(_("Invalid expiration date"));
          ex.target = "#account-expiration-input";
        }
      }

      if (ex) promise = cockpit.reject(ex);
    }

    if ((0, _jquery["default"])('#account-expiration-never').prop('checked')) {
      date = null;
      promise = null;
    }
    /* Actually perform the action if valid */


    var prog = ["/usr/sbin/usermod", "-e"];
    var account_id = (0, _jquery["default"])("#account-expiration").data("account-id");

    if (!promise) {
      if (date) prog.push(date.toISOString().substr(0, 10));else prog.push("");
      prog.push(account_id);
      promise = cockpit.spawn(prog, {
        "superuser": true,
        "err": "message"
      });
    }

    (0, _jquery["default"])("#account-expiration").dialog("promise", promise);
  });
  (0, _jquery["default"])('#account-expiration input').on('change', function () {
    (0, _jquery["default"])('#account-expiration-input').prop('disabled', (0, _jquery["default"])("#account-expiration-never").prop('checked'));
  });
  (0, _jquery["default"])('#account-expiration-input').datepicker({
    autoclose: true,
    todayHighlight: true,
    format: 'yyyy-mm-dd'
  });
  (0, _jquery["default"])('#account-expiration-input').on("show.bs.modal", function (ev) {
    ev.stopPropagation();
  });
}

function PasswordExpiration() {
  var never = 99999;
  (0, _jquery["default"])("#password-expiration").on("show.bs.modal", function (ev) {
    var account_id = (0, _jquery["default"])(ev.relatedTarget).data("account-id");
    (0, _jquery["default"])("#password-expiration").data("account-id", account_id);
    /* Fill in initial dialog values */

    var expire_days = parseInt((0, _jquery["default"])(ev.relatedTarget).data("expire-days"), 10);
    if (isNaN(expire_days) || expire_days < 0 || expire_days >= never) expire_days = null;
    (0, _jquery["default"])(expire_days ? '#password-expiration-expires' : "#password-expiration-never").prop('checked', true);
    (0, _jquery["default"])('#password-expiration-input').val(expire_days || "");
    (0, _jquery["default"])('#password-expiration-input').prop('disabled', !expire_days);
    /* TRANSLATORS: This is split up and therefore cannot use ngettext plurals */

    var parts = _("Require password change every $0 days").split("$0");

    (0, _jquery["default"])("#password-expiration-before").text(parts[0]);
    (0, _jquery["default"])("#password-expiration-after").text(parts[1]);
  });
  (0, _jquery["default"])('#password-expiration .btn-primary').on('click', function () {
    var days, ex;
    var promise = null;
    if ((0, _jquery["default"])('#password-expiration-expires').prop('checked')) days = parseInt((0, _jquery["default"])('#password-expiration-input').val().trim(), 10);
    if ((0, _jquery["default"])('#password-expiration-never').prop('checked')) days = never;

    if (isNaN(days) || days < 0) {
      ex = new Error(_("Invalid number of days"));
      ex.target = "#password-expiration-input";
      promise = cockpit.reject(ex);
    }

    var account_id = (0, _jquery["default"])("#password-expiration").data("account-id");

    if (!promise) {
      promise = cockpit.spawn(["/usr/bin/passwd", "-x", String(days), account_id], {
        "superuser": true,
        "err": "message"
      });
    }

    (0, _jquery["default"])("#password-expiration").dialog("promise", promise);
  });
  (0, _jquery["default"])('#password-expiration input').on('change', function () {
    (0, _jquery["default"])('#password-expiration-input').prop('disabled', (0, _jquery["default"])("#password-expiration-never").prop('checked'));
  });
}

function PasswordReset() {
  (0, _jquery["default"])("#password-reset").on("show.bs.modal", function (ev) {
    var account_id = (0, _jquery["default"])(ev.relatedTarget).data("account-id");
    (0, _jquery["default"])("#password-reset").data("account-id", account_id);
    var msg = cockpit.format(_("The account '$0' will be forced to change their password on next login"), account_id);
    (0, _jquery["default"])("#password-reset .modal-body p").text(msg);
  });
  (0, _jquery["default"])("#password-reset .btn-primary").on("click", function () {
    var account_id = (0, _jquery["default"])("#password-reset").data("account-id");
    var promise = cockpit.spawn(["/usr/bin/passwd", "-e", account_id], {
      "superuser": true,
      "err": "message"
    });
    (0, _jquery["default"])("#password-reset").dialog("promise", promise);
  });
}
/* INITIALIZATION AND NAVIGATION
 *
 * The code above still uses the legacy 'Page' abstraction for both
 * pages and dialogs, and expects page.setup, page.enter, page.show,
 * and page.leave to be called at the right times.
 *
 * We cater to this with a little compatability shim consisting of
 * 'dialog_setup', 'page_show', and 'page_hide'.
 */


function show_error_dialog(title, message) {
  if (message) {
    (0, _jquery["default"])("#error-popup-title").text(title);
    (0, _jquery["default"])("#error-popup-message").text(message);
  } else {
    (0, _jquery["default"])("#error-popup-title").text(_("Error"));
    (0, _jquery["default"])("#error-popup-message").text(title);
  }

  (0, _jquery["default"])("#show-error-dialog").click(); //$("#accounts-create").click();
} // 账户页面在 user_init 函数之外，需要一个全局变量才能访问到


var g_processPagination;

function user_init() {
  var account_empty_tmpl = (0, _jquery["default"])("#account-empty-tmpl").html();

  _mustache["default"].parse(account_empty_tmpl);

  var rules_list_tmpl = (0, _jquery["default"])("#rules-list-tmpl").html();

  _mustache["default"].parse(rules_list_tmpl);

  var overview_page = new PageAccounts();
  var create_page = new PageAccountsCreate();
  create_page.setup(render_users);
  var account_page = new PageAccount(); // 分页界面的相关变量放在这做成全局变量

  var g_vue_pagination_user;
  var g_cur_page_user = 1;
  var g_cur_page_user_rules = 1;
  var g_page_size_user = 20;

  function processPagination(units) {
    // 分页展示
    if (!g_vue_pagination_user) {
      g_vue_pagination_user = new Vue({
        template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
        el: "#user-vue-app-div",
        methods: {
          handleSizeChange: function handleSizeChange(val) {
            g_page_size_user = val;
            console.log("set g_page_size_user to:", val);

            if (window.location.href.indexOf("#/usersrules") < 0) {
              // group page
              overview_page.show();
            } else {
              // rules page
              show_rules_page();
              registerRulesEvents();
            }
          },
          handleCurrentChange: function handleCurrentChange(val) {
            if (window.location.href.indexOf("#/usersrules") < 0) {
              g_cur_page_user = val;
              console.log("set g_cur_page_user to:", val);
              overview_page.show();
            } else {
              g_cur_page_user_rules = val;
              console.log("set g_cur_page_user_rules to:", val);
              show_rules_page();
              registerRulesEvents();
            }
          }
        },
        data: {
          current_page: g_cur_page_user,
          page_size: g_page_size_user,
          total: units.length
        }
      });
    } else {
      if (window.location.href.indexOf("#/usersrules") < 0) {
        g_vue_pagination_user.current_page = g_cur_page_user;
      } else {
        g_vue_pagination_user.current_page = g_cur_page_user_rules;
      }

      g_vue_pagination_user.page_size = g_page_size_user;
      g_vue_pagination_user.total = units.length;
    }

    var newunits;

    if (window.location.href.indexOf("#/usersrules") < 0) {
      newunits = units.slice((g_cur_page_user - 1) * g_page_size_user, g_cur_page_user * g_page_size_user);
    } else {
      newunits = units.slice((g_cur_page_user_rules - 1) * g_page_size_user, g_cur_page_user_rules * g_page_size_user);
    }

    return newunits;
  }

  g_processPagination = processPagination;

  function getAssertById(assertid) {
    for (var i = 0; i < g_asserts_bak.length; i++) {
      if (g_asserts_bak[i].assertid == assertid) {
        return g_asserts_bak[i];
      }
    }

    return false;
  }

  function getRuleById(id) {
    for (var i = 0; i < g_rules_bak.length; i++) {
      if (g_rules_bak[i].id == id) {
        return g_rules_bak[i];
      }
    }

    return false;
  }

  function render_user_detail() {
    var path = window.location.href;
    var username = path.split("userdetail-")[1];
    account_page.setusername(username); // 如果还没有获取用户信息，先获取用户信息

    if (g_users_bak.length < 1) {
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getUsers").fail(function (err) {
        console.log("getUsers err:", err);
        (0, _jquery["default"])("#loading-fallback").hide();
      }).done(function (res) {
        // console.log("getUsers res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getUsers err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        info = info.data;
        g_users_bak = info;
        (0, _jquery["default"])("#content-header").hide();
        (0, _jquery["default"])("#loading-fallback").hide();
        overview_page.hide();
        account_page.setup();
        account_page.show();
      });
    } else {
      (0, _jquery["default"])("#content-header").hide();
      (0, _jquery["default"])("#loading-fallback").hide();
      overview_page.hide();
      account_page.setup();
      account_page.show();
    }
  }

  function show_users_page() {
    if (g_users_bak.length < 1) {
      var html = _mustache["default"].render(account_empty_tmpl, {
        empty_text: "尚未创建账户"
      });

      return (0, _jquery["default"])("#accounts-list").html(html);
    }

    (0, _jquery["default"])("#content-header").show();
    account_page.hide();
    overview_page.show();
    (0, _jquery["default"])("button.delete-user-btn").unbind("click").click(function (e) {
      var username = (0, _jquery["default"])(this).data("user-name");
      (0, _jquery["default"])("#confirm-del-user-private-data").data("private-data", username);
      (0, _jquery["default"])("#confirm-del-user-msg").text("确认要删除账户策略 " + username + " 吗?");
    });
    (0, _jquery["default"])("#confirm-del-user-confirm").unbind("click").click(function (e) {
      var name = (0, _jquery["default"])("#confirm-del-user-private-data").data("private-data");
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/delUser", {
        "name": name
      }).fail(function (err) {
        console.log("delUser err:", err);
        (0, _jquery["default"])("#confirm-del-user-msg").text("删除账户策略失败");
      }).done(function (res) {
        console.log("delUser res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          return (0, _jquery["default"])("#confirm-del-user-msg").text("删除账户策略失败：" + info.error);
        }

        (0, _jquery["default"])("#confirm-del-user-msg").text("删除账户策略成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#confirm-del-user-close").click();
          render_users();
        }, 1500);
      });
    });
    (0, _jquery["default"])("tr.unit-tr-user-row").unbind("click").click(function (e) {
      if (e.target.localName === "button") {
        return;
      }

      var user = (0, _jquery["default"])(this).data("goto-unit");
      cockpit.location.go(["userdetail-" + user]);
    });
  }

  function render_users() {
    // 如果是从账户详情页面跳回，需要先隐藏掉账户详情页面
    account_page.hide();
    (0, _jquery["default"])("#add-rule").hide();
    (0, _jquery["default"])("#accounts-create").show();
    (0, _jquery["default"])("#loading-fallback").show();
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getUsers").fail(function (err) {
      console.log("getUsers err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    }).done(function (res) {
      // console.log("getUsers res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getUsers err:", res);
        (0, _jquery["default"])("#loading-fallback").hide();
        return;
      }

      info = info.data;
      g_users_bak = info;
      show_users_page();
      (0, _jquery["default"])("#loading-fallback").hide();
    });
  }

  function show_rules_page() {
    if (g_rules_bak.length < 1) {
      var html = _mustache["default"].render(account_empty_tmpl, {
        empty_text: "尚未创建规则"
      });

      return (0, _jquery["default"])("#accounts-list").html(html);
    }

    account_page.hide();
    overview_page.hide();
    var header = {
      Name: "规则名称",
      Straname: "策略名称",
      Applyto: "应用到",
      Status: "规则状态",
      Operate: "操作"
    };
    var units = [];

    for (var i = 0; i < g_rules_bak.length; i++) {
      var unit = g_rules_bak[i];
      var applytotext = "";
      var assertsarr = unit.applyto.split(";");
      var deleted = [];

      for (var _i = 0; _i < assertsarr.length; _i++) {
        if (!assertsarr[_i] || assertsarr[_i].length < 1) {
          continue;
        }

        var asserttmp = getAssertById(assertsarr[_i]);

        if (!asserttmp.assertip) {
          // 过滤掉已删除的资产 添加到已删除列表
          deleted.push(assertsarr[_i]);
          continue;
        }

        applytotext = applytotext + "资产：" + asserttmp.assertip + "-" + asserttmp.assertname + ";";
      }

      unit.applytotext = applytotext;

      try {
        var userstra = _jquery["default"].parseJSON(unit.stracontent);

        unit.straname = userstra.name;
      } catch (e) {
        console.log(e);
      }

      if (unit.applycount.length < 1 || unit.status == "redownload") {
        unit.status = "下发中";
      } else {
        try {
          var applyjson = _jquery["default"].parseJSON(unit.applycount);

          var keys = Object.keys(applyjson);
          var flg = true;

          for (var _i2 = 0; _i2 < keys.length; _i2++) {
            if (applyjson[keys[_i2]]["applycount"] < unit.editcount) {
              // 说明还是上次的下发结果
              unit.status = "尚未下发";
              break;
            }

            if (applyjson[keys[_i2]]["result"] != "succeed") {
              // 判断失败的是否为删除的如果在删除的里面继续循环
              if (_jquery["default"].inArray(keys[_i2], deleted) == -1) {
                unit.status = "下发失败";
                flg = false;
                break;
              }
            }
          } // 如果全部都成功，才认为下发成功


          if (!unit.status || unit.status.length < 1 || flg) {
            unit.status = "下发成功";
          }
        } catch (e) {
          console.log(e);
        }
      }

      unit.ruleid = g_rules_bak[i].id;
      units.push(unit);
    } // 分页展示


    units = processPagination(units);

    var text = _mustache["default"].render(rules_list_tmpl, {
      table_head: header,
      units: units
    });

    (0, _jquery["default"])("#accounts-list").html(text);
  }

  var vue_choose_asserts;
  var vue_edit_choose_asserts; // vuedata 放在这里定义，新增，编辑，新增确认，编辑确认的时候都可以访问

  var vuedata;

  function getVuedataByAssertsAndGroups(info) {
    vuedata = [];
    var allGroupAsserts = [];
    var allasserts = info["allasserts"];

    function getAssertsById(id) {
      for (var i = 0; i < allasserts.length; i++) {
        if (allasserts[i].assertid == id) {
          return allasserts[i];
        }
      }

      return {};
    }

    for (var i = 0; i < info["allgroups"].length; i++) {
      var grouptmp = info["allgroups"][i];
      var unit = {
        id: grouptmp.groupid,
        label: "分组：" + grouptmp.groupname,
        children: []
      };
      var tmparr = grouptmp.groupasserts.split(";");

      for (var k = 0; k < tmparr.length; k++) {
        if (!tmparr[k] || tmparr[k].length < 1) {
          continue;
        }

        var asserttmp = getAssertsById(tmparr[k]);

        if (asserttmp.assertip == "localhost") {
          continue;
        }

        if (!asserttmp.assertip) {
          // 过滤掉已经删除的
          continue;
        }

        unit.children.push({
          id: tmparr[k],
          label: "资产：" + asserttmp.assertip + "-" + asserttmp.assertname
        });

        if (allGroupAsserts.indexOf(tmparr[k]) < 0) {
          allGroupAsserts.push(tmparr[k]);
        }
      }

      if (unit.children.length == 0) {
        continue;
      }

      vuedata.push(unit);
    }

    for (var _i3 = 0; _i3 < info["allasserts"].length; _i3++) {
      var _asserttmp = info["allasserts"][_i3];

      if (allGroupAsserts.indexOf(_asserttmp.assertid) >= 0) {
        continue;
      }

      if (_asserttmp.assertip == "localhost") {
        continue;
      }

      var _unit = {
        id: _asserttmp.assertid,
        label: "资产：" + _asserttmp.assertip + "-" + _asserttmp.assertname
      };
      vuedata.push(_unit);
    }

    return vuedata;
  }

  function registerRulesEvents() {
    // 点击下发按钮触发后台下发
    (0, _jquery["default"])("button.download-rule-btn").unbind("click").click(function (e) {
      var ruleid = (0, _jquery["default"])(this).data("rule-id");
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/downloadRule", {
        "type": "user",
        id: ruleid
      }).fail(function (err) {
        console.log("downloadRule err:", err);
        show_error_dialog("错误", "通知后台下发失败");
      }).done(function (res) {
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("downloadRule err:", res);
          return show_error_dialog("错误", "通知后台下发失败：" + info.error);
        }

        if (info.error) {
          return show_error_dialog("提示", info.error);
        }

        show_error_dialog("提示", "通知后台下发成功");
        setTimeout(render_rules, 1500);
      });
    }); // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件

    (0, _jquery["default"])(".user-rule-opr-more").unbind("click").on("click", function (e) {
      var top = (0, _jquery["default"])(this).offset().top;
      var left = (0, _jquery["default"])(this).offset().left;
      var top1 = (0, _jquery["default"])("html").scrollTop();
      top = top - top1;
      var width = parseInt((0, _jquery["default"])(this).css("width").replace("px", ""));
      (0, _jquery["default"])(".user-rule-popup-menu").css("top", top);
      (0, _jquery["default"])(".user-rule-popup-menu").css("left", left + width);

      if ((0, _jquery["default"])(".user-rule-popup-menu").css("display") == "none") {
        (0, _jquery["default"])(".user-rule-popup-menu").css("display", "inline-grid");
      } else {
        (0, _jquery["default"])(".user-rule-popup-menu").css("display", "none");
      }

      var ruldid = (0, _jquery["default"])(this).data("rule-id");
      (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data", ruldid);
    });
    (0, _jquery["default"])(".user-rule-popup-btn").mouseover(function (e) {
      (0, _jquery["default"])(this).css("background-color", "#def3ff");
    }).mouseout(function (e) {
      (0, _jquery["default"])(this).css("background-color", "white");
    });
    (0, _jquery["default"])(window).unbind("click").on("click", function (e) {
      if (e.target.localName == "button" && (e.target.className.indexOf("user-rule-opr-more") >= 0 || e.target.className.indexOf("user-rule-del") >= 0 || e.target.className.indexOf("user-rule-status") >= 0 || e.target.className.indexOf("user-rule-edit") >= 0)) {
        return;
      }

      (0, _jquery["default"])(".user-rule-popup-menu").css("display", "none");
    });
    (0, _jquery["default"])("button.user-rule-status").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getRuleById(ruleid);

      try {
        (0, _jquery["default"])("#rule-status-content").html("");

        var applycount = _jquery["default"].parseJSON(ruleunit.applycount);

        Object.keys(applycount).forEach(function (key) {
          // 渲染规则页面的时候已经获取过资产信息，这里直接用，不重新请求了
          var asserttmp = getAssertById(key);

          if (!asserttmp) {
            console.log("[user-rule-status]get assert failed,assertid:", applycount[key]);
            return;
          }

          var statustext = "";

          if (applycount[key]["applycount"] < ruleunit.editcount) {
            statustext = "尚未下发";
          } else {
            if (applycount[key]["result"] == "succeed") {
              statustext = "下发成功";
            } else {
              statustext = "下发失败";
            }
          }

          var tr = "<tr><td class='text-align-left'>" + asserttmp.assertip + "</td><td>" + asserttmp.assertname + "</td><td><span class=''>" + statustext + "</span>" + "</td><td><buttom data-toggle='modal' class='btn btn-default userrule-status'" + " data-target='#userrule-status-dialog' userrule-assert-id='" + key + "'>查看详情</buttom>" + "</td></tr>";
          (0, _jquery["default"])("#rule-status-content").append((0, _jquery["default"])(tr));
        });
        (0, _jquery["default"])("buttom.userrule-status").unbind("click").click(function (e) {
          var buttomid = (0, _jquery["default"])(this).attr("userrule-assert-id");
          (0, _jquery["default"])("#userrule-status-msg").text(applycount[buttomid]["result"]);
        });
      } catch (e) {
        console.log(e);
      }
    });
    (0, _jquery["default"])("button.user-rule-passwd").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      (0, _jquery["default"])("#rule-passwd-msg").text("");
      (0, _jquery["default"])("#rule-passwd-content").html("");
      var ruleid = (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data");
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getUserPassByRuleid", {
        "ruleid": ruleid
      }).fail(function (err) {
        console.log("getUserPassByRuleid err:", err);
        (0, _jquery["default"])("#rule-passwd-msg").text("获取资产密码失败");
      }).done(function (res) {
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getUserPassByRuleid err:", res);
          return (0, _jquery["default"])("#rule-passwd-msg").text("获取资产密码失败：" + info.msg);
        }

        info = info.data;

        for (var i = 0; i < info.length; i++) {
          var assertid = info[i]["assertid"];
          var asserttmp = getAssertById(assertid);
          var tr = "<tr><td class='text-align-left'>" + asserttmp.assertip + "</td><td>" + info[i]["username"] + "</td><td class='show-password-area' data-id='" + assertid + "' data-passwd='" + info[i]["password"] + "'>" + "******" + "</td><td>" + "<button class='btn btn-default show-pass-btn' data-id='" + assertid + "'>显示</button>" + "<button class='btn btn-default hide-pass-btn' data-id='" + assertid + "' style='margin-left:3px'>隐藏</button>" + "</td></tr>";
          (0, _jquery["default"])("#rule-passwd-content").append((0, _jquery["default"])(tr));
        }

        (0, _jquery["default"])("button.show-pass-btn").unbind("click").click(function (e) {
          var assertid = (0, _jquery["default"])(this).data("id");
          var ele = (0, _jquery["default"])("td.show-password-area[data-id=" + assertid + "]");
          ele.text(ele.data("passwd"));
        });
        (0, _jquery["default"])("button.hide-pass-btn").unbind("click").click(function (e) {
          var assertid = (0, _jquery["default"])(this).data("id");
          var ele = (0, _jquery["default"])("td.show-password-area[data-id=" + assertid + "]");
          ele.text("******");
        });
      });
    });
    (0, _jquery["default"])("button.user-rule-edit").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getRuleById(ruleid);
      (0, _jquery["default"])("#edit-rule-name").val(ruleunit.name);
      var http = cockpit.http({
        "port": 9091
      });
      http.get("/getUsers").fail(function (err) {
        console.log("getUsers err:", err);
        (0, _jquery["default"])("#edit-rule-msg").text("获取账号策略失败");
      }).done(function (res) {
        // console.log("getUsers res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getUsers err:", res);
          return (0, _jquery["default"])("#edit-rule-msg").text("获取账号策略失败：" + info.error);
        }

        info = info.data;
        g_users_bak = info;
        (0, _jquery["default"])("#edit-stra-name").html("");

        for (var i = 0; i < g_users_bak.length; i++) {
          var html = "";

          if (g_users_bak[i].id == ruleunit.straid) {
            html = '<option selected="selected" value="' + g_users_bak[i].id + '">' + g_users_bak[i].name + '</option>';
          } else {
            html = '<option value="' + g_users_bak[i].id + '">' + g_users_bak[i].name + '</option>';
          }

          (0, _jquery["default"])("#edit-stra-name").append((0, _jquery["default"])(html));
        } //$("#edit-stra-name").val(ruleunit.straname);
        // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
        // 先获取资产和分组信息


        http.get("/getGroupsAndAsserts").fail(function (err) {
          console.log("getGroupsAndAsserts err:", err);
          (0, _jquery["default"])("#edit-rule-msg").text("获取资产和分组失败");
        }).done(function (res) {
          // console.log("getGroupsAndAsserts res:", res);
          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("getGroupsAndAsserts err:", res);
            return (0, _jquery["default"])("#edit-rule-msg").text("获取资产和分组失败：" + info.error);
          }

          info = info.data;
          vuedata = getVuedataByAssertsAndGroups(info);

          if (!vue_edit_choose_asserts) {
            vue_edit_choose_asserts = new Vue({
              template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
              el: "#vue-app-edit-div",
              methods: {
                getCheckedNodes: function getCheckedNodes() {
                  return this.$refs.tree.getCheckedNodes();
                },
                setCheckedKeys: function setCheckedKeys(data) {
                  this.$refs.tree.setCheckedKeys(data);
                }
              },
              data: {
                data: vuedata,
                defaultProps: {
                  children: 'children',
                  label: 'label'
                }
              },
              watch: {
                data: function data(newdata, olddata) {//
                }
              }
            });
          }

          vue_edit_choose_asserts.data = vuedata;
          var checkedAsserts = ruleunit.applyto.split(";");
          vue_edit_choose_asserts.setCheckedKeys(checkedAsserts);
        });
      });
    });
    (0, _jquery["default"])("#edit-rule-confirm").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data");
      var choosedAssertsAndGroups = vue_edit_choose_asserts.getCheckedNodes();
      var choosedAsserts = [];

      for (var i = 0; i < choosedAssertsAndGroups.length; i++) {
        if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
          choosedAsserts.push(choosedAssertsAndGroups[i].id);
        }
      }

      if (choosedAsserts.length < 1) {
        return (0, _jquery["default"])("#edit-rule-msg").text("请至少选择一个资产");
      }

      var assertsstr = choosedAsserts.join(";");
      var name = (0, _jquery["default"])("#edit-rule-name").val();

      if (!name || name.length < 1 || name.length > 32) {
        return (0, _jquery["default"])("#edit-rule-msg").text("请输入合法的名称，最大32字符");
      }

      var straid = (0, _jquery["default"])("#edit-stra-name option:selected").val();
      var http = cockpit.http({
        "port": 9091
      });
      http.post("/editRule", {
        id: ruleid,
        type: "user",
        name: name,
        straid: straid,
        asserts: assertsstr
      }).fail(function (err) {
        console.log("editRule err:", err);
        (0, _jquery["default"])("#edit-rule-msg").text("编辑规则失败");
      }).done(function (res) {
        console.log("editRule res:", res);

        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("editRule err:", res);
          return (0, _jquery["default"])("#edit-rule-msg").text("编辑规则失败：" + info.error);
        }

        (0, _jquery["default"])("#edit-rule-msg").text("编辑规则成功");
        setTimeout(function (e) {
          (0, _jquery["default"])("#edit-rule-close").click();
          render_rules();
        }, 1500);
      });
    });
    (0, _jquery["default"])("button.user-rule-del").unbind("click").click(function (e) {
      // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
      var ruleid = (0, _jquery["default"])("#user-rule-popup-menu-private-data").data("private-data");
      var ruleunit = getRuleById(ruleid);
      (0, _jquery["default"])("#confirm-del-user-rule-msg").text("确认要删除规则 " + ruleunit.name + " 吗？");
      (0, _jquery["default"])("button#confirm-del-user-rule-confirm").unbind("click").click(function (e) {
        var http = cockpit.http({
          "port": 9091
        });
        http.post("/delRule", {
          type: "user",
          id: ruleid
        }).fail(function (err) {
          console.log("delRule err:", err);
          (0, _jquery["default"])("#confirm-del-user-rule-msg").text("删除规则失败");
        }).done(function (res) {
          // console.log("getUsers res:", res);
          var info = _jquery["default"].parseJSON(res);

          if (!info.succeed) {
            console.log("getUsers err:", res);
            (0, _jquery["default"])("#confirm-del-user-rule-msg").text("删除规则失败：" + info.error);
            return;
          }

          (0, _jquery["default"])("#confirm-del-user-rule-msg").text("删除规则成功");
          setTimeout(function (e) {
            (0, _jquery["default"])("#confirm-del-user-rule-close").click();
            render_rules();
          }, 1500);
        });
      });
    });
  }

  function render_rules() {
    (0, _jquery["default"])("#content-header").show();
    (0, _jquery["default"])("#accounts-create").hide();
    (0, _jquery["default"])("#add-rule").show();
    (0, _jquery["default"])(".user-rule-popup-menu").css("display", "none");
    (0, _jquery["default"])("#loading-fallback").show();
    clearInterval(intv);
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getRules", {
      "type": "user"
    }).fail(function (err) {
      console.log("getRules err:", err);
      (0, _jquery["default"])("#loading-fallback").hide();
    }).done(function (res) {
      // console.log("getRules res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getRules err:", res);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }

      info = info.data;
      g_rules_bak = info; // 规则里面还要展示应用到的资产，需要获取资产详细信息

      http.get("/getAsserts").fail(function (err) {
        console.log("getAsserts err:", err);
        return (0, _jquery["default"])("#loading-fallback").hide();
      }).done(function (res) {
        // console.log("getAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getAsserts err:", res);
          (0, _jquery["default"])("#loading-fallback").hide();
          return;
        }

        info = info.data;
        g_asserts_bak = info;
        show_rules_page();
        (0, _jquery["default"])("#loading-fallback").hide();
        registerRulesEvents(); // 定时器获取规则状态

        var dlsucceed = /\u4e0b\u53d1\u4e2d/;
        intv = setInterval(function () {
          var isdone = true;

          for (var i = 0; i < g_rules_bak.length; i++) {
            if (dlsucceed.test(g_rules_bak[i].status)) {
              isdone = false;
              http.get("/getRuleState", {
                "type": "user"
              }).fail(function (err) {
                console.log("getRules of user err:", err);
              }).done(function (res) {
                var info = _jquery["default"].parseJSON(res);

                if (!info.succeed) {
                  console.log("getRules of user err:", res);
                }

                info = info.data;
                g_rules_bak = info ? info : g_rules_bak;
              });
            } else {
              for (var k in g_rules_bak) {
                var arule = g_rules_bak[k];
                (0, _jquery["default"])("#user-rule-" + arule["id"]).text(arule["status"]);
              }
            }
          }

          if (isdone) {
            clearInterval(intv);
          }
        }, 5000);
      });
    });
  }

  (0, _jquery["default"])("#add-rule").unbind("click").click(function (e) {
    (0, _jquery["default"])("#add-stra-name").html("");
    (0, _jquery["default"])("#add-rule-name").val("");
    (0, _jquery["default"])("#add-rule-msg").text("");
    var http = cockpit.http({
      "port": 9091
    });
    http.get("/getUsers").fail(function (err) {
      console.log("getUsers err:", err);
      (0, _jquery["default"])("#add-rule-msg").text("获取账号策略失败");
    }).done(function (res) {
      // console.log("getUsers res:", res);
      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("getUsers err:", res);
        return (0, _jquery["default"])("#add-rule-msg").text("获取账号策略失败：" + info.error);
      }

      info = info.data;
      g_users_bak = info;
      (0, _jquery["default"])("#add-stra-name").html("");

      for (var i = 0; i < g_users_bak.length; i++) {
        var html = '<option value="' + g_users_bak[i].id + '">' + g_users_bak[i].name + '</option>';
        (0, _jquery["default"])("#add-stra-name").append((0, _jquery["default"])(html));
      } // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
      // 先获取资产和分组信息


      http.get("/getGroupsAndAsserts").fail(function (err) {
        console.log("getGroupsAndAsserts err:", err);
        (0, _jquery["default"])("#add-rule-msg").text("获取资产和分组失败");
      }).done(function (res) {
        // console.log("getGroupsAndAsserts res:", res);
        var info = _jquery["default"].parseJSON(res);

        if (!info.succeed) {
          console.log("getGroupsAndAsserts err:", res);
          return (0, _jquery["default"])("#add-rule-msg").text("获取资产和分组失败：" + info.error);
        }

        info = info.data;
        vuedata = getVuedataByAssertsAndGroups(info);

        if (!vue_choose_asserts) {
          vue_choose_asserts = new Vue({
            template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
            el: "#vue-app-div",
            methods: {
              getCheckedNodes: function getCheckedNodes() {
                return this.$refs.tree.getCheckedNodes();
              },
              setCheckedKeys: function setCheckedKeys(data) {
                this.$refs.tree.setCheckedKeys(data);
              }
            },
            data: {
              data: vuedata,
              defaultProps: {
                children: 'children',
                label: 'label'
              }
            },
            watch: {
              data: function data(newdata, olddata) {//
              }
            }
          });
        }

        vue_choose_asserts.data = vuedata;
      });
    });
  }); // 确认添加规则时的操作

  (0, _jquery["default"])("#add-rule-confirm").unbind("click").click(function (e) {
    var choosedAssertsAndGroups = vue_choose_asserts.getCheckedNodes();
    var choosedAsserts = [];

    for (var i = 0; i < choosedAssertsAndGroups.length; i++) {
      if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
        choosedAsserts.push(choosedAssertsAndGroups[i].id);
      }
    }

    var choosedGroups = []; // 检查是否某个分组的所有资产都选择上了，如果都选择上了，则认为应用到分组内的所有资产，包括以后添加的?
    // 确定是否选择了分组不太确定，如果第一次建立规则时没选全分组内的资产，后来删除了分组内没选的资产，
    // 下次编辑的时候就会变成选择了分组内的全部资产了，还是只按照资产下发，如果改变了分组状态，
    // 需要重新编辑规则，并且下发

    for (var _i4 = 0; _i4 < choosedAssertsAndGroups.length; _i4++) {
      if (choosedAssertsAndGroups[_i4].label.indexOf("资产") == 0) {
        continue;
      }
    }

    if (choosedAsserts.length < 1) {
      return (0, _jquery["default"])("#add-rule-msg").text("请至少选择一个资产");
    }

    var assertsstr = choosedAsserts.join(";");
    var name = (0, _jquery["default"])("#add-rule-name").val();

    if (!name || name.length < 1 || name.length > 32) {
      return (0, _jquery["default"])("#add-rule-msg").text("请输入合法的名称，最大32字符");
    }

    var straid = (0, _jquery["default"])("#add-stra-name option:selected").val();

    if (!straid || straid.length < 1) {
      return (0, _jquery["default"])("#add-rule-msg").text("请选择合法的策略");
    }

    var http = cockpit.http({
      "port": 9091
    });
    http.post("/addRule", {
      type: "user",
      name: name,
      straid: straid,
      asserts: assertsstr
    }).fail(function (err) {
      console.log("addRule err:", err);
      (0, _jquery["default"])("#add-rule-msg").text("添加规则失败");
    }).done(function (res) {
      console.log("addRule res:", res);

      var info = _jquery["default"].parseJSON(res);

      if (!info.succeed) {
        console.log("addRule err:", res);
        return (0, _jquery["default"])("#add-rule-msg").text("添加规则失败：" + info.error);
      }

      (0, _jquery["default"])("#add-rule-msg").text("添加规则成功");
      setTimeout(function (e) {
        (0, _jquery["default"])("#add-rule-close").click();
        render_rules();
      }, 1500);
    });
  });
  (0, _jquery["default"])('#accounts-filter li').on('click', function () {
    (0, _jquery["default"])('#accounts-filter li').removeClass('active').removeAttr('aria-current');
    (0, _jquery["default"])(this).addClass('active').attr('aria-current', true);
    var pattern = (0, _jquery["default"])(this).attr('data-pattern');

    if (pattern == "usersrules") {
      cockpit.location.go(["usersrules"]);
      (0, _jquery["default"])("#add-account").hide();
      (0, _jquery["default"])("#add-rule").show(); //render_rules();
    } else if (pattern == "users") {
      cockpit.location.go([""]);
      (0, _jquery["default"])("#add-account").show();
      (0, _jquery["default"])("#add-rule").hide(); //render_users()
    }
  });
  (0, _jquery["default"])("#accounts-create").unbind("click").click(function () {
    (0, _jquery["default"])("input#accounts-create-user-name").val("");
    (0, _jquery["default"])("input#accounts-create-full-name").val("");
    (0, _jquery["default"])("input#accounts-create-pw1").val("");
    (0, _jquery["default"])("input#accounts-create-pw2").val("");
    (0, _jquery["default"])("#accounts-create-password-meter").removeClass("weak okay good excellent");
    (0, _jquery["default"])("#accounts-create-password-meter-message").text("");
    (0, _jquery["default"])("input#accounts-create-locked").prop("checked", false);
    (0, _jquery["default"])("input#accounts-create-isadmin").prop("checked", false);
    (0, _jquery["default"])("input#accounts-create-delete").prop("checked", false);
    (0, _jquery["default"])("#create-user-msg").text("");
  }); // 根据 url 初始化渲染页面

  (0, _jquery["default"])("#accounts-filter li").removeClass('active').removeAttr('aria-current');

  function navigate() {
    if (window.location.href.indexOf("#/usersrules") > 0) {
      (0, _jquery["default"])("#usersrules-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#add-account").hide();
      (0, _jquery["default"])("#add-rule").show();
      render_rules();
    } else {
      (0, _jquery["default"])("#users-li").addClass('active').attr('aria-current', true);
      (0, _jquery["default"])("#add-account").show();
      (0, _jquery["default"])("#add-rule").hide();

      if (window.location.href.indexOf("#/userdetail-") > 0) {
        render_user_detail();
      } else {
        render_users();
      }
    }
  }

  (0, _jquery["default"])(cockpit).on("locationchanged", navigate);
  navigate();
}

if (window.location.pathname.indexOf("manager/user.html") > 0) {
  (0, _jquery["default"])(user_init);
}