import $ from "jquery";
import mustache from "mustache";

//import cockpit from "cockpit";
import moment from "moment";
import journal from "journal";
import "patterns";
import "bootstrap-datepicker/dist/js/bootstrap-datepicker";
import { writeAuditlog } from './write-auditlog';

//import "bootstrap-datepicker/dist/locales/bootstrap-datepicker.zh-CN.min";
//import "bootstrap-datepicker/js/bootstrap-datepicker";
//import "bootstrap-datepicker/js/locales/bootstrap-datepicker.zh-CN";

$.fn.datepicker.dates['zh-CN'] = {
    days:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],
    daysShort:["周日","周一","周二","周三","周四","周五","周六"],
    daysMin:["日","一","二","三","四","五","六"],
    months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],
    monthsShort:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],
    today:"今天",
    monthsTitle:"选择月份",
    clear:"清除",
    format:"yyyy-mm-dd",
    titleFormat:"yyyy年mm月",
    weekStart:1
};

function auditlogs_init() {
    console.log("auditlogs_init");

    var units_template = $("#auditlog-units-tmpl").html();
    mustache.parse(units_template);
    // var empty_template = $("#service-empty-tmpl").html();
    // mustache.parse(empty_template);
    // var auditlogs_detail_template = $("#service-template-tmpl").html();
    // mustache.parse(auditlogs_detail_template);

    $("#datepicker1").datepicker({
        language: "zh-CN", //语言
        autoclose: true, //选择后自动关闭
        clearBtn: true,//清除按钮
        format: "yyyy-mm-dd",//日期格式
        startDate: "-90d",
        endDate: new Date()
    });

    $("#datepicker2").datepicker({
        language: 'zh-CN', //语言
        autoclose: true, //选择后自动关闭
        clearBtn: true,//清除按钮
        format: "yyyy-mm-dd",//日期格式
        startDate: "-90d",
        endDate: new Date()
    });

    let g_auditlogs_bak = [];

    //分页界面的相关变量放在这做全局变量
    let g_vue_pagination;
    let g_cur_page = 1;
    let g_page_size = 20;
    let g_total_size = 0;

    function registerAuditlogsEvent() {
        //registerJumpPageConfirmEvent();
        auditlogSearchButtonConfirmEvent();
        //auditlogDeleteOperation();
        auditlogSaveConfig();
        $("#services-dropdown").change(function(e){
            show_auditlogs_page(g_auditlogs_bak);
            registerAuditlogsEvent();
        });
    }

    function show_auditlogs_page(info) {
        // 这个函数不申请数据，只是重新做下匹配
        let pattern = $('#services-filter li.active').attr('data-pattern');
        var operation = ["登录", "退出", "修改"];
        let units = [];

        for(var i=0;i<info.length;i++) {
            var k = info[i].operator;
            var tmp = {"key":info[i].id, "time":info[i].time, "user":info[i].user, "operator":operation[k], "auditobject":info[i].auditobject, "content":info[i].content}
            units.push(tmp)
        }

        let header = {
            key: "key",
            time: "time",
            user: "user",
            operator: "operator",
            auditobject: "auditobject",
            content: "content",
        };

        var text = "";
        if (units.length >= 0)
            text = mustache.render(units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);

        $("#services-list").html(text);
        $("#auditlog-delete-list").hide();
        $("#services").show();
        auditlogDeleteOperation();
        $("#services-dropdown").show();

        $("#loading-fallback").hide();
    }

    function auditlogSaveConfig(){
        let keeptimebak = -1; 
        $("#auditlog-save").unbind("click").click(function(e){
            $("#auditlog-save-msg").text("");
            let content = {
                keeptime : 4
            };

            JSON.stringify(content)
            let http = cockpit.http({
                "port": 9091
            });

            http.get("/getAuditlogConfig", content).done(function(res){
                let info = $.parseJSON(res);
                // console.log(info.content);
                $("#auditlog-keep-time").val(info.content.keeptime);
                keeptimebak = info.content.keeptime;
            }).catch(function(e){ })
        })

        $("#auditlog-save-confirm").unbind("click").click(function(e){
            let keeptime = $("#auditlog-keep-time").children("option:selected").val();
            if (keeptimebak == keeptime)
                return $("#auditlog-save-msg").text("未做任何编辑!");

            $("#auditlog-save-msg").text("配置中，请等待...");

            let http = cockpit.http({
                "port": 9091
            });
            http.post("/setAuditlogConfig", {
                "keeptime": keeptime
            }).done(function(res) {
                // console.log("setAuditlogConfig res:", res);
                let info = $.parseJSON( res );
                if (! info.succeed) {
                    let cent = "日志保存设置失败, keeptime: " + keeptime + ", 失败原因: " + info.error;
                    writeAuditlog(2, "日志保存时间", cent);
                    return $("#auditlog-save-msg").text("日志保存失败：" + info.error);
                }
                $("#auditlog-save-msg").text("日志保存成功");
                let cent = "日志保存设置成功, keeptime: " + keeptime;
                writeAuditlog(2, "日志保存时间", cent);
                setTimeout(function(e) {
                    $("#auditlog-save-close").click();
                }, 1000)
            }).fail(function(exception, err){
                console.log(err);
                $("#auditlog-save-msg").text("日志保存失败");
                let cent = "日志保存设置失败, keeptime: " + keeptime + ", 失败原因: " + err;
                writeAuditlog(2, "日志保存时间", cent);
            })
        })
    }

    function auditlogDeleteOperation(){
        $("button.auditlog-delete").unbind("click").click(function(e){
            let auditlogid = $(this).data("auditlog-id");
            console.log("删除日志 auditlogid:", auditlogid);

            $("#auditlog-delete-confirm").unbind("click").click(function(e){
                $("#auditlog-delete-msg").text("删除中，请等待...");
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/deleteAuditlog", {
                    "id": auditlogid
                }).done(function(res) {
                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        return $("#auditlog-delete-msg").text("删除日志失败：" + info.error);
                    }
                    $("#auditlog-delete-msg").text("删除日志成功");
                    setTimeout(function(e) {
                        $("#auditlog-delete-close").click();
                    }, 1000)
                    auditlogSearchByFilter();
                }).fail(function(exception, err){
                    $("#auditlog-delete-msg").text("删除日志失败");
                })
            })
        })
    }

    function auditlogSearchByFilter() {
        console.log("auditlogSearchByFilter");
        let jumppage = String(g_cur_page);
        let pagesize = String(g_page_size);
        let begintime = $("#datepicker1").val();
        let endtime = $("#datepicker2").val();
        //alert(begintime + endtime);
        let user = $("#auditlog-user").children("option:selected").val();
        let operation = $("#auditlog-operator").children("option:selected").val();
        $("#loading-fallback").show();
        //alert(priority);
        let http = cockpit.http({
            "port": 9091
        });
        console.log("auditlogSearchByFilter jumppage:", jumppage);
        http.get("/getAuditlogsByFilter", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "user": user, "operator": operation}).done(function(res){
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getAuditlogsByFilter err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            let data = info.data.log;
            g_total_size = info.data.totalrecords;
            g_auditlogs_bak = data;

            console.log("g_total_size: ", g_total_size, ", offset:", ((g_cur_page - 1) * g_page_size));
            if (g_cur_page !== 1 && g_total_size <= ((g_cur_page - 1) * g_page_size))
            {
                if (g_total_size === 0) {
                    g_cur_page = 1;
                } else {
                    g_cur_page = Math.ceil(g_total_size / g_page_size);
                }
                console.log("auditlogSearchByFilter change cur page to: ", g_cur_page);
            }
            show_auditlogs_page(data);
            $("#loading-fallback").hide();
            //点击搜索按钮后，更改分页相关变量
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = g_total_size;
        }).catch(err=>{
            console.log("getClientInfo err:", err);
            $("#loading-fallback").hide();
        })
    }

    function auditlogSearchButtonConfirmEvent(){
        console.log("auditlogSearchButtonConfirmEvent");
        $("#search-confirm").unbind("click").click(function(e) {
            auditlogSearchByFilter();
        })
    }

    function render_auditlogs() {
        console.log("render_auditlogs");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });
        let pagesize = String(g_page_size);
        let jumppage = String(g_cur_page);

        http.get("/getAuditlogs", {"jumppage": jumppage, "pagesize": pagesize}).done(function(res){
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getAuditlogs err:", res);
                $("#loading-fallback").hide();
                return ;
            }

            let data = info.data.log;
            let user = info.data.user;
            g_total_size = parseInt(info.data.totalrecords);

            console.log("total size:", g_total_size);

            if (!g_vue_pagination) {
                g_vue_pagination = new Vue({
                    template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80,100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                    el: "#vue-auditlog-div",
                    methods: {
                        handleSizeChange(val) {
                            //发请求，传递当前页和每页数据大小，得到当前页数据
                            g_page_size = val;
                            g_cur_page = 1;
                            console.log("set g_page_size to:", val);
                            let http = cockpit.http({
                                "port": 9091
                            });
                            let jumppage = String(g_cur_page);
                            let pagesize = String(g_page_size);
                            let begintime = $("#datepicker1").val();
                            let endtime = $("#datepicker2").val();
                            let user = $("#auditlog-user").children("option:selected").val();
                            let operator = $("#auditlog-operator").children("option:selected").val();

                            $("#loading-fallback").show();
                            http.get("/getAuditlogsByPage", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "user": user, "operator": operator}).done(function(res) {
                                let info = $.parseJSON( res );
                                if (! info.succeed) {
                                    console.log("getAuditlogsByPage err:", res);
                                    $("#loading-fallback").hide();
                                    return ;
                                   }
                                let data = info.data;
                                g_auditlogs_bak = data;
                                show_auditlogs_page(data);
                                $("#loading-fallback").hide();
                            }).fail(function(exception, err){
                                console.log("getAuditlogsByPage err:", err);
                                //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
                            })
                        },
                        handleCurrentChange(val) {
                            //发请求，传递当前页和每页数据大小，得到当前页数据
                            g_cur_page = val;
                            console.log("set g_cur_page to:", val);
                            let http = cockpit.http({
                                "port": 9091
                            });
                            let jumppage = String(g_cur_page);
                            let pagesize = String(g_page_size);
                            let begintime = $("#datepicker1").val();
                            let endtime = $("#datepicker2").val();
                            let user = $("#auditlog-user").children("option:selected").val();
                            let operator = $("#auditlog-operator").children("option:selected").val();

                            $("#loading-fallback").show();
                            http.get("/getAuditlogsByPage", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "user": user, "operator": operator}).done(function(res) {
                                // console.log("getAuditlogsByPage res:", domain);

                                let info = $.parseJSON( res );
                                if (! info.succeed) {
                                    console.log("getAuditlogsByPage err:", res);
                                    $("#loading-fallback").hide();
                                    return ;
                                   }
                                let data = info.data;
                                g_auditlogs_bak = data;
                                show_auditlogs_page(data);
                                $("#loading-fallback").hide();
                                 }).fail(function(exception, err){
                                console.log("getAuditlogsByPage err:", err);
                                //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
                            })
                        }
                    },
                    data: {
                        current_page: g_cur_page,
                        page_size: g_page_size,
                        total: g_total_size,
                    }
                })
            } else {
                g_vue_pagination.current_page = g_cur_page;
                g_vue_pagination.page_size = g_page_size;
                g_vue_pagination.total = g_total_size;
            }

            for (var id in user){
                $("#auditlog-user").append($("<option>").text(user[id]));
            } 
            g_auditlogs_bak = data;
            show_auditlogs_page(data);
            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getClientInfo err:", err);
            $("#loading-fallback").hide();
        })
        // fix -> fun() 
        auditlogDeleteOperation();
        registerAuditlogsEvent();
    }

    function has_special_chars(str)
    {
        var arr = ["&", "\\", "/", "*", ">", "<", "@", "!"];
        for (var i = 0; i < arr.length; i++)
        {
            for (var j = 0; j < str.length; j++)
            {
                if (arr[i] == str.charAt(j))
                {
                    return true;
                }
            }
        }
        return false;
    }

    // 根据 url 初始化渲染页面
    $("#services-filter li")
        .removeClass('active')
        .removeAttr('aria-current');
    render_auditlogs();
}

/* These add themselves to jQuery so just including is enough */
cockpit.translate();
const _ = cockpit.gettext;
moment.locale(cockpit.language);

if (window.location.pathname.indexOf("manager/auditlog.html") >  0){
    auditlogs_init();
}
