

    var jQMeter_defaults = {

		width : '100%',
		height : '15px',
		bgColor : '#444',
		barColor : '#bfd255',
		meterOrientation : 'horizontal',
		animationSpeed : 1000,
		counterSpeed : 1000,
		displayTotal : true

	};

    function jQMeter_func(elem, options) {
		options = $.extend(jQMeter_defaults, options);

		//Define plugin options
		let goal = parseInt((options.goal).replace(/\D/g,''));
		let raised = parseInt((options.raised).replace(/\D/g,''));
		let width = options.width;
		let height = options.height;
		let bgColor = options.bgColor;
		let barColor = options.barColor;
		let meterOrientation = options.meterOrientation;
		let animationSpeed = options.animationSpeed;
		let counterSpeed = options.counterSpeed;
		let displayTotal = options.displayTotal;
		let total = (raised / goal) * 100;

		/*
		 * Since the thermometer width/height is set based off of
		 * the total, we force the total to 100% if the goal has
		 * been exceeded.
		 */
		if(total >= 100) {
			total = 100;
		}

		//Create the thermometer layout based on orientation option
		if(meterOrientation == 'vertical') {

			//$(elem).html('<div class="therm outer-therm vertical"><div class="therm inner-therm vertical"><span style="display:none;">' + total + '</span></div></div>');
			$(elem).html('<div class="therm outer-therm vertical"><div class="therm inner-therm vertical"><span>' + total + '</span></div></div>');
			//$(elem).children('.outer-therm').attr('style','width:' + width + ';height:' + height + ';background-color:' + bgColor);
			//$(elem).children('.outer-therm').children('.inner-therm').attr('style','background-color:' + barColor + ';height:0;width:100%');
			$(elem).children('.outer-therm').children('.inner-therm').css({height : total + '%'});

		} else {

			//$(elem).html('<div class="therm outer-therm"><div class="therm inner-therm"><span style="display:none;">' + total + '</span></div></div>');
			$(elem).html('<div class="therm outer-therm"><div class="therm inner-therm"><span>' + total + '</span></div></div>');
			//$(elem).children('.outer-therm').attr('style','width:' + width + ';height:' + height + ';background-color:' + bgColor);
			//$(elem).children('.outer-therm').children('.inner-therm').attr('style','background-color:' + barColor + ';height:' + height + ';width:0');
			$(elem).children('.outer-therm').children('.inner-therm').css({width : total + '%'});

		}

		//If the user wants the total percentage to be displayed in the thermometer
		if(displayTotal) {

			//Accomodate the padding of the thermometer to include the total percentage text
			var formatted_height = parseInt(height);
			var padding = (formatted_height/2) - 13 + 'px 10px';

			if(meterOrientation != 'horizontal'){
			  padding = '10px 0';
			}

			$(elem).children('.outer-therm').children('.inner-therm').children().show();
			$(elem).children('.outer-therm').children('.inner-therm').children().css('padding', padding);

			//Animate the percentage total. Borrowed from: http://stackoverflow.com/questions/23006516/jquery-animated-number-counter-from-zero-to-value
			/*$({ Counter: 0 }).animate({ Counter: $(elem).children('.outer-therm').children('.inner-therm').children().text() }, {
					duration : counterSpeed,
					easing : 'swing',
					step : function() {
						$(elem).children('.outer-therm').children('.inner-therm').children().text(Math.ceil(this.Counter) + '%');
					}
			});*/
			var progress = Math.ceil(total) + '%';
			$(elem).children('.outer-therm').children('.inner-therm').children().text(progress);
			$(elem).children('.outer-therm').children('.inner-therm').children().css("width", progress)
		}

	}

export default {
	jQMeter_func
}