import $ from "jquery";
import mustache from "mustache";

//import cockpit from "cockpit";
import moment from "moment";
import journal from "journal";
import "patterns";
import "bootstrap-datepicker/dist/js/bootstrap-datepicker";
import { writeAuditlog } from './write-auditlog';
//import "bootstrap-datepicker/dist/locales/bootstrap-datepicker.zh-CN.min";
//import "bootstrap-datepicker/js/bootstrap-datepicker";
//import "bootstrap-datepicker/js/locales/bootstrap-datepicker.zh-CN";

$.fn.datepicker.dates['zh-CN'] = {
    days:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],
    daysShort:["周日","周一","周二","周三","周四","周五","周六"],
    daysMin:["日","一","二","三","四","五","六"],
    months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],
    monthsShort:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],
    today:"今天",
    monthsTitle:"选择月份",
    clear:"清除",
    format:"yyyy-mm-dd",
    titleFormat:"yyyy年mm月",
    weekStart:1
}; 

function syslogs_init() {
    console.log("syslogs_init");

    var units_template = $("#services-units-tmpl").html();
    mustache.parse(units_template);
    var empty_template = $("#service-empty-tmpl").html();
    mustache.parse(empty_template);
    var syslogs_detail_template = $("#service-template-tmpl").html();
    mustache.parse(syslogs_detail_template);

    $("#datepicker1").datepicker({
        language: "zh-CN", //语言
        autoclose: true, //选择后自动关闭
        clearBtn: true,//清除按钮
        format: "yyyy-mm-dd",//日期格式
        startDate: "-90d",
        endDate: new Date()
    });

    $("#datepicker2").datepicker({
        language: 'zh-CN', //语言
        autoclose: true, //选择后自动关闭
        clearBtn: true,//清除按钮
        format: "yyyy-mm-dd",//日期格式
        startDate: "-90d",
        endDate: new Date()
    });

    let g_syslogs_bak = [];

    //分页界面的相关变量放在这做全局变量
    let g_vue_pagination;
    let g_cur_page = 1;
    let g_page_size = 20;
    let g_total_size = 0;

    function registerSyslogsEvent() {
		//registerJumpPageConfirmEvent();
        registerSearchButtonConfirmEvent();
        //syslogMessageOperation();
        syslogServerConfig();
        $("#services-dropdown").change(function(e){
            show_syslogs_page(g_syslogs_bak);
            registerSyslogsEvent();
        });
    }

    function getSyslogMessageById(syslogid) {
        console.log("getSyslogMessageById")
        console.log(syslogid)
        for (let i=0;i<g_syslogs_bak.length;i++) {
            if (g_syslogs_bak[i][0] == syslogid) {
                console.log(g_syslogs_bak[i][7])
                return g_syslogs_bak[i][7]
            }
        }
        return false;
    }

    function show_syslogs_page(info) {
        // 这个函数不申请数据，只是重新做下匹配
        let pattern = $('#services-filter li.active').attr('data-pattern');

        var severity = ["紧急", "警报", "关键", "错误", "警告", "通知", "信息", "调试"];

        let units = [];
        for(var i=0;i<info.length;i++) {
            var j = info[i][5];
            var tmp = {"ID": info[i][0], "ReceivedAt":info[i][2], "FromHost":info[i][6], "Priority":severity[j],"Message":info[i][7]}
            units.push(tmp)
         }

        let header = {
            ID: "ID",         
            ReceivedAt: "ReceivedAt",           
            FromHost: "FromHost",            
            NTSeverity: "NTSeverity",
            Message: "Message"
        };
        var text = "";
        if (units.length >= 0)
            text = mustache.render(units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);

        $("#services-list").html(text);
        $("#service-detail-list").hide();
        $("#services").show();
        syslogMessageOperation();
        $("#services-dropdown").show();

        $("#loading-fallback").hide();
    }
    
    function syslogServerConfig(){
        let ipbak = "";
        let portbak = "";
        let databasebak = "";
        let userbak = "";
        let passwordbak = "";
        let keeptimebak = -1;

        $("#syslog-server").unbind("click").click(function(e){
            $("#syslog-server-msg").text("");
            let content = {
                ip : "",
                port : "3306",
                database : "",
                user : "",
                password : "",
                keeptime : 3
            };
            JSON.stringify(content)
            let http = cockpit.http({
                "port": 9091
            });
            http.get("/getdbconfig", content).done(function(res){
                let info = $.parseJSON(res);
                // console.log(info.content);
                $("#syslog-server-ip").val(info.content.ip)
                $("#syslog-server-port").val(info.content.port);
                $("#syslog-server-database").val(info.content.database);
                $("#syslog-server-user").val(info.content.user);
                $("#syslog-server-password").val(info.content.password);
                $("#syslog-keep-time").val(info.content.keeptime);
                ipbak = info.content.ip;
                portbak = info.content.port;
                databasebak = info.content.database;
                userbak = info.content.user;
                passwordbak = info.content.password;
                keeptimebak = info.content.keeptime;
            }).catch(function(e){ })
        })
        $("#syslog-server-confirm").unbind("click").click(function(e){
            let ip = $("#syslog-server-ip").val();
            let port = $("#syslog-server-port").val();
            let database = $("#syslog-server-database").val();
            let user = $("#syslog-server-user").val();
            let password = $("#syslog-server-password").val();
            let keeptime = $("#syslog-keep-time").children("option:selected").val();
            if (ipbak == ip && portbak == port && databasebak == database && userbak == user && passwordbak == password && keeptimebak == keeptime)
                return $("#syslog-server-msg").text("未做任何编辑!");

            $("#syslog-server-msg").text("配置中，请等待...");
            //var result = "ip:" + ip + " " + "port:" + port + " " + "database:" + database + " " + "user:" + user + " " + "password:" + password + " " + "keeptime:" + keeptime;
            //alert(result);
            let http = cockpit.http({
                "port": 9091
            });
            http.post("/setSyslogConfig", {
                "ip": ip,
                "port": port,
                "database": database,
                "user": user,
                "password": password,
                "keeptime": keeptime
            }).done(function(res) {
                // console.log("setSyslogConfig res:", res);
                let info = $.parseJSON( res );
                if (! info.succeed) {
                    let cent = "日志服务器配置失败, ip: " + ip + ", keeptime: " + keeptime + ", 失败原因: " + info.error;
                    writeAuditlog(2, "日志服务器配置", cent);
                    return $("#syslog-server-msg").text("日志服务器配置失败：" + info.error);
                }
                $("#syslog-server-msg").text("日志服务器配置成功");
                let cent = "日志服务器配置成功, ip: " + ip + ", keeptime: " + keeptime;
                writeAuditlog(2, "日志服务器配置", cent);
                setTimeout(function(e) {
                    $("#syslog-server-close").click();
                }, 1000)
            }).fail(function(exception, err){
                console.log(err);
                $("#syslog-server-msg").text("日志服务器配置失败");
                let cent = "日志服务器配置失败, ip: " + ip + ", keeptime: " + keeptime + ", 失败原因: " + err;
                writeAuditlog(2, "日志服务器配置", cent);
            })
        })
    }

    function syslogMessageOperation(){
        $("button.syslog-message").unbind("click").click(function(e){
            let syslogid = $(this).data("syslog-id");
            let syslogmessage = getSyslogMessageById(syslogid);
            //alert(syslogid);
            $("#syslog-message-msg").val(syslogmessage);
            console.log(syslogid);
            console.log(syslogmessage);
        })
    }

    function dealSearchResult(info) {
        let data = info.data.log;
        g_total_size = info.data.totalrecords;
        g_syslogs_bak = data;
        show_syslogs_page(data);
        $("#loading-fallback").hide();
        //点击搜索按钮后，更改分页相关变量
        g_vue_pagination.current_page = g_cur_page;
        g_vue_pagination.page_size = g_page_size;
        g_vue_pagination.total = g_total_size;
    }

    function registerSearchButtonConfirmEvent() {
        $("#search-confirm").unbind("click").click(function(e) {
            //g_cur_page = 1;
            let jumppage = String(g_cur_page);
            let pagesize = String(g_page_size);
            let begintime = $("#datepicker1").val();
            let endtime = $("#datepicker2").val();
            //alert(begintime + endtime);
            let domain = $("#services-domain").children("option:selected").val();
            let priority = $("#services-priority").children("option:selected").val();
            let search = $("#services-search").val();
            $("#loading-fallback").show();
            //alert(priority);
            let http = cockpit.http({ 
                "port": 9091
            });
            http.get("/getRsyslogsByFilter", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "domain": domain, "priority": priority, "search": search}).done(function(res){
                // console.log("getRsyslogsByFilter res:", domain);
                let info = $.parseJSON( res );
                if (! info.succeed) {
                    console.log("getRsyslogsByFilter err:", res);
                    $("#loading-fallback").hide();
                    return ;
                }

                g_total_size = info.data.totalrecords;
                console.log("g_total_size : ", g_total_size, ", offset:", ((g_cur_page - 1) * g_page_size));

                if (g_total_size === 0 || g_cur_page === 1) {
                    g_cur_page = 1;
                    dealSearchResult(info);
                } else if (g_total_size <= ((g_cur_page - 1) * g_page_size)) {
                    g_cur_page = Math.ceil(g_total_size / g_page_size);
                    console.log("change cur page to : ", g_cur_page);
                    let jumppage = String(g_cur_page);
                     http.get("/getRsyslogsByFilter", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "domain": domain, "priority": priority, "search": search}).done(function(res){
                        // console.log("getRsyslogsByFilter res:", domain);
                        let info = $.parseJSON( res );
                        if (! info.succeed) {
                            console.log("getRsyslogsByFilter err:", res);
                            $("#loading-fallback").hide();
                            return ;
                        }
                        dealSearchResult(info);
                     }).catch(err=>{
                        console.log("getClientInfo err:", err);
                        $("#loading-fallback").hide();
                    })
                } else {
                    dealSearchResult(info);
                }
            }).catch(err=>{
                console.log("getClientInfo err:", err);
                $("#loading-fallback").hide();
            })
        })
    }

    function render_syslogs() {
        console.log("render_syslogs");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });
        let pagesize = String(g_page_size);
        let jumppage = String(g_cur_page);
        http.get("/getRsyslogs", {"jumppage": jumppage, "pagesize": pagesize}).done(function(res){
            // console.log("getRsyslogs res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getRsyslogs err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            let data = info.data.log;
            let domain = info.data.domain;
            g_total_size = parseInt(info.data.totalrecords);
            // console.log("the total size is")
            // console.log(info);
            if (!g_vue_pagination) {
                g_vue_pagination = new Vue({
                    template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80,100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                    el: "#vue-syslog-div",
                    methods: {
                        handleSizeChange(val) {
                            //发请求，传递当前页和每页数据大小，得到当前页数据
                            g_page_size = val;
                            g_cur_page = 1;
                            console.log("set g_page_size to:", val);
                            let http = cockpit.http({
                                "port": 9091
                            });
                            let jumppage = String(g_cur_page);
                            let pagesize = String(g_page_size);
                            let begintime = $("#datepicker1").val();
                            let endtime = $("#datepicker2").val();
                            let domain = $("#services-domain").children("option:selected").val();
                            let priority = $("#services-priority").children("option:selected").val();
                            let search = $("#services-search").val();
                            $("#loading-fallback").show();
                            http.get("/getRsyslogsByPage", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "domain": domain, "priority": priority, "search": search}).done(function(res) {
                                // console.log("getRsyslogsByPage res:", domain);
                                let info = $.parseJSON( res );
                                if (! info.succeed) {
                                    console.log("getRsyslogsByPage err:", res);
                                    $("#loading-fallback").hide();
                                    return ;
                                   }
                                let data = info.data.log;
                                g_syslogs_bak = data;
                                show_syslogs_page(data);
                                $("#loading-fallback").hide();
                            }).fail(function(exception, err){
                                console.log("getRsyslogsByPage err:", err);
                                //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
                            })
                        },
                        handleCurrentChange(val) {
                            //发请求，传递当前页和每页数据大小，得到当前页数据
                            g_cur_page = val;
                            console.log("set g_cur_page to:", val);
                            let http = cockpit.http({
                                "port": 9091
                            });
                            let jumppage = String(g_cur_page);
                            let pagesize = String(g_page_size);
                            let begintime = $("#datepicker1").val();
                            let endtime = $("#datepicker2").val();
                            let domain = $("#services-domain").children("option:selected").val();
                            let priority = $("#services-priority").children("option:selected").val();
                            let search = $("#services-search").val();
                            $("#loading-fallback").show();
                            http.get("/getRsyslogsByPage", {"jumppage": jumppage, "pagesize": pagesize, "begintime": begintime, "endtime": endtime, "domain": domain, "priority": priority, "search": search}).done(function(res) {
                                // console.log("getRsyslogsByPage res:", domain);

                                let info = $.parseJSON( res );
                                if (! info.succeed) {
                                    console.log("getRsyslogsByPage err:", res);
                                    $("#loading-fallback").hide();
                                    return ;
                                   }
                                let data = info.data.log;
                                g_syslogs_bak = data;
                                show_syslogs_page(data);
                                $("#loading-fallback").hide();
                                 }).fail(function(exception, err){
                                console.log("getRsyslogsByPage err:", err);
                                //$("#edit-group-msg").text("编辑分组失败，请检查名称是否已经存在");
                            })
                        }
                    },
                    data: {
                        current_page: g_cur_page,
                        page_size: g_page_size,
                        total: g_total_size,
                    }
                })
            } else {
                g_vue_pagination.current_page = g_cur_page;
                g_vue_pagination.page_size = g_page_size;
                g_vue_pagination.total = g_total_size;
            }
            
            for (var id in domain){
                $("#services-domain").append($("<option>").text(domain[id]));
            }   
            g_syslogs_bak = data;
            show_syslogs_page(data);
            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getClientInfo err:", err);
            $("#loading-fallback").hide();
        })
        // fix -> fun() 
        syslogMessageOperation();
        registerSyslogsEvent();
    }
    function has_special_chars(str)
    {
        var arr = ["&", "\\", "/", "*", ">", "<", "@", "!"];
        for (var i = 0; i < arr.length; i++)
        {
            for (var j = 0; j < str.length; j++)
            {
                if (arr[i] == str.charAt(j))
                {
                    return true;
                }
            }
        }
        return false;
    } 

    $('#services-filter li').on('click', function() {
        $('#services-filter li')
            .removeClass('active')
            .removeAttr('aria-current');
        $(this)
            .addClass('active')
            .attr('aria-current', true);

        let pattern = $(this).attr('data-pattern');
        if (pattern == "syslogs") {
            cockpit.location.go(["syslogs"]);
            render_syslogs();
        }
    })

    // 根据 url 初始化渲染页面
    $("#services-filter li")
        .removeClass('active')
        .removeAttr('aria-current');
	render_syslogs();
}

/* These add themselves to jQuery so just including is enough */
cockpit.translate();
const _ = cockpit.gettext;
moment.locale(cockpit.language);
 
if (window.location.pathname.indexOf("manager/logs.html") >  0){
    syslogs_init();
}
