import $ from "jquery";
import mustache from "mustache";

//import cockpit from "cockpit";
import moment from "moment";
import journal from "journal";
import "patterns";
//import "bootstrap-datepicker/dist/js/bootstrap-datepicker";
//import "bootstrap-datepicker/dist/locales/bootstrap-datepicker.zh-CN.min";
//import "bootstrap-datepicker/js/bootstrap-datepicker";
//import "bootstrap-datepicker/js/locales/bootstrap-datepicker.zh-CN";
import JQMeter from "./jqmeter";
import { writeAuditlog } from './write-auditlog';

function show_error_dialog(title, message) {
    if (message) {
        $("#error-popup-title").text(title);
        $("#error-popup-message").text(message);
    } else {
        $("#error-popup-title").text(_("Error"));
        $("#error-popup-message").text(title);
    }

    $("#show-error-dialog").click();
}

function randomString(e) {
  e = e || 32;
  var t = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678",
  a = t.length,
  n = "";
  for (let i = 0; i < e; i++) n += t.charAt(Math.floor(Math.random() * a));
  return n
}

function update_init() {
    console.log("update_init");

    var softrepo_units_template = $("#softrepo-units-tmpl").html();
    mustache.parse(softrepo_units_template);
    let reporule_units_template = $("#reporule-units-tmpl").html();
    mustache.parse(reporule_units_template);
    var empty_template = $("#softrepo-empty-tmpl").html();
    mustache.parse(empty_template);

    var repostrategy_units_template = $("#repostrategy-units-tmpl").html();
    mustache.parse(repostrategy_units_template);

    var updatestrategy_units_template = $("#updatestrategy-units-tmpl").html();
    mustache.parse(updatestrategy_units_template);

    var updaterule_units_template = $("#updaterule-units-tmpl").html();
    mustache.parse(updaterule_units_template);


    let g_softrepos_bak = [];
    let g_repostrategies_bak = [];
    let g_updatestrategies_bak = [];
    let g_reporules_bak = [];
    let g_updaterules_bak = [];
    let g_asserts_bak = [];
    let intv = 0;
    // 分页界面的相关变量放在这做成全局变量
    let g_vue_pagination;
    let g_cur_page = 1;
    let g_page_size = 20;

    let vue_choose_softrepos;
    let vue_choose_softrepospkgs;
    let vue_choose_asserts;
    let vue_choose_repo_asserts;
    let vuedata;

    

    function getAssertById(assertid) {
        for (let i=0;i<g_asserts_bak.length;i++) {
            if (g_asserts_bak[i].assertid == assertid) {
                return g_asserts_bak[i]
            }
        }
        return false;
    }

    function getRepoRuleById(id) {
        for (let i=0;i<g_reporules_bak.length;i++) {
            if (g_reporules_bak[i].id == id) {
                return g_reporules_bak[i]
            }
        }
        return false;
    }

    function getUpdateRuleById(id) {
        for (let i=0;i<g_updaterules_bak.length;i++) {
            if (g_updaterules_bak[i].id == id) {
                return g_updaterules_bak[i]
            }
        }
        return false;
    }

    function getRepoStrategyById(id) {
        for (let i=0;i<g_repostrategies_bak.length;i++) {
            if (g_repostrategies_bak[i].id == id) {
                return g_repostrategies_bak[i]
            }
        }
        return false;
    }

    function getUpdateStrategyById(id) {
        for (let i=0;i<g_updatestrategies_bak.length;i++) {
            if (g_updatestrategies_bak[i].id == id) {
                return g_updatestrategies_bak[i]
            }
        }
        return false;
    }

    function getSoftRepoById(id) {
        for (let i=0;i<g_softrepos_bak.length;i++) {
            if (g_softrepos_bak[i].id == id) {
                return g_softrepos_bak[i]
            }
        }
        return false;
    }

    function show_reporules_page() {
        // 未使用
        console.log("show_reporules_page")
        let current_text_filter = $('#services-text-filter').val().toLowerCase();

        let header = {
            Name: "名称",
            Straname:"",
            Applyto: "应用到",
            Status: "规则状态",
            Operate: "操作"
        }
        //debugger

        let units = [];
        for (let i=0;i<g_reporules_bak.length;i++) {
            let unit = g_reporules_bak[i];
            let applytotext = "";
            let assertsarr = unit.applyto.split(";");
            for (let i=0;i<assertsarr.length;i++) {
                if (!assertsarr[i] || assertsarr[i].length < 1) {
                    continue
                }
                let asserttmp = getAssertById(assertsarr[i]);
                applytotext = applytotext + "资产：" + asserttmp.assertip + "-" + asserttmp.assertname + ";"
            }
            unit.applytotext = applytotext;
            try {
                unit.straname = unit.stracontent;
            } catch(e) {
                console.log(e)
            }

            if (unit.applycount.length < 1) {
                unit.status = "下发中"
            }
            else {
                try {
                    let applyjson = $.parseJSON(unit.applycount);
                    let keys = Object.keys(applyjson);
                    for (let i=0;i<keys.length;i++) {
                        if (applyjson[keys[i]]["applycount"] < unit.editcount) {
                            // 说明还是上次的下发结果
                            unit.status = "尚未下发"
                            break;
                        }
                        if (applyjson[keys[i]]["result"] != "succeed") {
                            // 只要有一个下发失败，就认为下发失败
                            unit.status = "下发失败"
                            break;
                        }
                    }
                    // 如果全部都成功，才认为下发成功
                    if (! unit.status || unit.status.length < 1) {
                        unit.status = "下发成功"
                    }
                } catch(e) {
                    console.log(e)
                }
            }

            // 匹配搜索字符串
            if (! current_text_filter || unit.name.indexOf(current_text_filter) != -1) {
                units.push(unit);
            }

        }

        // 分页展示
        if (!g_vue_pagination) {
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-update-div",
                methods: {
                    handleSizeChange(val) {
                        g_page_size = val;
                        console.log("set g_page_size to:", val);
                        show_reporules_page(g_reporules_bak);
                        //registerAssertsEvent();
                        ruleDownloadOperation();
                        repoRuleMoreOperation();
                    },
                    handleCurrentChange(val) {
                        g_cur_page = val;
                        console.log("set g_cur_page to:", val);
                        show_reporules_page(g_reporules_bak);
                        //registerAssertsEvent();
                        ruleDownloadOperation();
                        repoRuleMoreOperation();
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: units.length,
                }
            })
        } else {
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = units.length;
        }

        // 只展示这一页的数据
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )



        let text;
        if (units.length > 0)
            text = mustache.render(reporule_units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);

        $("#reporule-list").html(text);
        $("#software-list").html("");
        $("#repostrategy-list").html("");
        $("#updatestrategy-list").html("");
        $("#updaterule-list").html("");
    }

    function show_updaterules_page() {
        console.log("show_updaterules_page")
        let current_text_filter = $('#services-text-filter').val().toLowerCase();

        let header = {
            Name: "名称",
            // Straname: "策略名称",
            Reponame: "软件源",
            Pkgname: "软件包",
            Applyto: "应用到",
            Status: "规则状态",
            Operate: "操作"
        }
        //debugger
        let units = [];
        for (let i=0;i<g_updaterules_bak.length;i++) {
            let unit = g_updaterules_bak[i];
            let applytotext = "";
            let assertsarr = unit.applyto.split(";");
            let applycount = $.parseJSON(unit.applycount);
            let stracontent = $.parseJSON(unit.stracontent);
            let deleted = [];
            for (let i=0;i<assertsarr.length;i++) {
                if (!assertsarr[i] || assertsarr[i].length < 1) {
                    continue
                }
                let asserttmp = getAssertById(assertsarr[i]);
                if(!asserttmp.assertip){
                    // 过滤已删除的 添加到已删除列表
                    deleted.push(assertsarr[i]);
                    continue
                }
                applytotext = applytotext + "资产：" + asserttmp.assertip + "-" + asserttmp.assertname + ";"
            }
            unit.applytotext = applytotext;

            // try {
            //     unit.straname = unit.stracontent;
            // } catch(e) {
            //     console.log(e)
            // }
            unit.reponame = [];
            unit.pkgname = [];
            $.each(stracontent,function(key,v){
                unit.reponame.push(key);
                unit.pkgname.push(v);
            });
            unit.reponamep=unit.reponame.toString().replace(/\,/g, "\n")
            unit.pkgnamep=unit.pkgname.toString().replace(/\,/g, "\n")
            unit.applytop=unit.applytotext.replace(/\;/g, "\n")
            // 如果是失败状态要判断是不是所有失败的都在已删除列表里
            // 如果有一项失败的不在删除列表里则返回失败，全在则返回成功
            var statusmap = {
                donwlaod : "下发中",
                redownload : "下发中",
                processing : "下发中",
                succeed : "下发成功",
                failed : function(){
                    let flag = true
                    $.each(applycount,function(i,v){
                        if (v.result != "succeed"){
                            if ($.inArray(i,deleted) == -1) {
                                // 存在返回0,不存在返回-1
                                flag = false;
                                return false;
                            }
                        }
                    });
                    return (!flag) ? "下发失败" : "下发成功"
                }
            };
            let jsstatus = unit.status;
            $.each(statusmap,function(i,v){
                if (i == jsstatus){
                    unit.status = v;
                }
            });
            unit.ruleid=g_updaterules_bak[i].id;
            // if (unit.status != "donwload" && unit.status != "redownload") {
            //     unit.status = "下发中";
            // } else if (unit.status == "succeed"){
            //     unit.status = "下发成功";
            // } else if (unit.status == "failed"){
            //     unit.status = "下发失败";
            // }else {
            //     unit.status = "错误";
            // }
                // try {
                //     let applyjson = $.parseJSON(unit.applycount);
                //     let keys = Object.keys(applyjson);
                //     for (let i=0;i<keys.length;i++) {
                //         if (applyjson[keys[i]]["applycount"] < unit.editcount) {
                //             // 说明还是上次的下发结果
                //             if(applyjson[keys[i]]["result"] == "processing"){
                //                 unit.status = "下发中";
                //             }else{
                //                 unit.status = "尚未下发";
                //             }
                //         }
                //         if (applyjson[keys[i]]["result"] == "failed") {
                //             // 只要有一个下发失败，就认为下发失败
                //             unit.status = "下发失败";
                //         }
                //     }
                //     // 如果全部都成功，才认为下发成功
                //     for (let i=0;i<keys.length;i++) {

                //         unit.status = "下发成功";
                //     }
                // } catch(e) {
                //     console.log(e)
                // }
            
            // console.log(unit);
            //units.push(unit);
            // 匹配搜索字符串
            if (! current_text_filter || unit.name.indexOf(current_text_filter) != -1) {
                units.push(unit);
            }
        }

        // 分页展示
        if (!g_vue_pagination) {
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-update-div",
                methods: {
                    handleSizeChange(val) {
                        g_page_size = val;
                        console.log("set g_page_size to:", val);
                        show_updaterules_page(g_updaterules_bak);
                        //registerAssertsEvent();
                        ruleDownloadOperation();
                        updateRuleMoreOperation();
                    },
                    handleCurrentChange(val) {
                        g_cur_page = val;
                        console.log("set g_cur_page to:", val);
                        show_updaterules_page(g_updaterules_bak);
                        //registerAssertsEvent();
                        ruleDownloadOperation();
                        updateRuleMoreOperation();
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: units.length,
                }
            })
        } else {
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = units.length;
        }

        // 只展示这一页的数据
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )


        let text;
        if (units.length > 0)
            text = mustache.render(updaterule_units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);

        //debugger
        $("#reporule-list").html("");
        $("#software-list").html("");
        $("#repostrategy-list").html("");
        $("#updatestrategy-list").html("");
        $("#updaterule-list").html(text);
    }

    function getVuedataByAssertsAndGroups(info) {
        vuedata = [];
        let allGroupAsserts = [];
        let allasserts = info["allasserts"];
        function getAssertsById(id) {
            for (let i=0;i<allasserts.length;i++) {
                if (allasserts[i].assertid == id) {
                    return allasserts[i]
                }
            }
            return {}
        }

        for (let i=0;i<info["allgroups"].length;i++) {
            let grouptmp = info["allgroups"][i];
            let unit = {
                id: grouptmp.groupid,
                label: "分组：" + grouptmp.groupname,
                children: []
            }

            let tmparr = grouptmp.groupasserts.split(";")
            for (let k=0;k<tmparr.length;k++) {
                if (!tmparr[k] || tmparr[k].length < 1) {
                    continue
                }
                let asserttmp = getAssertsById(tmparr[k]);
                if (asserttmp.assertip == "localhost") {
                    continue
                }
                if (!asserttmp.assertip){
                    // 过滤掉已经删除的
                    continue
                }
                unit.children.push({
                    id: tmparr[k],
                    label: "资产：" + asserttmp.assertip + "-" + asserttmp.assertname
                })
                if (allGroupAsserts.indexOf(tmparr[k]) < 0) {
                    allGroupAsserts.push(tmparr[k])
                }
            }
            if (unit.children.length == 0){
                continue;
            }
            vuedata.push(unit);
        }

        for (let i=0;i<info["allasserts"].length;i++) {
            let asserttmp = info["allasserts"][i];
            if (allGroupAsserts.indexOf(asserttmp.assertid) >= 0) {
                continue
            }
            if (asserttmp.assertip == "localhost") {
                    continue
                }
            let unit = {
                id: asserttmp.assertid,
                label: "资产：" + asserttmp.assertip + "-" + asserttmp.assertname
            }
            vuedata.push(unit);
        }

        return vuedata;
    }

    function getVuedataBySoftRepos(info){
        vuedata = [];
        //let allrepostrategies = info;
        for (let i=0;i<info.length;i++){
            let softrepo = info[i];
            let unit ={
                id: softrepo.id,
                label:"软件源:" + softrepo.name
            }
            vuedata.push(unit);
        }
        //debugger
        return vuedata;
    }

    function getVuedataBySoftRepo(info){
        // 获取软件源和包含的包名
        vuedata = [];
        for ( let i=0;i<info.length;i++){
            let repotmp = info[i];
            let unit = {
                id: repotmp.id,
                label: "软件源: "+repotmp.name,
                children: []
            }
            let tmparr = repotmp.pkglist.split("\n");
            for(let j=0;j<tmparr.length;j++){
                if (tmparr[j].length == 0){
                    continue;
                }
                unit.children.push({
                    id:repotmp.name+":"+tmparr[j],
                    label:"软件包: "+tmparr[j]
                })
            }
            vuedata.push(unit);
        }
        return vuedata
    }

    function render_reporules() {    
       console.log("render_reporules")

        $("#loading-fallback").show();
        let http = cockpit.http({
                "port": 9091
            });
        http.get("/getRules", {"type": "repo"})
        .fail(function(err){
            console.log("getRules err:", err);
            $("#loading-fallback").hide();
        })
        .done(function(res) {
            // console.log("getRules res:", res);

            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getRules err:", res);
                return $("#loading-fallback").hide();
            }
            info = info.data;
            g_reporules_bak = info;

            // 规则里面还要展示应用到的资产，需要获取资产详细信息
            http.get("/getAsserts")
            .fail(function(err){
                console.log("getAsserts err:", err);
                return $("#loading-fallback").hide();
            })
            .done(function(res) {
                // console.log("getAsserts res:", res);

                let info = $.parseJSON( res );
                if (! info.succeed) {
                    console.log("getAsserts err:", res);
                    $("#loading-fallback").hide();
                    return ;
                }
                info = info.data;
                g_asserts_bak = info;

                show_reporules_page();
                ruleDownloadOperation();
                repoRuleMoreOperation();
                $("#loading-fallback").hide();
            })
        })
    }

    function render_updaterules() {    
        console.log("render_updaterules")
        clearInterval(intv)
        $("#loading-fallback").show();
        let http = cockpit.http({
                "port": 9091
            });
        http.get("/getRules", {"type": "update"})
        .fail(function(err){
            console.log("getRules err:", err);
            $("#loading-fallback").hide();
        })
        .done(function(res) {
            // console.log("getRules res:", res);
            
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getRules err:", res);
                return $("#loading-fallback").hide();
            }
            info = info.data;
            // console.log(info);

            g_updaterules_bak = info;
            // 规则里面还要展示应用到的资产，需要获取资产详细信息
            http.get("/getAsserts")
            .fail(function(err){
                console.log("getAsserts err:", err);
                return $("#loading-fallback").hide();
            })
            .done(function(res) {
                // console.log("getAsserts res:", res);

                let info = $.parseJSON( res );
                if (! info.succeed) {
                    console.log("getAsserts err:", res);
                    $("#loading-fallback").hide();
                    return ;
                }
                info = info.data;
                g_asserts_bak = info;
                show_updaterules_page();
                ruleDownloadOperation();
                updateRuleMoreOperation();
                $.each(g_updaterules_bak,function(i,v){
                    if (!v.isdelete == 0 || v.deletecount){
                        $("#data-rule-"+v.id).attr("disabled",true);
                        $("#update-rule-"+v.id).text("正在删除");
                    }
                });
                $("#loading-fallback").hide();
                // 定时器获取规则状态
                var dlsucceed = /\u4e0b\u53d1\u4e2d/
                intv = setInterval(()=>{
                    let isdone = true
                    for (var i=0; i<g_updaterules_bak.length; i++){
                        if (!g_updaterules_bak[i].isdelete == 0 || g_updaterules_bak[i].deletecount){
                            continue;
                        }
                        if (dlsucceed.test(g_updaterules_bak[i].status)){   
                            isdone = false              
                            http.get("/getRuleState", {"type": "update"})
                            .fail(function(err) {
                                console.log("getRules of update err:", err);
                            })
                            .done(function(res) {
                                let info = $.parseJSON( res );
                                if (! info.succeed) {
                                    console.log("getRules of update err:", res);
                                }
                                info = info.data;
                                g_updaterules_bak = info ? info : g_updaterules_bak;
                            })
                        }else{
                            for (var k in g_updaterules_bak){
                                var arule = g_updaterules_bak[k];
                                var rstatus = "下发中"
                                if (arule["status"] == "succeed" || arule["status"] == "下发成功"){
                                    rstatus = "下发成功";
                                }else if (arule["status"] =="下发中" || arule["status"] == "redownload" || arule["status"] == "processing"){
                                    isdone = false;
                                    g_updaterules_bak[k]["status"] = "下发中";
                                }else if (arule["isdelete"]){
                                    rstatus = "正在删除";
                                }else{
                                    rstatus = "下发失败";
                                }
                                $("#update-rule-"+arule["id"]).text(rstatus);
                            }
                        }
                    }
                    if (isdone){
                        clearInterval(intv);
                    }
                },5000);
            })
        })
    }

    function show_softrepos_page(info) {
        // 这个函数不申请数据，只是重新做下匹配
        //let pattern = $('#services-filter li.active').attr('data-pattern');
        console.log("show_softrepos_page");
        let current_text_filter = $('#services-text-filter').val().toLowerCase();

        let units = [];
        for(var i=0;i<info.length;i++) {
            var repo = info[i];
            var newinfo = repo["repoinfo"].replace(/\;/g, "\n");
            var tmp = {"ID": repo["id"], "Name":repo["name"], "Tag":repo["tag"], "BuildTime":repo["buildtime"],"PkgList":repo["pkglist"],"RepoFile":repo["repofile"],"RepoInfo":repo["repoinfo"],"Tinfo":newinfo,"IP":repo["ip"],"CVE":repo["iscve"],"CveInfo":repo["cveinfo"],"Status":repo["iseffective"]};
            //units.push(tmp);
            if (repo["iscve"]) {
                tmp["CVE"] = "是" ;
            }
            else {
                tmp["CVE"] = "否" ;
            }
            if (! current_text_filter || repo["name"].indexOf(current_text_filter) != -1) {
                units.push(tmp);
            }
         }

        let header = {
            ID: "ID",         
            Name: "Name",           
            Tag: "Tag",            
            BuildTime: "BuildTime",
            PkgList: "PkgList",
            RepoFile: "RepoFile",
            RepoInfo: "RepoInfo",
            IP: "IP",
            CVE: "CVE",
            CveInfo: "CveInfo",
            Status: "Status",
            Tinfo: "Tinfo"
        };

        // 分页展示
        if (!g_vue_pagination) {
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-update-div",
                methods: {
                    handleSizeChange(val) {
                        g_page_size = val;
                        console.log("set g_page_size to:", val);
                        show_softrepos_page(g_softrepos_bak);
                        //registerAssertsEvent();
                        softrepoAddOperation();
                        softrepoDeleteOperation();
                        softrepoPkglistOperation();
                    },
                    handleCurrentChange(val) {
                        g_cur_page = val;
                        console.log("set g_cur_page to:", val);
                        show_softrepos_page(g_softrepos_bak);
                        //registerAssertsEvent();
                        softrepoAddOperation();
                        softrepoDeleteOperation();
                        softrepoPkglistOperation();
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: units.length,
                }
            })
        } else {
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = units.length;
        }

        // 只展示这一页的数据
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )

        let text;

        if (units.length > 0)
            text = mustache.render(softrepo_units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);

        $("#software-list").html(text);
        $("#repostrategy-list").html("");
        $("#updatestrategy-list").html("");
        $("#reporule-list").html("");
        $("#updaterule-list").html("");

        $("#loading-fallback").hide();
    }

    function show_repostrategies_page(info) {
        // 这个函数不申请数据，只是重新做下匹配
        //let pattern = $('#services-filter li.active').attr('data-pattern');
        console.log("show_repostrategies_page");
        let current_text_filter = $('#services-text-filter').val().toLowerCase();

        let units = [];
        for(var i=0;i<info.length;i++) {
            var strategy = info[i];
            var tmp = {"ID": strategy["id"], "Name":strategy["name"],"RepoList":strategy["reponamelist"]};
            //units.push(tmp);
            if (! current_text_filter || strategy["name"].indexOf(current_text_filter) != -1) {
                units.push(tmp);
            }
         }

        let header = {
            ID: "ID",         
            Name: "Name",           
            RepoList: "RepoList"
        };

        // 分页展示
        if (!g_vue_pagination) {
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-update-div",
                methods: {
                    handleSizeChange(val) {
                        g_page_size = val;
                        console.log("set g_page_size to:", val);
                        show_repostrategies_page(g_repostrategies_bak);
                        //registerAssertsEvent();
                        repoStrategyDeleteOperatin();
                    },
                    handleCurrentChange(val) {
                        g_cur_page = val;
                        console.log("set g_cur_page to:", val);
                        show_repostrategies_page(g_repostrategies_bak);
                        //registerAssertsEvent();
                        repoStrategyDeleteOperatin();
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: units.length,
                }
            })
        } else {
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = units.length;
        }

        // 只展示这一页的数据
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )

        let text;

        if (units.length > 0)
            text = mustache.render(repostrategy_units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);
        //console.log(text)
        //debugger
        $("#software-list").html("");
        $("#repostrategy-list").html(text);
        $("#updatestrategy-list").html("");
        $("#reporule-list").html("");
        $("#updaterule-list").html("");

        $("#loading-fallback").hide();
    }

    function show_updatestrategies_page(info) {
        // 这个函数不申请数据，只是重新做下匹配
        //let pattern = $('#services-filter li.active').attr('data-pattern');
        console.log("show_updatestrategies_page");
        let current_text_filter = $('#services-text-filter').val().toLowerCase();

        let units = [];
        for(var i=0;i<info.length;i++) {
            var strategy = info[i];
            var tmp = {"ID": strategy["id"], "Name":strategy["name"],"PkgList":strategy["pkglist"]};
            //units.push(tmp);
            if (! current_text_filter || strategy["name"].indexOf(current_text_filter) != -1) {
                units.push(tmp);
            }
         }

        let header = {
            ID: "ID",         
            Name: "Name",           
            PkgList: "PkgList"
        };

        // 分页展示
        if (!g_vue_pagination) {
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-update-div",
                methods: {
                    handleSizeChange(val) {
                        g_page_size = val;
                        console.log("set g_page_size to:", val);
                        show_updatestrategies_page(g_updatestrategies_bak);
                        //registerAssertsEvent();
                        updateStrategyDeleteOperatin();
                    },
                    handleCurrentChange(val) {
                        g_cur_page = val;
                        console.log("set g_cur_page to:", val);
                        show_updatestrategies_page(g_updatestrategies_bak);
                        //registerAssertsEvent();
                        updateStrategyDeleteOperatin();
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: units.length,
                }
            })
        } else {
            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = units.length;
        }

        // 只展示这一页的数据
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )

        let text;

        if (units.length > 0)
            text = mustache.render(updatestrategy_units_template, {
                table_head: header,
                units: units
            });
        else
            text = mustache.render(empty_template);
        //console.log(text)
        //debugger
        $("#software-list").html("");
        $("#repostrategy-list").html("");
        $("#reporule-list").html("");
        $("#updaterule-list").html("");
        $("#updatestrategy-list").html(text);
        $("#loading-fallback").hide();
    }

    function render_softrepos() {
        console.log("render_softrepos");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });
        http.get("/getSoftRepos").done(function(res){
            // console.log("getSoftRepos res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getSoftRepos err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            info = info.data;
            g_softrepos_bak = info;
            show_softrepos_page(info);
            softrepoAddOperation();
            softrepoDeleteOperation();
            softrepoPkglistOperation();
            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getClientInfo err:", err);
            $("#loading-fallback").hide();
        })
    }

    function render_repostrategies() {
        console.log("render_repostrategies");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });
        http.get("/getRepoStrategies").done(function(res){
            console.log("getRepoStrategies res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getRepoStrategies err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            info = info.data;
            g_repostrategies_bak = info;
            show_repostrategies_page(info);
            //repostrategyAddOperation();
            repoStrategyDeleteOperatin();
            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getRepoStrategies err:", err);
            $("#loading-fallback").hide();
        })
    }

    function render_updatestrategies() {
        console.log("render_updatestrategies");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });
        http.get("/getUpdateStrategies").done(function(res){
            // console.log("getUpdateStrategies res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getUpdateStrategies err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            info = info.data;
            g_updatestrategies_bak = info;
            show_updatestrategies_page(info);
            //repostrategyAddOperation();
            updateStrategyDeleteOperatin();
            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getUpdateStrategies err:", err);
            $("#loading-fallback").hide();
        })
    }

    $('#services-text-filter').change(function(e){
        //let filter-text = $("#services-text-filter").val();
        //alert($("#services-text-filter").val());
        if (window.location.href.indexOf("#/repostrategy") > 0) {
            render_repostrategies();
        } else if (window.location.href.indexOf("#/reporule") > 0){
            render_reporules();
        } else if (window.location.href.indexOf("#/updatestrategy") > 0){
            render_updatestrategies();
        } else if (window.location.href.indexOf("#/updaterule") > 0){
            render_updaterules();
        } else {
            render_softrepos();
        }
    })

    function softrepoAddOperation(){
        //alert("nihao")
        $("#softrepo-add").unbind("click").click(function(e){
            $("#softrepo-add-msg").text("");
            $("#jsonfile").val("");
            $("#rpmfile").val("");
            $("#jqmeter-container-upload").html("");
        })
        $("#softrepo-add-confirm").unbind("click").click(function(e){
            if ( $("#jsonfile").val() == "" || $("#rpmfile").val() == "" ) {
                $("#softrepo-add-msg").text("上传文件不能为空");
                setTimeout(function(e){
                    $("#softrepo-add-close").click();
                }, 1500)
                return;
            }

            let jsonfile = $("#jsonfile").prop("files");
            let rpmfile = $("#rpmfile").prop("files");
            // console.log("jsonfile:", jsonfile);
            // console.log("rpmfile", rpmfile);

            var jsonfilename = jsonfile[0].name;
            var jsonfilenamesave = "/tmp/" + jsonfile[0].name + "." + randomString(6);;
            var jsonreader = new FileReader();
            jsonreader.readAsBinaryString(jsonfile[0]);
            var rpmname = "rpmfile." + randomString(6);
            var rpmfilename = $('#rpmfile')[0].files[0].name;
            // 保存在服务器上的文件路径，cockpit 的上传接口会保存在固定的位置
            var rpmfilenamesave = "/tmp/cockpit-upload-" + rpmname + "-" + rpmfilename;

            var checkProgressFlag = 1;

            function doAddRepo() {
                var http = cockpit.http({
                    "port": 9091
                });
                http.post("/addSoftRepo", {
                    "jsonfile": jsonfilenamesave,
                    "rpmfile": rpmfilenamesave
                }).done(function(res) {
                    console.log("addSoftRepo res:", res);

                    var info = $.parseJSON( res );
                    if (! info.succeed) {
                        let cent = "软件源添加失败, 软件源详情: 软件源json文件=" + jsonfilenamesave + ", 软件包=" + rpmfilenamesave + ", 失败原因: " + info.error;
                        writeAuditlog(2, "软件源", cent);
                        return $("#softrepo-add-msg").text("软件源添加失败：" + info.error);
                    }
                    $("#softrepo-add-msg").text("软件源添加成功");
                    let cent = "软件源添加成功, 软件源详情: 软件源json文件=" + jsonfilenamesave + ", 软件包=" + rpmfilenamesave
                    writeAuditlog(2, "软件源", cent);
                    setTimeout(function(e) {
                        $("#softrepo-add-msg").text("");
                        $("#softrepo-add-close").click();
                        render_softrepos();
                    }, 1000)
                }).fail(function(err) {

                    console.log(err);
                    return $("#softrepo-add-msg").text("软件源添加失败");
                    let cent = "软件源添加失败, 软件源详情: 软件源json文件=" + jsonfilenamesave + ", 软件包=" + rpmfilenamesave + ", 失败原因: " + err;
                    writeAuditlog(2, "软件源", cent);
                })
            }

            function checkProgress() {
                if (!checkProgressFlag) {
                    return
                }

                let http = cockpit.http({
                    "port": 9091
                });
                http.get("/getUploadProgress", {
                    "filepath": rpmfilenamesave
                })
                .done(function(res) {
                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("checkProgress failed ", res)
                        return setTimeout(checkProgress, 2000)
                    }

                    //console.log("get upload progress:", info.data)

                    let progress = parseInt(info.data);
                    $("#jqmeter-container-upload").html("");
                    JQMeter.jQMeter_func('#jqmeter-container-upload', {
                        "goal": "100",
                        "raised": progress.toString()
                    });

                    if (progress >= 100) {
                        $("#softrepo-add-msg").text("正在生成软件源，请耐心等待");
                        checkProgressFlag = 0;
                    }

                    setTimeout(checkProgress, 2000)
                })
                .fail(function(e){
                    console.log("checkProgress failed,", e)
                    return setTimeout(checkProgress, 2000)
                })
            }

            function uploadRpmfile() {
                $("#softrepo-add-msg").text("文件正在上传，请耐心等待");
                // 大文件采用 cockpit 的文件上传接口来上传
                let formdata = new FormData();
                formdata.append(rpmname, $('#rpmfile')[0].files[0]);
                $.ajax({
                    url : "/cockpit/upload",
                    dataType:'json',
                    type : 'POST',
                    timeout: 3600000,
                    //async: false,
                    //cache : false,
                    data : formdata,
                    processData : false,
                    contentType : false,
                    success : function(result) {
                        console.log("upload rpm file succeed:", rpmfilenamesave);
                        // disable checkprocess timer
                        checkProgressFlag = 0;
                        $("#jqmeter-container-upload").html("");
                        JQMeter.jQMeter_func('#jqmeter-container-upload', {
                            "goal": "100",
                            "raised": "100"
                        });
                        $("#softrepo-add-msg").text("正在生成软件源，请耐心等待");

                        doAddRepo()
                    },
                    error: function(err) {
                        console.log(err)
                        checkProgressFlag = 0;
                        $("#softrepo-add-msg").text("上传软件包失败");
                    }
                })

                setTimeout(checkProgress, 1000)
            }
            // 上传 json 文件
            jsonreader.onload = function(){
                console.log("文件读取完毕 " + jsonfile[0].name);
                var baseString = jsonreader.result;
                try{
                    $.parseJSON(baseString)
                }
                catch(err)
                {
                    return $("#softrepo-add-msg").text("Json文件格式错误，请检查");
                }
                let jsonobj = $.parseJSON(baseString);
                // 上传前判断是否存在数据库中
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/checkSoftRepo", {
                    "reponame": jsonobj.name
                }).done(function(res) {
                    console.log("checkSoftRepo res:", res);
                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        let cent = "软件源: " + jsonobj.name + " 查询失败, 失败原因: " + info.error;
                        writeAuditlog(2, jsonobj.name, cent);
                        return $("#softrepo-add-msg").text("软件源查询失败" + info.error);
                    }

                    let cent = "软件源: " + jsonobj.name + " 查询成功";
                    writeAuditlog(2, jsonobj.name, cent);
                    var jsonwriter = cockpit.file(jsonfilenamesave, {
                        binary: true,
                    })
                    jsonwriter.replace(baseString)
                    .done(function (tag) {
                        console.log("upload json file succeed:", jsonfilenamesave, tag)
                        uploadRpmfile()
                        jsonwriter.close();
                    })
                    .fail(function (error) {
                        console.log("upload json file failed:", jsonfilenamesave, error)
                        jsonwriter.close();
                    })
                }).fail(function(err) {
                    console.log(err);
                    return $("#softrepo-add-msg").text("软件源添加失败");
                    let cent = "软件源: " + jsonobj.name + " 查询失败, 失败原因: " + err;
                    writeAuditlog(2, jsonobj.name, cent);
                })
                
            }
            

        })
    }

    function softrepoPkglistOperation(){
        $("button.softrepo-pkglist").unbind("click").click(function(e){
            let softrepoid = $(this).data("softrepo-id");
            let softrepounit = getSoftRepoById(softrepoid);
            //alert(softrepoid);
            $("#softrepo-pkglist-msg").text(softrepounit.pkglist)
        })
    }

    function softrepoDeleteOperation(){
        $("button.softrepo-del").unbind("click").click(function(e){
            let softrepoid = $(this).data("softrepo-id");
            let softrepounit = getSoftRepoById(softrepoid);
            //alert(strategyid);
            $("#softrepo-del-msg").text("确认要删除软件源 " + softrepounit.name + " 吗？")
            console.log(softrepoid);
            $("#softrepo-del-confirm").unbind("click").click(function(e) {
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/delSoftRepo", {
                    id: softrepoid
                })
                .fail(function(err){
                    console.log("delSoftRepo err:", err);
                    $("#softrepo-del-msg").text("删除软件源失败");
                    let cent = "删除软件源: " + softrepounit.name + " 失败, 失败原因：" + err;
                    writeAuditlog(2, softrepounit.name, cent);
                })
                .done(function(res) {
                    console.log("delSoftRepo res:", res);

                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("delSoftRepo err:", res);
                        $("#softrepo-del-msg").text("删除软件源失败：" + info.error);
                        let cent = "删除软件源: " + softrepounit.name + " 失败, 失败原因：" + info.error;
                        writeAuditlog(2, softrepounit.name, cent);
                        return ;
                    }
                    $("#softrepo-del-msg").text("删除软件源成功");
                    let cent = "删除软件源: " + softrepounit.name + " 成功";
                    writeAuditlog(2, softrepounit.name, cent);
                    setTimeout(function(e){
                        $("#softrepo-del-close").click()
                        render_softrepos();
                    }, 1500)
                })
            })
        })
    }

    function ruleDownloadOperation(){
        //点击下发按钮触发后台下发
        $("button.download-rule-btn").unbind("click").click(function(e){
            console.log("downloadRule");
            let ruleid = $(this).data("rule-id");
            let ruletype = "";
            let runit = "";
            if (window.location.href.indexOf("#/reporule") > 0){
                ruletype = "repo";
            }
            else {
                ruletype = "update";
            }
            if (ruletype == "repo"){
                runit = getRepoRuleById(ruleid);
            } else if (ruletype == "update") {
                runit = getUpdateRuleById(ruleid);
            }

            $("#download-rule-btn-msg").text("确认要重新下发规则 " +  runit.name + " 吗？")
            $("#download-rule-btn-confirm").unbind("click").click(function(e){
                console.log(ruletype);
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/downloadRule", {
                    id: ruleid,
                    type: ruletype
                })
                .fail(function(err){
                    console.log("downloadRule err:", err);
                    $("#download-rule-btn-msg").text("通知后台下发失败")

                })
                .done(function(res) {
                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("downloadRule err:", res);
                        $("#download-rule-btn-msg").text("通知后台下发失败：" + info.error);
                        return ;
                    }
                    $("#download-rule-btn-msg").text("已通知后台下发");
               
                    if (ruletype == "repo"){
                        setTimeout(function(e){
                            $("#download-rule-btn-close").click()
                            render_reporules();
                        }, 1500)
                    }
                    else {
                        setTimeout(function(e){
                            $("#download-rule-btn-close").click()
                            render_updaterules();
                        }, 1500)
                    }
                })
            })
        
        })
    }

    function repoRuleMoreOperation(){
        // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件
        $(".repo-rule-opr-more").unbind("click").on("click", function(e){
            let top = $(this).offset().top;
            let left = $(this).offset().left;
            let top1 = $("html").scrollTop();
            top = top - top1;
            let width = parseInt($(this).css("width").replace("px", ""));

            //对于软件源规则和软件升级规则，暂时不提供编辑功能
            $("button.repo-rule-edit").hide();

            $(".repo-rule-popup-menu").css("top", top);
            $(".repo-rule-popup-menu").css("left", left + width);

            if ($(".repo-rule-popup-menu").css("display") == "none") {
                $(".repo-rule-popup-menu").css("display", "inline-grid")
            } else {
                $(".repo-rule-popup-menu").css("display", "none")
            }

            let ruleid = $(this).data("rule-id")
            $("#repo-rule-popup-menu-private-data").data("private-data", ruleid)
        })

        $(".repo-rule-popup-btn").mouseover(function(e){
            $(this).css("background-color", "#def3ff")
        })
        .mouseout(function(e){
            $(this).css("background-color", "white")
        })
        $(window).unbind("click").on("click", function(e){
            if ( e.target.localName == "button" &&
                (e.target.className.indexOf("repo-rule-opr-more") >= 0 ||
                e.target.className.indexOf("repo-rule-del") >= 0 ||
                e.target.className.indexOf("repo-rule-status") >= 0 ||
                e.target.className.indexOf("repo-rule-edit") >= 0 )) {
                return
            }
            $(".repo-rule-popup-menu").css("display", "none")
        })

        $("button.repo-rule-status").unbind("click").click(function(e){
            // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
            let ruleid = $("#repo-rule-popup-menu-private-data").data("private-data");
            let ruleunit = getRepoRuleById(ruleid);
            try {
                $("#repo-rule-status-content").html("");
                let applycount = $.parseJSON(ruleunit.applycount);
                Object.keys(applycount).forEach(function(key) {
                    // 渲染规则页面的时候已经获取过资产信息，这里直接用，不重新请求了
                    let asserttmp = getAssertById(key);
                    if (!asserttmp) {
                        console.log("[repo-rule-status]get assert failed,assertid:", applycount[key]);
                        return
                    }
                    let statustext = ""
                    if (applycount[key]["applycount"] < ruleunit.editcount) {
                        statustext = "尚未下发"
                    } else {
                        if (applycount[key]["result"] == "succeed") {
                            statustext = "下发成功"
                        } else {
                            statustext = "下发失败"
                        }
                    }
                    let tr = "<tr><td class='text-align-left'>" + asserttmp.assertip
                            + "</td><td>" + asserttmp.assertname 
                            + "</td><td><span class=''>"+statustext+"</span></td></tr>"
                    $("#repo-rule-status-content").append($(tr));
                })
            } catch(e) {
                console.log(e)
            }
        })

        $("button.repo-rule-del").unbind("click").click(function(e){
            // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
            let ruleid = $("#repo-rule-popup-menu-private-data").data("private-data");
            let ruleunit = getRepoRuleById(ruleid);
            $("#repo-rule-del-msg").text("确认要删除规则 " + ruleunit.name + " 吗？")
            $("#repo-rule-del-confirm").unbind("click").click(function(e) {
                $("#repo-rule-del-msg").text("规则正在删除，请耐心等待");
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/delRule", {
                    type: "repo",
                    id: ruleid
                })
                .fail(function(err){
                    console.log("delRule err:", err);
                    $("#repo-rule-del-msg").text("删除规则失败");
                    let cent = "删除软件源规则: " + ruleunit.name + " 失败, 失败原因: " + err;
                    writeAuditlog(2, ruleunit.name, cent);
                })
                .done(function(res) {
                    console.log("delRule res:", res);

                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("delRule err:", res);
                        $("#repo-rule-del-msg").text("删除规则失败：" + info.error);
                        let cent = "删除软件源规则: " + ruleunit.name + " 失败, 失败原因: " + info.error;
                        writeAuditlog(2, ruleunit.name, cent);
                        return ;
                    }
                    $("#repo-rule-del-msg").text("删除规则成功");
                    let cent = "删除软件源规则: " + ruleunit.name + " 成功";
                    writeAuditlog(2, ruleunit.name, cent);
                    setTimeout(function(e){
                        $("#repo-rule-del-close").click()
                        render_reporules();
                    }, 1500)
                })
            })
        })
    }       

    function updateRuleMoreOperation(){
        // 点击规则行上的更多按钮时，弹出菜单，需要在渲染完成后再绑定事件
        $(".update-rule-opr-more").unbind("click").on("click", function(e){
            let top = $(this).offset().top;
            let left = $(this).offset().left;
            let top1 = $("html").scrollTop();
            top = top - top1;
            let width = parseInt($(this).css("width").replace("px", ""));

            //对于软件源规则和软件升级规则，暂时不提供编辑功能
            $("button.update-rule-edit").hide();


            $(".update-rule-popup-menu").css("top", top);
            $(".update-rule-popup-menu").css("left", left + width);

            if ($(".update-rule-popup-menu").css("display") == "none") {
                $(".update-rule-popup-menu").css("display", "inline-grid")
            } else {
                $(".update-rule-popup-menu").css("display", "none")
            }

            let ruleid = $(this).data("rule-id")
            $("#update-rule-popup-menu-private-data").data("private-data", ruleid)
        })

        $(".update-rule-popup-btn").mouseover(function(e){
            $(this).css("background-color", "#def3ff")
        })
        .mouseout(function(e){
            $(this).css("background-color", "white")
        })
        $(window).unbind("click").on("click", function(e){
            if ( e.target.localName == "button" &&
                (e.target.className.indexOf("update-rule-opr-more") >= 0 ||
                e.target.className.indexOf("update-rule-del") >= 0 ||
                e.target.className.indexOf("update-rule-status") >= 0 ||
                e.target.className.indexOf("update-rule-edit") >= 0 )) {
                return
            }
            $(".update-rule-popup-menu").css("display", "none")
        })

        $("button.update-rule-status").unbind("click").click(function(e){
            // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid

            let ruleid = $("#update-rule-popup-menu-private-data").data("private-data");
            let ruleunit = getUpdateRuleById(ruleid);

            try {
                $("#update-rule-status-content").html("");
                let applycount = $.parseJSON(ruleunit.applycount);
                Object.keys(applycount).forEach(function(key) {
                    // 渲染规则页面的时候已经获取过资产信息，这里直接用，不重新请求了
                    let asserttmp = getAssertById(key);
                    let statustext = ""
                    if (!asserttmp) {
                        console.log("[update-rule-status]get assert failed,assertid:", key);
                        return
                    }
                    
                    if (applycount[key]["applycount"] < ruleunit.editcount) {
                        if(applycount[key]["result"] == "processing"){
                            statustext = "下发中";
                        }else{
                            statustext = "尚未下发";
                        }
                    } else {
                        if (applycount[key]["result"] == "succeed") {
                            statustext = "下发成功";
                        } else {
                            statustext = "下发失败";
                        }
                    }
                    let tr = "<tr><td class='text-align-left'>" + asserttmp.assertip
                            + "</td><td>" + asserttmp.assertname 
                            + "</td><td><span class=''>"+statustext+"</span>"
                            + "</td><td><buttom data-toggle='modal' class='btn btn-default assert-status'"
                            + " data-target='#updaterule-status-dialog' arule-assert-id='"+key
                            + "'>查看详情</buttom>"
                            + "</td></tr>"
                    $("#update-rule-status-content").append($(tr));

                })
                $("buttom.assert-status").unbind("click").click(function(e){
                    let buttomid = $(this).attr("arule-assert-id");
                    $("#assert-status-msg").text(applycount[buttomid]["result"]);
                })

            } catch(e) {
                console.log(e)
            }
        })

        $("button.update-rule-del").unbind("click").click(function(e){
            // 弹出框只有一个，直接用弹出框上的 ruleid 就是当前操作的 ruleid
            let ruleid = $("#update-rule-popup-menu-private-data").data("private-data");
            let ruleunit = getUpdateRuleById(ruleid);
            $("#update-rule-del-msg").text("确认要删除规则 " + ruleunit.name + " 吗？")
            $("#update-rule-del-confirm").unbind("click").click(function(e) {
                $("#update-rule-del-msg").text("规则正在删除，请耐心等待");
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/delRule", {
                    type: "update",
                    id: ruleid
                })
                .fail(function(err){
                    console.log("delRule err:", err);
                    $("#update-rule-del-msg").text("删除规则失败");
                    let cent = "删除软件升级规则: " + ruleunit.name + " 失败, 失败原因: " + err;
                    writeAuditlog(2, ruleunit.name, cent);
                })
                .done(function(res) {
                    console.log("delRule res:", res);

                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("delRule err:", res);
                        $("#update-rule-del-msg").text("通知后台删除规则失败：" + info.error);
                        let cent = "删除软件升级规则: " + ruleunit.name + " 失败, 失败原因: " + info.error;
                        writeAuditlog(2, ruleunit.name, cent);
                        return ;
                    }
                    $("#update-rule-del-msg").text("成功通知后台删除规则");
                    $("#data-rule-"+ruleid).attr("disabled",true);
                    let cent = "删除软件升级规则: " + ruleunit.name + " 成功";
                    writeAuditlog(2, ruleunit.name, cent);
                    setTimeout(function(e){
                        $("#update-rule-del-close").click()
                        render_updaterules();
                    }, 1500)
                })
            })
        })
    } 

    function updateStrategyDeleteOperatin(){
        $("button.update-strategy-del").unbind("click").click(function(e){
            let strategyid = $(this).data("strategy-id");
            let strategyunit = getUpdateStrategyById(strategyid);
            //alert(strategyid);
            $("#update-strategy-del-msg").text("确认要删除策略 " + strategyunit.name + " 吗？")
            console.log(strategyid);
            $("#update-strategy-del-confirm").unbind("click").click(function(e) {
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/delUpdateStrategy", {
                    id: strategyid
                })
                .fail(function(err){
                    console.log("delUpdateStrategy err:", err);
                    $("#update-strategy-del-msg").text("删除策略失败");
                    let cent = "删除软件升级策略: " + strategyunit.name + " 失败, 失败原因：" + err;
                    writeAuditlog(2, strategyunit.name, cent);
                })
                .done(function(res) {
                    console.log("delUpdateStrategy res:", res);

                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("delUpdateStrategy err:", res);
                        $("#update-strategy-del-msg").text("删除策略失败：" + info.error);
                        let cent = "删除软件升级策略: " + strategyunit.name + " 失败, 失败原因： " + info.error;
                        writeAuditlog(2, strategyunit.name, cent);
                        return ;
                    }
                    $("#update-strategy-del-msg").text("删除策略成功");
                    let cent = "删除软件升级策略: " + strategyunit.name + " 成功";
                    writeAuditlog(2, strategyunit.name, cent);
                    setTimeout(function(e){
                        $("#update-strategy-del-close").click()
                        render_updatestrategies();
                    }, 1500)
                })
            })
        })
    }   

    function repoStrategyDeleteOperatin(){
        $("button.repo-strategy-del").unbind("click").click(function(e){
            let strategyid = $(this).data("strategy-id");
            let strategyunit = getRepoStrategyById(strategyid);

            $("#repo-strategy-del-msg").text("确认要删除策略 " + strategyunit.name + " 吗？")
            console.log(strategyid);
            $("#repo-strategy-del-confirm").unbind("click").click(function(e) {
                let http = cockpit.http({
                    "port": 9091
                });
                http.post("/delRepoStrategy", {
                    id: strategyid
                })
                .fail(function(err){
                    console.log("delRepoStrategy err:", err);
                    $("#repo-strategy-del-msg").text("删除策略失败");
                    let cent = "删除软件源策略: " + strategyunit.name + " 失败, 原因: " + err;
                    writeAuditlog(2, strategyunit.name, cent);
                })
                .done(function(res) {
                    console.log("delRepoStrategy res:", res);

                    let info = $.parseJSON( res );
                    if (! info.succeed) {
                        console.log("delRepoStrategy err:", res);
                        $("#repo-strategy-del-msg").text("删除策略失败：" + info.error);
                        let cent = "删除软件源策略: " + strategyunit.name + " 失败，原因：" + info.error;
                        writeAuditlog(2, strategyunit.name, cent);
                        return ;
                    }
                    $("#repo-strategy-del-msg").text("删除策略成功");
                    let cent = "删除软件源策略: " + strategyunit.name + " 成功";
                    writeAuditlog(2, strategyunit.name, cent);
                    setTimeout(function(e){
                        $("#repo-strategy-del-close").click()
                        render_repostrategies();
                    }, 1500)
                })
            })
        })
    }         
    
    $("#repostrategy-add").unbind("click").click(function(e){
        //info = g_softrepos_bak;
        $("#repostrategy-add-msg").text("");
        $("#repostrategy-add-name").val("");
        //vue_choose_softrepos = "";
        //vue_choose_softrepos.data = [];
        let http = cockpit.http({ 
            "port": 9091
        });
        http.get("/getSoftRepos").done(function(res){
            // console.log("getSoftRepos res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getSoftRepos err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            info = info.data;
            g_softrepos_bak = info;

            vuedata = getVuedataBySoftRepos(g_softrepos_bak);
            //debugger
            if (!vue_choose_softrepos){
                vue_choose_softrepos = new Vue({
                    template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
                    el: "#vue-repostrtegy-div",
                    methods: {
                        getCheckedNodes() {
                            return this.$refs.tree.getCheckedNodes();
                        },
                        setCheckedKeys(data) {
                            this.$refs.tree.setCheckedKeys(data);
                        }
                    },
                    data: {
                        data: vuedata,
                        defaultProps: {
                            children: 'children',
                            label: 'label'
                        }
                    },
                    watch: {
                        data(newdata, olddata) {
                        }
                    }
                })
            }
            vue_choose_softrepos.data = vuedata;
            //vue_choose_softrepos.setCheckedKeys([]);

            $("#loading-fallback").hide();
        }).catch(err=>{
            console.log("getClientInfo err:", err);
            $("#loading-fallback").hide();
        })
            
    })
   

    $("#reporule-add").unbind("click").click(function(e){
        $("#reporule-add-straname").html("");
        $("#reporule-add-name").val("");
        $("#reporule-add-msg").text("");
        let http = cockpit.http({
            "port": 9091
        });
        http.get("/getRepoStrategies")
        .fail(function(err){
            console.log("getRepoStrategies err:", err);
            $("#reporule-add-msg").text("获取软件源策略失败")
        })
        .done(function(res) {
            console.log("getRepoStrategies res:", res);

            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getRepoStrategies err:", res);
                return $("#reporule-add-msg").text("获取软件源策略失败：" + info.error)
            }
            info = info.data;
            g_repostrategies_bak = info;

            $("#reporule-add-straname").html("");
            for (let i=0;i<g_repostrategies_bak.length;i++) {
                let html = '<option value="' + g_repostrategies_bak[i].id + '">' + g_repostrategies_bak[i].name + '</option>';
                $("#reporule-add-straname").append($(html))
            }

            // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
            // 先获取资产和分组信息
            http.get("/getGroupsAndAsserts")
            .fail(function(err){
                console.log("getGroupsAndAsserts err:", err);
                $("#reporule-add-msg").text("获取资产和分组失败")
            })
            .done(function(res) {
                // console.log("getGroupsAndAsserts res:", res);

                let info = $.parseJSON( res );
                if (! info.succeed) {
                    console.log("getGroupsAndAsserts err:", res);
                    return $("#reporule-add-msg").text("获取资产和分组失败：" + info.error)
                }

                info = info.data;
                vuedata = getVuedataByAssertsAndGroups(info);

                if (!vue_choose_repo_asserts) {
                    vue_choose_repo_asserts = new Vue({
                        template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
                        el: "#vue-reporule-div",
                        methods: {
                            getCheckedNodes() {
                                return this.$refs.tree.getCheckedNodes();
                            },
                            setCheckedKeys(data) {
                                this.$refs.tree.setCheckedKeys(data);
                            }
                        },
                        data: {
                            data: vuedata,
                            defaultProps: {
                                children: 'children',
                                label: 'label'
                            }
                        },
                        watch: {
                            data(newdata, olddata) {
                                //
                            }
                        }
                    })
                }
                vue_choose_repo_asserts.data = vuedata;
            })
        })
    })

    $("#updaterule-add").unbind("click").click(function(e){
        // $("#updaterule-add-straname").html("");
        $("#updaterule-add-name").val("");
        $("#updaterule-add-msg").text("");
        let http = cockpit.http({
            "port": 9091
        });
        http.get("/getUpdateStrategies")
        .fail(function(err){
            console.log("getUpdateStrategies err:", err);
            $("#updaterule-add-msg").text("获取软件升级策略失败")
        })
        .done(function(res) {
            // console.log("getUpdateStrategies res:", res);

            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("getUpdateStrategies err:", res);
                return $("#updaterule-add-msg").text("获取软件升级策略失败：" + info.error)
            }
            info = info.data;
            g_updatestrategies_bak = info;

            // $("#updaterule-add-straname").html("");
            // for (let i=0;i<g_updatestrategies_bak.length;i++) {
            //     let html = '<option value="' + g_updatestrategies_bak[i].id + '">' + g_updatestrategies_bak[i].name + '</option>';
            //     $("#updaterule-add-straname").append($(html))
            // }
            http.get("/getSoftRepos")
            .fail(function(err){
                console.log("getSoftRepos err:",err);
                $("#updaterule-add-msg").text("获取软件源失败")
            })
            .done(function(res){
                // console.log("getSoftRepos res",res);
                let reposinfo = $.parseJSON(res);
                if(! reposinfo.succeed) {
                    console.log("getSoftRepos err", res);
                    return $("#updaterule-add-msg").text("获取软件源失败：" + info.error)
                }
                reposinfo = reposinfo.data
                let vuedata1 = getVuedataBySoftRepo(reposinfo);
                //debugger
                if (!vue_choose_softrepospkgs){
                    vue_choose_softrepospkgs = new Vue({
                        template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
                        el: "#vue-updaterule-repos",
                        methods: {
                            getCheckedNodes() {
                                return this.$refs.tree.getCheckedNodes();
                            },
                            setCheckedKeys(data) {
                                this.$refs.tree.setCheckedKeys(data);
                            }
                        },
                        data: {
                            data: vuedata1,
                            defaultProps: {
                                children: 'children',
                                label: 'label'
                            }
                        },
                        watch: {
                            data(newdata, olddata) {
                            }
                        }
                    })
                }
                vue_choose_softrepospkgs.data = vuedata1;
            })
            // 新增规则的选择资产和分组的控件用的是 element-ui 的 tree 控件，用 vue 来渲染
            // 先获取资产和分组信息
            http.get("/getGroupsAndAsserts")
            .fail(function(err){
                console.log("getGroupsAndAsserts err:", err);
                $("#updaterule-add-msg").text("获取资产和分组失败")
            })
            .done(function(res) {
                // console.log("getGroupsAndAsserts res:", res);

                let info = $.parseJSON( res );
                if (! info.succeed) {
                    console.log("getGroupsAndAsserts err:", res);
                    return $("#updaterule-add-msg").text("获取资产和分组失败：" + info.error)
                }

                info = info.data;
                vuedata = getVuedataByAssertsAndGroups(info);
                if (!vue_choose_asserts) {
                    vue_choose_asserts = new Vue({
                        template: '<el-tree :data="data" show-checkbox default-expand-all node-key="id" ref="tree" highlight-current :props="defaultProps"></el-tree>',
                        el: "#vue-updaterule-div",
                        methods: {
                            getCheckedNodes() {
                                return this.$refs.tree.getCheckedNodes();
                            },
                            setCheckedKeys(data) {
                                this.$refs.tree.setCheckedKeys(data);
                            }
                        },
                        data: {
                            data: vuedata,
                            defaultProps: {
                                children: 'children',
                                label: 'label'
                            }
                        },
                        watch: {
                            data(newdata, olddata) {
                                //
                            }
                        }
                    })
                }
                vue_choose_asserts.data = vuedata;
            })
        })
    })


    // 确认添加规则时的操作
    // $("#reporule-add-confirm").unbind("click").click(function(e){
    //     // 暂时弃用
    //     console.log("reporule-add-confirm")
    //     let choosedAssertsAndGroups = vue_choose_repo_asserts.getCheckedNodes();
    //     let choosedAsserts = [];
    //     for (let i=0;i<choosedAssertsAndGroups.length;i++) {
    //         if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
    //             choosedAsserts.push(choosedAssertsAndGroups[i].id)
    //         }
    //     }
    //     let choosedGroups = [];
    //     // 检查是否某个分组的所有资产都选择上了，如果都选择上了，则认为应用到分组内的所有资产，包括以后添加的?
    //     // 确定是否选择了分组不太确定，如果第一次建立规则时没选全分组内的资产，后来删除了分组内没选的资产，
    //     // 下次编辑的时候就会变成选择了分组内的全部资产了，还是只按照资产下发，如果改变了分组状态，
    //     // 需要重新编辑规则，并且下发
    //     for (let i=0;i<choosedAssertsAndGroups.length;i++) {
    //         if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
    //             continue
    //         }
    //     }
    //     if (choosedAsserts.length < 1) {
    //         return $("#reporule-add-msg").text("请至少选择一个资产");
    //     }

    //     let assertsstr = choosedAsserts.join(";");
    //     let name = $("#reporule-add-name").val();
    //     if (!name || name.length < 1 || name.length > 32) {
    //         return $("#reporule-add-msg").text("请输入合法的名称，最大32字符");
    //     }
    //     let straid = $("#reporule-add-straname option:selected").val();
    //     if (!straid || straid.length < 1) {
    //         return $("#reporule-add-msg").text("请选择合法的策略");
    //     }
        
    //     $("#reporule-add-msg").text("规则正在添加，请耐心等待");
    //     let http = cockpit.http({
    //         "port": 9091
    //     });
    //     http.post("/addRule", {
    //         type: "repo",
    //         name: name,
    //         straid: straid,
    //         asserts: assertsstr
    //     })
    //     .fail(function(err){
    //         console.log("addRule err:", err);
    //         $("#reporule-add-msg").text("添加规则失败")
    //     })
    //     .done(function(res) {
    //         console.log("addRule res:", res);

    //         let info = $.parseJSON( res );
    //         if (! info.succeed) {
    //             console.log("addRule err:", res);
    //             return $("#reporule-add-msg").text("添加规则失败：" + info.error)
    //         }
    //         $("#reporule-add-msg").text("添加规则成功");
    //         setTimeout(function(e){
    //             $("#reporule-add-close").click();
    //             render_reporules();
    //         }, 1500)
    //     })
    // })

    // 确认添加规则时的操作
    $("#updaterule-add-confirm").unbind("click").click(function(e){
        // 根据评审 更改为可选安装包应用到不同资产或者分组去
        console.log("updaterule-add-confirm")
        let choosedAssertsAndGroups = vue_choose_asserts.getCheckedNodes();
        let choosedAsserts = [];
        let choosedRepospkgs = vue_choose_softrepospkgs.getCheckedNodes();
        let choosedpkgs = [];
        for(let x=0;x<choosedRepospkgs.length;x++){
            if (!choosedRepospkgs[x].children){
                choosedpkgs.push(choosedRepospkgs[x].id);
                // console.log(choosedRepospkgs[x].id);
            }
        }

        for (let i=0;i<choosedAssertsAndGroups.length;i++) {
            if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
                choosedAsserts.push(choosedAssertsAndGroups[i].id)
            }
        }
        let choosedGroups = [];
        // 检查是否某个分组的所有资产都选择上了，如果都选择上了，则认为应用到分组内的所有资产，包括以后添加的?
        // 确定是否选择了分组不太确定，如果第一次建立规则时没选全分组内的资产，后来删除了分组内没选的资产，
        // 下次编辑的时候就会变成选择了分组内的全部资产了，还是只按照资产下发，如果改变了分组状态，
        // 需要重新编辑规则，并且下发
        for (let i=0;i<choosedAssertsAndGroups.length;i++) {
            if (choosedAssertsAndGroups[i].label.indexOf("资产") == 0) {
                continue
            }
        }
        if (choosedRepospkgs.length < 1) {
            return $("#updaterule-add-msg").text("请至少选择一个软件包");
        }
        if (choosedAsserts.length < 1) {
            return $("#updaterule-add-msg").text("请至少选择一个资产");
        }
        let assertsstr = choosedAsserts.join(";");
        let name = $("#updaterule-add-name").val();
        if (!name || name.length < 1 || name.length > 32) {
            return $("#updaterule-add-msg").text("请输入合法的名称，最大32字符");
        }
        // let straid = $("#updaterule-add-straname option:selected").val();
        // if (!straid || straid.length < 1) {
        //     return $("#updaterule-add-msg").text("请选择合法的策略");
        // }

        $("#updaterule-add-msg").text("规则正在添加，请耐心等待");
        let http = cockpit.http({
            "port": 9091
        });
        http.post("/addRule", {
            type: "update",
            name: name,
            stracontent: choosedpkgs,
            straid: 0,
            asserts: assertsstr
        })
        .fail(function(err){
            console.log("addRule err:", err);
            $("#updaterule-add-msg").text("添加规则失败")
            let cent = "添加规则: " + name + " 失败, ruletype: update, 失败原因: " + err;
            writeAuditlog(2, name, cent);
        })
        .done(function(res) {
            // console.log("addRule res:", res);

            let info = $.parseJSON( res );
            if (! info.succeed) {
                console.log("addRule err:", res);
                let cent = "添加规则: " + name + " 失败, ruletype: update, 失败原因: " + info.error;
                writeAuditlog(2, name, cent);
                return $("#updaterule-add-msg").text("添加规则失败：" + info.error)
            }
            $("#updaterule-add-msg").text("添加规则成功");
            let cent = "添加规则: " + name + " 成功, ruletype: update";
            writeAuditlog(2, name, cent);
            setTimeout(function(e){
                $("#updaterule-add-close").click();
                render_updaterules();
            }, 1500)
        })
    })

    $("#repostrategy-add-confirm").unbind("click").click(function(e){
        console.log("repostrategy-add-confirm");
        let choosedNodes = vue_choose_softrepos.getCheckedNodes();
        let choosedSoftRepos = [];
        let choosedNames = [];
        if(choosedNodes.length < 1){
            return $("#repostrategy-add-msg").text("请至少选择一个软件源");
        }
        for(let i=0;i<choosedNodes.length;i++){
            choosedSoftRepos.push(choosedNodes[i].id);
            let softreponame = choosedNodes[i].label.split(':')[1];
            choosedNames.push(softreponame);
        }
        let softrepostr = choosedSoftRepos.join(";");
        let softreponamestr = choosedNames.join(";");
        console.log(softrepostr);
        console.log(softreponamestr);
        let name = $("#repostrategy-add-name").val()
        console.log(name);
        let http = cockpit.http({
            "port": 9091
        });
        http.post("/addRepoStrategies", {
            "name": name,
            "softrepostr": softrepostr,
            "softreponamestr": softreponamestr
        }).done(function(res) {
            console.log("addRepoStrategies res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                let cent = "软件源策略: " + name + " 添加失败, 策略详情: softrepo=" + softrepostr + ", softreponame=" + softreponamestr + ", 失败原因: " + info.error;
                writeAuditlog(2, name, cent);
                return $("#repostrategy-add-msg").text("软件源策略添加失败：" + info.error);
            }
            $("#repostrategy-add-msg").text("软件源策略添加成功");
            let cent = "软件源策略: " + name + " 添加成功, 策略详情: softrepo=" + softrepostr + ", softreponame=" + softreponamestr;
            writeAuditlog(2, name, cent);
            setTimeout(function(e) {
                $("#repostrategy-add-close").click();
                //vue_choose_softrepos.data = [];
                render_repostrategies();
            }, 1000)
        }).fail(function(exception, err){
            console.log(err);
            $("#repostrategy-add-msg").text("软件源策略添加失败");
            let cent = "软件源策略: " + name + " 添加失败, 策略详情: softrepo=" + softrepostr + ", softreponame=" + softreponamestr + ", 失败原因: " + err;
            writeAuditlog(2, name, cent);
        })
    })

    $("#updatestrategy-add-confirm").unbind("click").click(function(e){
        console.log("updatestrategy-add-confirm");
        let name = $("#updatestrategy-add-name").val();
        let pkglist = $("#updatestrategy-add-pkglist").val();    
        console.log(name);
        console.log(pkglist);
        let http = cockpit.http({
            "port": 9091
        });
        http.post("/addUpdateStrategies", {
            "name": name,
            "pkglist": pkglist
        }).done(function(res) {
            console.log("addUpdateStrategies res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                let cent = "软件升级策略: " + name + " 添加失败, 策略详情: pkglist=" + pkglist + ", 失败原因: " + info.error;
                writeAuditlog(2, name, cent);
                return $("#updatestrategy-add-msg").text("软件升级策略添加失败：" + info.error);
            }
            $("#updatestrategy-add-msg").text("软件升级策略添加成功");
            let cent = "软件升级策略: " + name + " 添加成功, 策略详情: pkglist=" + pkglist;
            writeAuditlog(2, name, cent);
            setTimeout(function(e) {
                $("#updatestrategy-add-close").click();
                render_updatestrategies();
            }, 1000)
        }).fail(function(exception, err){
            console.log(err);
            $("#updatestrategy-add-msg").text("软件升级策略添加失败");
            let cent = "软件升级策略: " + name + " 添加失败, 策略详情: pkglist=" + pkglist + ", 失败原因: " + err;
            writeAuditlog(2, name, cent);
        })
    })

    $('#update-filter li').on('click', function() {
        $('#update-filter li')
            .removeClass('active')
            .removeAttr('aria-current');
        $(this)
            .addClass('active')
            .attr('aria-current', true);

        let pattern = $(this).attr('data-pattern');
        if (pattern == "repostrategy") {
            cockpit.location.go(["repostrategy"]);
            //$("#softrepo-add").hide();
            //$("#repostrategy-add").show();
            //render_rules();
        }
        else if (pattern == "softrepo") {
            cockpit.location.go([""]);
            //$("#softrepo-add").show();
            //$("#repostrategy-add").hide();
            //render_users()
        }
        else if (pattern == "reporule") {
            cockpit.location.go(["reporule"]);
            //$("#softrepo-add").hide();
            //$("#repostrategy-add").hide();
            //render_users()
        }
        else if (pattern == "updatestrategy") {
            cockpit.location.go(["updatestrategy"]);
            //$("#softrepo-add").hide();
            //$("#repostrategy-add").hide();
            //render_users()
        }
        else if (pattern == "updaterule") {
            cockpit.location.go(["updaterule"]);
            //$("#softrepo-add").hide();
            //$("#repostrategy-add").hide();
            //render_users()
        }
    })
    
    // 根据 url 初始化渲染页面
    $("#update-filter li")
        .removeClass('active')
        .removeAttr('aria-current');

    function navigate() {
        if (window.location.href.indexOf("#/repostrategy") > 0) {
            $("#repostrategy-li").addClass('active')
                .attr('aria-current', true);    
            $("#repostrategy-add").show();
            $("#softrepo-add").hide();
            $("#reporule-add").hide();
            $("#updatestrategy-add").hide();
            $("#updaterule-add").hide();
            render_repostrategies();
        } else if (window.location.href.indexOf("#/reporule") > 0){
            $("#reporule-li").addClass('active')
                .attr('aria-current', true);
            $("#reporule-add").show();
            $("#softrepo-add").hide();
            $("#repostrategy-add").hide();
            $("#updatestrategy-add").hide();
            $("#updaterule-add").hide();
            render_reporules();
        } else if (window.location.href.indexOf("#/updatestrategy") > 0){
            $("#updatestrategy-li").addClass('active')
                .attr('aria-current', true);
            $("#reporule-add").hide();
            $("#softrepo-add").hide();
            $("#repostrategy-add").hide();
            $("#updatestrategy-add").show();
            $("#updaterule-add").hide();
            render_updatestrategies();
        } else if (window.location.href.indexOf("#/updaterule") > 0){
            $("#updaterule-li").addClass('active')
                .attr('aria-current', true);
            $("#reporule-add").hide();
            $("#softrepo-add").hide();
            $("#repostrategy-add").hide();
            $("#updatestrategy-add").hide();
            $("#updaterule-add").show();
            render_updaterules();
        } else {
            $("#softrepo-li").addClass('active')
                .attr('aria-current', true);
            $("#softrepo-add").show();
            $("#repostrategy-add").hide();
            $("#reporule-add").hide();
            $("#updatestrategy-add").hide();
            $("#updaterule-add").hide();
            render_softrepos();
        }
    }

    $(cockpit).on("locationchanged", navigate);
    navigate();
}

/* These add themselves to jQuery so just including is enough */
cockpit.translate();
const _ = cockpit.gettext;
moment.locale(cockpit.language);

if (window.location.pathname.indexOf("manager/update.html") >  0){
    $(update_init);
}
