import $ from "jquery";
import mustache from "mustache";

//import cockpit from "cockpit";
import moment from "moment";
import journal from "journal";
import "patterns";
import "bootstrap-datepicker/dist/js/bootstrap-datepicker";
import { writeAuditlog } from './write-auditlog';

function usermanager_init() {
    //console.log("usermanager_init");
    var units_template = $("#user-units-tmpl").html();
    mustache.parse(units_template);

    let g_users_bak = [];    
    //分页界面的相关变量放在这做全局变量
    let g_vue_pagination;
    let g_cur_page = 1;
    let g_page_size = 20;
    let g_total_size = 0;


    //分页处理 
    function processPagination(units) {
        
        // 分页展示
        if (!g_vue_pagination) {
            //console.log("进入分页展示页面");
            //console.log(g_users_bak);
            g_vue_pagination = new Vue({
                template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
                el: "#vue-usermanager-div",
                methods: {

                    //事件处理
                    handleSizeChange(val) {
                        //console.log("handleSizeChange 事件-1");
                        g_page_size = val;
                        //console.log("set g_page_size to:", val)

                        // rules page
                        //console.log("查询记录为:");
                        //console.log(g_users_bak);
                        show_usermanagers_page(g_users_bak);
                        userManagerOperation();

                        //registerAssertsEvent()                        }
                    },


                    //事件处理
                    handleCurrentChange(val) {
                        //console.log("handleCurrentChange 事件-2");       
                        g_cur_page = val;
                        //console.log("set g_cur_page to:", val);

                        //console.log("查询记录为:");
                        //console.log(g_users_bak);
                        show_usermanagers_page(g_users_bak);
                        userManagerOperation();
                        //registerAssertsEvent();
                        
                        //console.log("handleCurrentChange事件");
                    }
                },
                data: {
                    current_page: g_cur_page,
                    page_size: g_page_size,
                    total: g_total_size,
                }
            })
        } else {

            g_vue_pagination.current_page = g_cur_page;
            g_vue_pagination.page_size = g_page_size;
            g_vue_pagination.total = g_total_size;
        }
    
        units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size);      
        return units
    }


    //显示数据
    function show_usermanagers_page(info_data)
    {          
           
            let units = [];

            //对数据进行排序 sysadm secadm audadm 放最前面
            for(var j=0;j<info_data.length;j++){

                if(info_data[j].role == "sysadm")
                    info_data[j].role = "系统管理员"
                else if(info_data[j].role == "secadm")
                    info_data[j].role = "安全管理员"
                else if(info_data[j].role == "audadm")
                    info_data[j].role = "审计管理员"



                if(info_data[j].name == "sysadm" || info_data[j].name == "secadm" || info_data[j].name == "audadm")
                {
                    var tmp = {"name": info_data[j].name, "role":info_data[j].role, "enabled":info_data[j].enabled, "createtime":info_data[j].createtime,"id":info_data[j].id}
                    units.push(tmp)
                }
            }


            for(var i=0;i<info_data.length;i++) {
                //var j = info[i][5];
                //console.log(info_data[i].name)
                //console.log(info_data[i].role)
                //console.log(info_data[i].enabled)
                //console.log(info_data[i].createtime)
                if(info_data[i].name != "sysadm" && info_data[i].name != "secadm" && info_data[i].name != "audadm")
                {                
                    var tmp = {"name": info_data[i].name, "role":info_data[i].role, "enabled":info_data[i].enabled, "createtime":info_data[i].createtime,"id":info_data[i].id}
                    //console.log(tmp)
                    units.push(tmp)
                }
            }

            
            //分页处理
            //console.log("分页处理");            
            units = processPagination(units);
    
            let header = {
                name: "name",         
                role: "role",           
                enabled: "enabled",            
                createtime: "createtime"
            };
    
            var text = "";
            if (units.length >= 0)
                text = mustache.render(units_template, {
                    table_head: header,
                    units: units
            });
            else
                text = mustache.render(empty_template);
            
            $("#services-list").html(text);
            $("#service-detail-list").hide();
    
            $("#services").show();
                //syslogMessageOperation();
            $("#services-dropdown").show();
            $("#loading-fallback").hide();
    }


    function userManagerOperation(){
        //console.log("userManagerOperation");
        
        $("#create-user-btn").unbind("click").click(function(e){            
           //console.log("创建用户按钮被点击");
     

            $("#usersmanager-user").val("");
            $("#usersmanager-password").val("");
            $("#usersmanager-password-confirm").val("");
            //$("#usersmanager-role").val("");
            //$("#usersmanager-role option:selected").val("系统管理员");
            //console.log("设置select默认值");
            $("#usersmanager-role option[value='系统管理员']").attr("selected",true);
            $("#usersmanager-msg").text("");

        });

        $("button.confirm-delete-btn").unbind("click").click(function(e){
            //console.log("删除按钮被点击");
            //console.log("删除按钮被点击");
            //console.log("删除按钮被点击");
            let id = $(this).data("user-id");
            let user_name = "";
            //let syslogmessage = getSyslogMessageById(syslogid);
            //alert(syslogid);
            //$("#syslog-message-msg").val(syslogmessage);
            

            $("#confirm-operate-private-data").data("private-data", id);

            //根据ID查找姓名
            for(var i=0;i<g_users_bak.length;i++) {
                
                if(g_users_bak[i].id == id)
                    user_name = g_users_bak[i].name;
                    
                //console.log(g_users_bak[i].id);             
            }

            //console.log("XXXXXXXXXXXXXXXXXXXXX")
            //console.log(user_name)
            if(user_name == "sysadm" || user_name == "secadm" || user_name == "audadm")
            {
                $("#confirm-operate-msg").text("不允许删除" + user_name + "用户!")
                $("#confirm-delete-user").attr("disabled", "disabled");
            }                
            else
            {
                $("#confirm-delete-user").removeAttr("disabled")
                $("#confirm-operate-msg").text("确定要删除该用户 " + user_name + "么?")
            }
            
            //console.log("hello,world");
            //console.log(id);
        });

        $("button.edit-user-manager").unbind("click").click(function(e){
            //console.log("编辑按钮被点击");
            //console.log("编辑按钮被点击");
            //console.log("编辑按钮被点击");
            let id = $(this).data("usermanager-id");
            //console.log(id);
            //let syslogmessage = getSyslogMessageById(syslogid);
            //alert(syslogid);
            //$("#syslog-message-msg").val(syslogmessage);

            //let enabled = $("#user-enabled").val();
            //$("#user-enabled").prop("disabled", true);
            //设置默认值
            //根据ID查找姓名
            let user_name = "";
            let password = "";
            let role = "";
            let enabled = false;
            for(var i=0;i<g_users_bak.length;i++) {
                
                if(g_users_bak[i].id == id)
                {
                    user_name = g_users_bak[i].name;
                    password = g_users_bak[i].password;
                    role = g_users_bak[i].role;                    

                    if(role == "sysadm")
                        role = "系统管理员"
                    else if(role == "secadm")
                        role = "安全管理员"
                    else if(role == "audadm")
                        role = "审计管理员"            
                    
                    enabled = g_users_bak[i].enabled;


                    //console.log(g_users_bak[i].id);            
                    //console.log(g_users_bak[i].name);
                    //console.log(g_users_bak[i].role);
                    //console.log(g_users_bak[i].enabled);
                    //console.log(g_users_bak[i].createtime);  

                }                       
                               
            }

            if(user_name == "sysadm" || user_name == "secadm" || user_name == "audadm")
            {
                $("#user-enabled").attr("disabled", "disabled");
                $("#usersmanager-edit-role").attr("disabled", "disabled");
            }else{
                $("#user-enabled").removeAttr("disabled")
                $("#usersmanager-edit-role").removeAttr("disabled")
            }
            

            $("#usersmanager-edit-password").val(password);
            $("#usersmanager-edit-password-confirm").val(password);
            //$("#usersmanager-edit-role").val(role);
            $("#user-enabled").prop("checked",enabled);

            if(role == "安全管理员")
                $("#usersmanager-edit-role option[value='安全管理员']").attr("selected", true);
            else if(role == "审计管理员")
                $("#usersmanager-edit-role option[value='审计管理员']").attr("selected", true);
            else if(role == "系统管理员")
                $("#usersmanager-edit-role option[value='系统管理员']").attr("selected", true);

            
            //$("#usersmanager-edit-role option:selected").attr("selected", true);
            $("#user-operate-private-data").data("private-data", id);
            $("#usersmanager-edit-msg").text(" ");

            //console.log("hello,world");
            //console.log(id);
        });        
    }

    function render_usermanagers() {
        //console.log("render_usermanagers");
        $("#loading-fallback").show();

        let http = cockpit.http({ 
            "port": 9091
         });


        //API 接口 getUsers  获取用户数据
        http.get("/getUsersManager").done(function(res){
            //console.log("getUsers  res:", res);
            let info = $.parseJSON(res);
            if (! info.succeed) {
                //console.log("getUser err:", res);
                $("#loading-fallback").hide();
                return ;
            }
            
            for(var j=0;j<info.data.length;j++){

                if(info.data[j].role == "sysadm")
                    info.data[j].role = "系统管理员"
                else if(info.data[j].role == "secadm")
                    info.data[j].role = "安全管理员"
                else if(info.data[j].role == "audadm")
                    info.data[j].role = "审计管理员"
    
            }

        
            let info_data = info.data;            
            g_users_bak = info.data;
            //console.log(info.data);
            //console.log(info_data.length);

            //console.log("查询记录为-render_usermanagers:");
            //console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
            //console.log(g_users_bak);
            //console.log("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");


            g_total_size = info_data.length;

            show_usermanagers_page(info_data);             
            userManagerOperation();        
        }).catch(err=>{
            //console.log("getUsersManager err:", err);
            $("#loading-fallback").hide();
        })
        userManagerOperation();        
    }

    $('#services-filter li').on('click', function() {
        $('#services-filter li')
            .removeClass('active')
            .removeAttr('aria-current');
        render_usermanagers();
    })

    //点击确认之后,创建用户
    $("#usersmanager-confirm").on("click",function(e){
        console.log("点击确认之后,创建用户");           

        let name = $("#usersmanager-user").val();
        let password = $("#usersmanager-password").val();
        let role = $("#usersmanager-role option:selected").val();
        
        function is_valid_char_username(c) {
            return (c >= 'a' && c <= 'z') ||
                (c >= 'A' && c <= 'Z') ||
                (c >= '0' && c <= '9') ||
                c == '.' || c == '_' || c == '-';
        }
        
        //根据用户名规则检查创建的用户
        for (var i = 0; i < name.length; i++) {  
            if (!is_valid_char_username(name[i])) {
                return $("#usersmanager-msg").text("创建的用户名不符合规则（数字、字母以及'.'  '-'  '_' 三个字符组合）,请修改!" ); 
                break;      
            }
        }

        //判断两次输入的密码是否一致
        let password_confirm = $("#usersmanager-password-confirm").val();
        if(password_confirm != password)
        {
            return $("#usersmanager-msg").text("密码不一致， 请重新输入密码!" );
        }

        if(role == "系统管理员")
            role = "sysadm"
        else if(role == "安全管理员")
            role = "secadm"
        else if(role == "审计管理员")
            role = "audadm"
        //console.log(name.indexOf(" "));
        //console.log(name.indexOf("  "));        

        //验证用户名是否合法
        if(name == "")
        {
            return $("#usersmanager-msg").text("用户名为空,请输入用户名!" );   
        }
       
        else if(name.indexOf(" ") != -1 || name.indexOf("   ") != -1)
        {
            return $("#usersmanager-msg").text("用户名包含有空格,请重新输入用户名!" ); 
        }        

        //密码复杂度检查
        var pwdRegex = new RegExp('(?=.*[0-9])(?=.*[a-zA-Z]).{8,30}');
        if(password.length > 20){
            //console.log(password.length);            
            return $("#usersmanager-msg").text("密码长度过长, 不得超过20位!" );
        }        

        if(password == "")
        {
            return $("#usersmanager-msg").text("密码为空，请输入用户密码!" );
            //密码为空，请输入用户密码
        }
        else if(password.length < 8)
        {
            return $("#usersmanager-msg").text("密码不合法，最少8个字符!" );
        }        
        else if(!pwdRegex.test(password)){
            return $("#usersmanager-msg").text("您的密码复杂度太低（必须包含字母、数字),请及时修改密码！" );
        }
        
        //console.log(role);    
              
        $("#usersmanager-msg").text("创建用户中，请等待...");
        //var result = "ip:" + ip + " " + "port:" + port + " " + "database:" + database + " " + "user:" + user + " " + "password:" + password + " " + "keeptime:" + keeptime;
        //alert(result);
        let http = cockpit.http({
            "port": 9091
        });



        http.post("/addUsersManager", {
            "name": name,
            "password": password,
            "role": role
        }).done(function(res) {
            // console.log("setSyslogConfig res:", res);
            let info = $.parseJSON( res );
            if (! info.succeed) {
                let cent = "创建用户: " + name + ", 失败, role=" + role + ", 失败原因: " + info.error;
                writeAuditlog(2, name, cent);
                return $("#usersmanager-msg").text("创建用户失败：" + info.error);
            }
            $("#usersmanager-msg").text("创建用户成功!");
            let cent = "创建用户: " + name + ", 成功, role=" + role;
            writeAuditlog(2, name, cent);
            setTimeout(function(e) {
                $("#usersmanager-close").click();
                render_usermanagers();
            }, 1000)
        }).fail(function(exception, err){
            //console.log(err);
            $("#usersmanager-msg").text("创建用户失败");
            let cent = "创建用户: " + name + ", 失败, role=" + role + ", 失败原因: " + err;
            writeAuditlog(2, name, cent);
        })
    })

    //点击确认之后,编辑用户
    $("#usersmanager-edit").on("click",function(e){

        let id = $("#user-operate-private-data").data("private-data")
        //let id = $(delete-user-manager).data("user-id");
        //console.log("XXXXXXXXXXXXXXXXXXXXXXXXXX");
        //console.log(id);
        //console.log("XXXXXXXXXXXXXXXXXXXXXXXXXX");

        //let enabled = $("#user-enabled").val();
        let enabled = $("#user-enabled").prop("checked");
        if (enabled) {
            enabled = 1
        } else {
            enabled = 0
        }
        
        //判断用户是否编辑
        let check_user_name = "";
        let check_password = "";
        let check_role = "";
        let check_enabled = false;
        for(var i=0;i<g_users_bak.length;i++) {
            
            if(g_users_bak[i].id == id)
            {
                check_user_name = g_users_bak[i].name;
                check_password = g_users_bak[i].password;
                check_role = g_users_bak[i].role;
                check_enabled = g_users_bak[i].enabled;

                //console.log(g_users_bak[i].id);            
                //console.log(g_users_bak[i].name);
                //console.log(g_users_bak[i].role);
                //console.log(g_users_bak[i].enabled);
                //console.log(g_users_bak[i].createtime);  

            }                       
                           
        }
        
        //判断两次输入的密码是否一致
        let password = $("#usersmanager-edit-password").val();
        let password_confirm = $("#usersmanager-edit-password-confirm").val();
        if(password != password_confirm)
        {
            return $("#usersmanager-edit-msg").text("密码不一致， 请重新输入密码!" );
        }

        //密码复杂度检查
        var pwdRegex = new RegExp('(?=.*[0-9])(?=.*[a-zA-Z]).{8,30}');
        if(password == "")
        {
            return $("#usersmanager-edit-msg").text("密码为空，请输入用户密码!" );
            //密码为空，请输入用户密码
        }
        else if(password.length < 8)
        {
            return $("#usersmanager-edit-msg").text("密码不合法，最少8个字符!" );
        }        
        else if(!pwdRegex.test(password)){
            return $("#usersmanager-edit-msg").text("您的密码复杂度太低（必须包含字母、数字),请及时修改密码！" );
        }

        //let role = $("#usersmanager-edit-role").val();
        let role = $("#usersmanager-edit-role option:selected").val();
        //console.log(role);
        
        if(check_enabled == enabled && check_password == password && check_role == role){
            return $("#usersmanager-edit-msg").text("未做任何编辑,请编辑用户相关信息!" );
        }

        if(role == "安全管理员")
            role = "secadm"
        else if(role == "审计管理员")
            role = "audadm"
        else if(role == "系统管理员")
            role = "sysadm"
            
            
        $("#usersmanager-edit-msg").text("编辑用户中，请等待...");
        //var result = "ip:" + ip + " " + "port:" + port + " " + "database:" + database + " " + "user:" + user + " " + "password:" + password + " " + "keeptime:" + keeptime;
        //alert(result);
        let http = cockpit.http({
            "port": 9091
        });

        http.post("/editUsersManager", {
            "id": id,
            "enabled":enabled,
            "password": password,
            "role": role
        }).done(function(res) {
            // console.log("setSyslogConfig res:", res);
            let info = $.parseJSON( res );
            //console.log(info);

            //console.log(info.succeed);
            if (! info.succeed) {
                let cent = "编辑用户: " + check_user_name + " 失败, 失败原因: " + info.error;
                writeAuditlog(2, check_user_name, cent);
                return $("#usersmanager-edit-msg").text("编辑用户失败：" + info.error);
            }
            $("#usersmanager-edit-msg").text("编辑用户成功!");
            let cent = "编辑用户: " + check_user_name + " 成功";
            writeAuditlog(2, check_user_name, cent);
            setTimeout(function(e) {
                $("#usermanager-close").click();
                render_usermanagers();
            }, 1000)
        }).fail(function(exception, err){
            //console.log(err);
            $("#usersmanager-edit-msg").text("编辑用户失败");
            let cent = "编辑用户: " + check_user_name + " 失败, 失败原因: " + err;
            writeAuditlog(2, check_user_name, cent);
        })
    })


    //点击确认之后,删除用户
    $("#confirm-delete-user").on("click",function(e) {

        //let id = $("#confirm-delete-user").data("user-id");

        let id = $("#confirm-operate-private-data").data("private-data")
        //let id = $(this).data("syslog-id");
        //let uuid = $(this).data("group-id");
        //console.log("删除用户");

        //console.log("用户ID为：");
        //console.log(id);
        let user_name = "";
        for(var i=0;i<g_users_bak.length;i++) {
            if(g_users_bak[i].id == id)
                user_name = g_users_bak[i].name;         
        }

        let http = cockpit.http({
            "port": 9091
        })
        http.post("/delUsersManager", {"id": id}).done(function(res){
            //console.log("delUsersManager res:", res);

            let info = $.parseJSON( res );
            if (! info.succeed) {
                //console.log("deleteGroup error, res:", res);
                $("#confirm-operate-msg").text("删除用户失败");
                let cent = "删除用户: " + user_name + " 失败, 失败原因: " + info.error;
                writeAuditlog(2, user_name, cent);
                return ;
            }            

            $("#confirm-operate-msg").text("删除用户成功");
            let cent = "删除用户: " + user_name + " 成功";
            writeAuditlog(2, user_name, cent);
            setTimeout(function(e){
                $("#confirm-operate-close").click();
                render_usermanagers();                
            }, 1000)
        }).fail(function(err){
            //console.log("deleteGroup err:", err);
            $("#confirm-operate-msg").text("删除用户失败");
            let cent = "删除用户: " + user_name + " 失败, 失败原因: " + err;
            writeAuditlog(2, user_name, cent);
            return ;
        })
    })    

    $("#create-user-btn").on("click",function(e){
        //console.log("创建用户按钮被点击");
        $("#usersmanager-user").val("");
        $("#usersmanager-password").val("");
        //$("#usersmanager-role").val("");


    });

    // 根据 url 初始化渲染页面
    $("#services-filter li")
        .removeClass('active')
        .removeAttr('aria-current');
    render_usermanagers();
}


/* These add themselves to jQuery so just including is enough */
cockpit.translate();
const _ = cockpit.gettext;
moment.locale(cockpit.language);
 
if (window.location.pathname.indexOf("manager/usermanager.html") >  0){
    usermanager_init(); 
}
