import $ from "jquery";
import mustache from "mustache";

//import cockpit from "cockpit";
import moment from "moment";
import journal from "journal";
import "patterns";
import "bootstrap-datepicker/dist/js/bootstrap-datepicker";

var g_auditlog_cur_user = "";
var g_auditlog_op = 0;
var g_auditlog_obj = "";
var g_auditlog_cent = "";

function writeAuditlogBody(op, obj, cent) {
    let http = cockpit.http({
        "port": 9091
    });
    http.post("/addAuditlog", {
        "user": g_auditlog_cur_user,
        "operator": op,
        "auditobject": obj,
        "content": cent
    }).done(function(res) {
        let info = $.parseJSON(res);
        if (! info.succeed) {
            console.log(obj, "write audit log failed:", info.error, cent);
        }else{
            //console.log(obj, "write audit log succeed", cent);
        }
    }).fail(function(exception, err){
        console.log(obj, "write audit log failed:", err, cent);
    })
}

function writeAuditlogcb(callback) {
    callback(g_auditlog_op, g_auditlog_obj, g_auditlog_cent);
}

export function writeAuditlog(op, obj, cent) {
    g_auditlog_op = op;
    g_auditlog_obj = obj;
    g_auditlog_cent = cent;

    writeAuditlogcb(function(op, obj, cent) {
        if ("" == g_auditlog_cur_user) {
            cockpit.user().done(function (user) {
                console.log("writeAuditlogcb  user", user);
                g_auditlog_cur_user = user.name;
                writeAuditlogBody(op, obj, cent);
            });
        } else {
           writeAuditlogBody(op, obj, cent);
        }
    });
}
