# -*- coding:utf-8 -*-
__author__ = "tangjie"

import sys
import time
import fcntl

class FLock():

    def __init__(self, name, locktype):
        '''
        locktype: exclusive | share
        '''
        realname = ""
        for ch in str(name):
            if "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-.".find(ch) >= 0:
                realname = realname + ch

        self.locktype = locktype
        if not locktype == "exclusive" and not locktype == "share":
            raise Exception("locktype parameter of FLock invalid,must be exclusive or share")

        self.fobj = open("/run/%s.pylock" %realname, 'w+')
        self.fd = self.fobj.fileno()

    def wrlock(self):
        fcntl.lockf(self.fd, fcntl.LOCK_EX)

    def rdlock(self):
        fcntl.lockf(self.fd, fcntl.LOCK_SH)

    def unlock(self):
        fcntl.lockf(self.fd, fcntl.LOCK_UN)

    def trylock(self):
        try:
            fcntl.lockf(self.fd, fcntl.LOCK_EX|fcntl.LOCK_NB)
            ret = "succeed"
            fcntl.lockf(self.fd, fcntl.LOCK_UN)
        except Exception as ex:
            ret = "failed"

        return ret

    def __enter__(self):
        #print("lock file")
        if self.locktype == "exclusive":
            self.wrlock()
        elif self.locktype == "share":
            self.rdlock()

    def __exit__(self, exc_type, exc_value, exc_traceback):
        #print("unlock file")
        self.unlock()

if __name__ == "__main__":
    import pdb;pdb.set_trace()

    a= Flock("abc.txt").wrlock()
    b= Flock("abc.txt").wrlock()