#!/usr/bin/python
# coding=utf8

import paramiko
import os

REMOTEFILE_DIR="/tmp/"

def execRemoteCmd(ip, port, username, cmd, timeout=30):
    # 创建SSH对象
    ssh = paramiko.SSHClient()
    # 允许连接不在know_hosts文件中的主机
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    # 连接服务器
    ssh.connect(hostname=ip, port=port, username=username, timeout=timeout)
    if not username == "root" and not cmd.startswith("sudo "):
        cmd = "sudo " + cmd
    # 执行命令
    stdin, stdout, stderr = ssh.exec_command(cmd, timeout=timeout)

    channel = stdout.channel
    status = channel.recv_exit_status()
    # 获取命令结果
    res = stdout.read()
    err = stderr.read()
    # 关闭连接
    ssh.close()
    res = str(res, encoding = "utf-8")
    err = str(err, encoding = "utf-8")
    return res, err, status

def execRemoteFile(ip, port, username, remotefile, timeout=30):
    # 创建SSH对象
    cmd = "/bin/bash %s 2>&1" %remotefile
    res = execRemoteCmd(ip, port, username, cmd, timeout=timeout)
    return res

def uploadFile(ip, port, username, localfile, remotepath=REMOTEFILE_DIR):
    """上传文件到远程服务器"""
    ssh=paramiko.Transport((ip, port))
    key = paramiko.RSAKey.from_private_key_file('/root/.ssh/id_rsa')
    ssh.connect(username=username,pkey=key)
    sftp=paramiko.SFTPClient.from_transport(ssh)
    if remotepath == REMOTEFILE_DIR:
        remotefile = "%s/%s" %(REMOTEFILE_DIR, os.path.basename(localfile))
    else:
        remotefile = "%s%s"%(remotepath, os.path.basename(localfile))
    sftp.put(localfile, remotefile)
    ssh.close()

def uploadAndExecFile(ip, port, username, localfile, timeout=30):
    filename = os.path.basename(localfile)
    uploadFile(ip, port, username, localfile)

    remotefile = os.path.join(REMOTEFILE_DIR, filename)
    return execRemoteFile(ip, port, username, remotefile, timeout=timeout)

