(function (root, data) {
    var loaded, module;

    /* Load into AMD if desired */
    if (typeof define === 'function' && define.amd) {
        define(data);
        loaded = true;
    }

    /* Load into Cockpit locale */
    if (typeof cockpit === 'object') {
        cockpit.locale(data)
        loaded = true;
    }

    function transformAngular(data, prev) {
        var key, context, parts, value, result = { };
        for (key in data) {
            if (key === "")
                continue;
            parts = key.split("\u0004");
            value = data[key];
            if (parts[1]) {
                context = parts[0];
                key = parts[1];
            } else {
                context = "$$noContext";
                key = parts[0];
            }
            if (value[0] === null)
                value = value[1];
            else
                value = value.slice(1);
            if (!(key in result))
                result[key] = { };
            result[key][context] = value;
        }
        return angular.extend(prev, result);
    }

    /* Load into angular here */
    if (typeof angular === 'object') {
        try {
            module = angular.module(["gettext"]);
        } catch(ex) { console.log(ex); /* Either no angular or angular-gettext */ };
        if (module) {
            loaded = true;
            module.run(['gettextCatalog', function(gettextCatalog) {
                var lang = data[""]["language"];
                var prev = (gettextCatalog.getCurrentLanguage() == lang) ? gettextCatalog.strings : { };
                gettextCatalog.setStrings(lang, transformAngular(data, prev));
                gettextCatalog.setCurrentLanguage(lang);
            }]);
        }
    }

    if (!loaded)
        root.po = data;

/* The syntax of this line is important  by po2json */
}(this, {
 "": {'plural-forms':function(n) {
var nplurals, plural;
nplurals=1; plural=0;
return plural;
},
  "language": "zh_CN",
  "x-generator": "Zanata 4.6.2"
 },
/* Asserts page*/
 "AssertsMng": [
  null,
  "资产管理"
 ],
 "RealTimeMonitor": [
  null,
  "实时监控"
 ],
 "LogMng": [
  null,
  "日志管理"
 ],
 "SoftwareUpdate": [
  null,
  "软件升级"
 ],
 "UserPassword": [
  null,
  "账户密码"
 ],
 "SecureMng": [
  null,
  "安全管理"
 ],
 "UserManager": [
  null,
  "用户管理"
 ],
"AuditLog": [
  null,
  "审计日志"
 ],
 "RulesDownload": [
  null,
  "规则下发"
 ], 
 "PassNotify": [
  null,
  "过期提醒"
 ],

 "Assert:": [
  null,
  "资产："
 ],
 "Asserts": [
  null,
  "资产"
 ],
 "Groups": [
  null,
  "分组"
 ],
 "Id": [
  null,
  "Id"
 ],
 "Name": [
  null,
  "名称"
 ],
 "Description": [
  null,
  "描述"
 ],
 "State": [
  null,
  "状态"
 ],


 "Memory": [
  null,
  "内存"
 ],
 "Network": [
  null,
  "网络"
 ],
 "Hard Drive I/O": [
  null,
  "硬盘I/O"
 ],
 "Filter by name/IP...": [
  null,
  "根据名称、IP过滤..."
 ],

 "Hostname": [
  null,
  "主机"
 ],
 "Start Date": [
  null,
  "起始日期"
 ],
 "End Date": [
  null,
  "截止日期"
 ],
 "Search log...": [
  null,
  "日志信息搜索"
 ],
 "Priority": [
  null,
  "严重性"
 ],
 "Search": [
  null,
  "搜索"
 ],
 "Add": [
  null,
  "添加"
 ],
  "1 month": [
  null,
  "一个月"
 ],
 "2 months": [
 null,
 "两个月"
 ],
 "3 months": [
  null,
  "三个月"
 ],
 "Keep time:": [
  null,
  "保存时长："
 ],
 "Database:": [
  null,
  "数据库："
 ],
 "Port:": [
  null,
  "端口："
 ],
 "IP Address:":[
  null,
  "IP地址"
 ],
 "Username:": [
    null,
   "用户名："
   ],
   "Methods:": [
    null,
   "验证方式："
   ],
   "Credentials:": [
    null,
    "可用的："
   ],
   "Password": [
    null,
   "密码"
   ],
   "Use id_rsa": [
    null,
   "使用可用凭证"
   ],
   "Find": [
    null,
   "发现"
   ],
   "Find result": [
    null,
   "发现结果"
   ],
   "Find asserts": [
    null,
   "发现资产"
   ],
   "Add assert": [
    null,
    "添加资产"
   ],
   "Assert IP": [
    null,
    "资产IP"
   ],
   "Assert Name": [
    null,
    "资产名称"
   ],
   "Assert name": [
    null,
    "资产名称"
   ],
   "Group Name": [
    null,
    "分组名称"
   ],
   "Group Description":[
    null,
    "分组描述"
   ],
   "Assert Number":[
    null,
    "资产数"
   ],
   "Support IP address and IP range, use semicolon to separate.": [
    null,
   "支持IP地址，IP段和IP范围，用分号分隔。"
   ],
   "e.g.: 1.2.3.4;1.2.3.4-1.2.3.10;1.2.3.0/24": [
    null,
    "例如: 1.2.3.4;1.2.3.4-1.2.3.10;1.2.3.0/24"
   ],
   "Not Found": [
    null,
   "扫描失败"
   ],
   "Added": [
    null,
   "已添加"
   ],
   "Adding, please wait...": [
    null,
   "添加中，请等待..."
   ],
   "Online": [
    null,
   "在线"
   ],
   "Offline": [
    null,
   "离线"
   ],
   "From": [
    null,
   "来源于"
   ],
   "Status": [
    null,
   "状态"
   ],
   "Waiting": [
    null,
   "尚未下发"
   ],
   "Tag:": [
    null,
   "标签："
   ],
   "Assert ID":[
    null,
    "资产ID"
   ],
   "Assert IP":[
    null,
    "资产IP"
   ],
   "Assert Location":[
    null,
    "资产位置"
   ],
   "Assert Status":[
    null,
    "资产状态"
   ],
   "Assert Tag":[
    null,
    "资产标签"
   ],
   "Location:": [
    null,
   "位置："
   ],
   "Assert Usage":[
    null,
    "资产用途"
   ],
   "Usage:": [
    null,
   "用途："
   ],
   "Assert Group":[
    null,
    "所属组"
   ],
   "Group:": [
    null,
   "分组："
   ],
   "The rules need redownload, when assert group changed.": [
    null,
   "资产的分组改变时，应用到该资产的规则需要重新下发才能生效"
   ],
   "No matches result": [
    null,
   "没有匹配的结果"
   ],
   "Clean search string": [
    null,
   "清除搜索字符串"
   ],
   "Create Group": [
    null,
   "新增分组"
   ],
   "Name/IP/Location/Usage/Description": [
    null,
   "名称、IP、位置、用途或描述"
   ],
   "Description:": [
    null,
   "描述："
   ],
   "Available": [
    null,
   "可选择"
   ],
   "Chosen": [
    null,
   "已拥有"
   ],
   "No result": [
    null,
   "未选择"
   ],
   "Syslog Server Config": [
    null,
   "日志服务器设置"
   ],
   "Date": [
    null,
   "时间"
   ],
   "Severity": [
    null,
   "严重程度"
   ],
   "Message": [
    null,
   "消息"
   ],
   "Detail": [
    null,
   "消息详情"
   ],
   "Repos": [
    null,
   "软件源生成"
   ],
   "Name:": [
    null,
   "名称："
   ],
   "Create Date": [
    null,
   "生成时间"
   ],
   "Include CVE": [
    null,
   "是否包含CVE漏洞"
   ],
   "CVE info": [
    null,
   "CVE漏洞信息"
   ],
   "Repo info": [
    null,
   "repo信息"
   ],
   "Software List": [
    null,
   "软件列表"
   ],
   "Operation": [
    null,
   "操作"
   ],
   "List Detail": [
    null,
   "列表详情"
   ],
   "Delete": [
    null,
   "删除"
   ],
   "Create repo": [
    null,
   "新增软件源"
   ],
   "Filter by name...": [
    null,
   "根据名称过滤..."
   ],
   "Repo's JSON file:": [
    null,
   "软件源json文件："
   ],
   "Software package:": [
    null,
   "软件包上传："
   ],
   "Upload process:": [
    null,
   "上传进度："
   ],
   "Software update": [
    null,
   "软件升级"
   ],
   "Repo": [
    null,
   "软件源"
   ],
   "Softwares:": [
    null,
   "软件包："
   ],
   "Softwares": [
    null,
   "软件包"
   ],
   "Apply to:": [
    null,
   "应用到："
   ],
   "Apply to": [
    null,
   "应用到"
   ],
   "Status": [
    null,
   "规则状态"
   ],
   "More": [
    null,
   "更多"
   ],
   "Details": [
    null,
    "详情"
   ],
   "Not selected":[
    null,
    "未选择"
   ],
   "Detail": [
    null,
   "查看状态"
   ],
   "Failed ": [
    null,
   "下发失败"
   ],
   "Succeed": [
    null,
   "下发成功"
   ],
   "Create update rule": [
    null,
   "新建软件升级"
   ],
   "User strategy": [
    null,
   "账户策略"
   ],
   "Create user": [
    null,
   "新增账户策略"
   ],
   "Username": [
    null,
   "账户名"
   ],
   "Full name": [
    null,
   "账户全名"
   ],
   "Type": [
    null,
   "策略类型"
   ],
   "Creation": [
    null,
   "创建账户"
   ],
   "Delete account": [
    null,
   "删除账户"
   ],
   "Password:": [
    null,
   "密码："
   ],
   "Confirm": [
    null,
   "确认"
   ],
   "Edit assert": [
    null,
    "编辑资产"
   ],
   "Edit group": [
    null,
    "编辑分组"
   ],
   "Generate": [
    null,
   "生成密码"
   ],
   "Show": [
    null,
   "查看密码"
   ],
   "Set password": [
    null,
   "设置密码"
   ],
   "Lock account": [
    null,
   "锁定账户"
   ],
   "Character": [
    null,
   "角色"
   ],
   "Server admin": [
    null,
   "服务器管理员"
   ],
   "Note: the assert password consists with Strategy password and 4 random digits": [
    null,
   "备注说明：资产密码由账户策略密码+4位随机数组合生成"
   ],
   "Create": [
    null,
   "创建"
   ],
   "Rule": [
    null,
   "规则"
   ],
   "Create repo rules":[
    null,
    "新增软件源规则"
   ],
   "Rule name:": [
    null,
   "规则名称："
   ],
   "Rule name": [
    null,
   "规则名称"
   ],
   "Strategy name:": [
    null,
   "策略名称："
   ],
   "Strategy name": [
    null,
   "策略名称"
   ],
   "Edit rule": [
    null,
    "编辑规则"
   ],
   "Redownload": [
    null,
   "重新下发"
   ],
   "Edit": [
    null,
   "编辑"
   ],
   "Security Strategy": [
    null,
   "安全策略"
   ],
   "Login failed": [
    null,
   "登录失败处理"
   ],
   "Failed time: ": [
    null,
   "失败次数："
   ],
   "Lock time(s): ": [
    null,
   "锁定时间(S)："
   ],
   "Password complex": [
    null,
   "密码复杂度"
   ],
   "Disable USB drive": [
    null,
   "禁用U盘"
   ],
   "Password expiration": [
    null,
   "密码过期时间"
   ],
   "days": [
    null,
   "天"
   ],
   "Session expiration": [
    null,
   "会话超时时间"
   ],
   "seconds": [
    null,
   "秒"
   ],
   "The rules need redownload, when Security Strategy changed.": [
    null,
   "安全策略改变时，应用到该策略的规则需要重新下发才能生效"
   ],
   "The rules need redownload, when User Strategy changed.":[
    null,
    "账户策略改变时，应用到该策略的规则需要重新下发才能生效"
   ],
   "Excute security commands": [
    null,
   "执行安全命令"
   ],
   "Default Strategy": [
    null,
   "默认策略"
   ],
   "New rule": [
    null,
   "新增规则"
   ],
   "Terminal password change": [
    null,
   "终端修改密码"
   ],
   "Step1: Open terminal enter \"ssh User@ip\", then press return key.":[
    null,
    "步骤1：打开终端输入\"ssh 用户名@ip\"按下回车"
   ],
   'E.g.: "ssh user@192.120.3.1", press return key':[
    null,
    '例如: "ssh user@192.120.3.1"按下回车'
   ],
    "Password Expired notify": [
    null,
    "修改密码提示"
   ],
   "Prompt like: You are required to change your password immediately (password aged)": [
    null,
    "此时提示类似：You are required to change your password immediately (password aged)"
   ],
   "Step2: Enter OLD password and NEW password, then confirm NEW password. Finish password change.":[
    null,
    "步骤2：输入资产“旧密码”和“新密码”并确认“新密码”完成密码修改"
   ],
   "All": [
    null,
    "全部"
   ],
   "Rules": [
    null,
    "查看规则"
   ],
   "Inspect":[
    null,
    "查看"
   ],
   "Notice": [
    null,
    "提示"
   ],
   "Close": [
    null,
    "关闭"
   ],
   "Emerg": [
    null,
    "紧急"
   ],
   "Alert": [
    null,
    "警报"
   ],
   "Crit": [
    null,
    "关键"
   ],
   "Err": [
    null,
    "错误"
   ],
   "Warning": [
    null,
    "警告"
   ],
   "Notice": [
    null,
    "通知"
   ],
   "Info": [
    null,
    "信息"
   ],
   "Debug": [
    null,
    "调试"
   ],
   "No details...":[
    null,
    "暂无详情..."
   ],
   "Assert status":[
    null,
    "资产状态详情"
   ],
   "Software list detail": [
    null,
    "软件包详情"
   ],
   "Please enter Security Command here...":[
    null,
    "请在此处输入安全命令..."
   ],
   "Disabled":[
    null,
    "关闭"
   ],
   "Permissive":[
    null,
    "放行"
   ],
   "Enforcing":[
    null,
    "打开"
   ],
   "Security mode": [
    null,
    "安全开关"
   ],
   "Please enter legitimate IP address. E.g.: 192.168.0.1": [
    null,
    "请输入合法ip, 如：192.168.0.1"
   ],
   "Please enter legitimate name, 1-40 characstics. English, Chinese, number or . - _ only.": [
    null,
    "请输入合法名称，1-40字符, 仅支持英文 中文 数字 . - _"
   ],
   "Management Server does not have credentials. Please generate credential first.": [
    null,
    "管理服务器的证书不存在，请先生成证书"
   ],
   "Please select a credential.": [
    null,
    "请选择使用的证书"
   ],
   "Get assert's version and fingerprints failed.": [
    null,
    "获取资产版本和指纹信息失败"
   ],
   "Get fingerprints failed.": [
    null,
    "获取指纹信息失败"
   ],
   "Get version tag information failed.": [
    null,
    "获取版本标签信息失败"
   ],
   "Add assert failed: ": [
    null,
    "添加资产记录失败："
   ],
   "Add assert failed": [
    null,
    "添加资产记录失败"
   ],
   "Add assert succeed!": [
    null,
    "添加资产成功"
   ],
   "Upload credential failed.": [
    null,
    "上传证书到资产失败"
   ],
   "Create directory failed while uploading credential.": [
    null,
    "上传证书时创建目录失败"
   ],
   "Add assert to SCMMS failed.": [
    null,
    "添加资产到SCMMS失败"
   ],
   "Connect to assert failed. Add assert to knwon_hosts failed.": [
    null,
    "连接资产失败，添加资产信息到known_hosts失败"
   ],
   "Connect to assert failed. Make sure ssh is opening.": [
    null,
    "连接资产失败，请确保对端已经开启ssh"
   ],   
   "Connection refuesd. Make sure authentication is valid.": [
    null,
    "连接被拒绝，请确保认证方式有效"
   ],
   "Add assert failed. Unknown error.": [
    null,
    "添加资产失败，未知错误"
   ],
   "Adding...": [
    null,
    "添加中，请等待..."
   ],
   "Get rules info failed: ": [
    null,
    "获取规则信息失败："
   ],
   "Get rules info failed": [
    null,
    "获取规则信息失败"
   ],
   "No rules on this assert": [
    null,
    "没有应用到该资产的规则"
   ],
   "Downloading": [
    null,
    "下发中"
   ],
   "Are you sure delete assert ": [
    null,
    "是否要删除资产 "
   ],
   "Localhost cannot delete": [
    null,
    "本机资产不允许删除"
   ],
   
   
   
   
}));
